/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 19 "basicParse.y"


#ifdef __cplusplus
	extern "C" {
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "../ByteCodes.h"
#include "../CompileErrors.h"

#define SYMTABLESIZE 2000
#define IFTABLESIZE 1000

extern int yylex();
extern char *yytext;
int yyerror(const char *);
int errorcode;
extern int column;
extern int linenumber;

char *byteCode = NULL;
unsigned int byteOffset = 0;
unsigned int lastLineOffset = 0; // store the byte offset for the end of the last line - use in loops
unsigned int oldByteOffset = 0;
unsigned int listlen = 0;

int functionDefSymbol = -1;	// if in a function definition (what is the symbol number) -1 = not in fundef
int subroutineDefSymbol = -1;	// if in a subroutine definition (what is the symbol number) -1 = not in fundef

struct label
{
	char *name;
	int offset;
};

char *EMPTYSTR = "";
char *symtable[SYMTABLESIZE];
int labeltable[SYMTABLESIZE];
int numsyms = 0;
int numlabels = 0;
unsigned int maxbyteoffset = 0;

// array to hold stack of if statement branch locations
// that need to have final jump location added to them
// the iftable is also used by for, subroutine, and function to insure
// that no if,do,while,... is nested incorrectly
unsigned int iftable[IFTABLESIZE];
unsigned int iftablesourceline[IFTABLESIZE];
unsigned int iftabletype[IFTABLESIZE];
int numifs = 0;

#define IFTABLETYPEIF 1
#define IFTABLETYPEELSE 2
#define IFTABLETYPEDO 3
#define IFTABLETYPEWHILE 4
#define IFTABLETYPEFOR 5
#define IFTABLETYPEFUNCTION 6


// store the function variables here during a function definition
unsigned int args[100];
unsigned int argstype[100];
int numargs = 0;

#define ARGSTYPEINT 0
#define ARGSTYPESTR 1
#define ARGSTYPEVARREF 2
#define ARGSTYPEVARREFSTR 3

int
basicParse(char *);

void
clearIfTable() {
	int j;
	for (j = 0; j < IFTABLESIZE; j++) {
		iftable[j] = -1;
		iftablesourceline[j] = -1;
		iftabletype[j] = -1;
	}
	numifs = 0;
}

int testIfOnTable() {
	// return line number if there is an unfinished while.do.if.else
	// or send back -1
	if (numifs >=1 ) {
		return iftablesourceline[numifs-1];
	}	
	return -1;
}

int testIfOnTableError() {
	// return Error number if there is an unfinished while.do.if.else
	// or send back 0
	if (numifs >=1 ) {
		if (iftabletype[numifs-1]==IFTABLETYPEIF) return COMPERR_IFNOEND;
		if (iftabletype[numifs-1]==IFTABLETYPEELSE) return COMPERR_ELSENOEND;
		if (iftabletype[numifs-1]==IFTABLETYPEDO) return COMPERR_DONOEND;
		if (iftabletype[numifs-1]==IFTABLETYPEWHILE) return COMPERR_WHILENOEND;
		if (iftabletype[numifs-1]==IFTABLETYPEFOR) return COMPERR_FORNOEND;
		if (iftabletype[numifs-1]==IFTABLETYPEFUNCTION) return COMPERR_FUNCTIONNOEND;
	}	
	return 0;
}

void
clearLabelTable() {
	int j;
	for (j = 0; j < SYMTABLESIZE; j++) {
		labeltable[j] = -1;
	}
	numlabels = 0;
}

void
clearSymbolTable() {
	int j;
	if (numsyms == 0) {
		for (j = 0; j < SYMTABLESIZE; j++) {
			symtable[j] = 0;
		}
	}
	for (j = 0; j < numsyms; j++) {
		if (symtable[j]) {
			free(symtable[j]);
		}
		symtable[j] = 0;
	}
	numsyms = 0;
}

int
getSymbol(char *name) {
	int i;
	for (i = 0; i < numsyms; i++) {
		if (symtable[i] && !strcmp(name, symtable[i]))
			return i;
	}
	return -1;
}

int
newIf(int offset, int sourceline, int type) {
	iftable[numifs] = offset;
	iftablesourceline[numifs] = sourceline;
	iftabletype[numifs] = type;
	numifs++;
	return numifs - 1;
}

int
newSymbol(char *name) {
	symtable[numsyms] = name;
	numsyms++;
	return numsyms - 1;
}

int
newByteCode(unsigned int size) {
	if (byteCode) {
		free(byteCode);
	}
	maxbyteoffset = 1024;
	byteCode = malloc(maxbyteoffset);

	if (byteCode) {
		memset(byteCode, 0, maxbyteoffset);
		byteOffset = 0;
		return 0;
	}
	return -1;
}

void
checkByteMem(unsigned int addedbytes) {
	if (byteOffset + addedbytes + 1 >= maxbyteoffset) {
		maxbyteoffset += maxbyteoffset + addedbytes + 32;
		byteCode = realloc(byteCode, maxbyteoffset);
		memset(byteCode + byteOffset, 0, maxbyteoffset - byteOffset);
	}
}

void
addOp(char op) {
	checkByteMem(sizeof(char));
	byteCode[byteOffset] = op;
	byteOffset++;
}

void
addExtendedOp(char extop) {
	// ad an extended op WITHOUT an argument
	addOp(OP_EXTENDEDNONE);
	addOp(extop);
}

unsigned int
addInt(int data) {
	// add an integer to the bytecode at the current location
	// return starting location of the integer - so we can write to it later
	int *temp;
	unsigned int holdOffset = byteOffset;
	checkByteMem(sizeof(int));
	temp = (int *) (byteCode + byteOffset);
	*temp = data;
	byteOffset += sizeof(int);
	return holdOffset;
}

void
addString(char *data) {
	int len = strlen(data) + 1;
	checkByteMem(len+1);
	strncpy((char *) byteCode + byteOffset, data, len);
	byteOffset += len;
}

void
addIntOp(char op, int data) {
	int *temp = NULL;
	checkByteMem(sizeof(char) + sizeof(int));
	byteCode[byteOffset] = op;
	byteOffset++;

	temp = (int *) (byteCode + byteOffset);
	*temp = data;
	byteOffset += sizeof(int);
}

void
addInt2Op(char op, int data1, int data2) {
	int *temp = NULL;
	checkByteMem(sizeof(char) + 2 * sizeof(int));
	byteCode[byteOffset] = op;
	byteOffset++;

	temp = (int *) (byteCode + byteOffset);
	temp[0] = data1;
	temp[1] = data2;
	byteOffset += 2 * sizeof(int);
}

void
addFloatOp(char op, double data) {
	double *temp = NULL;
	checkByteMem(sizeof(char) + sizeof(double));
	byteCode[byteOffset] = op;
	byteOffset++;

	temp = (double *) (byteCode + byteOffset);
	*temp = data;
	byteOffset += sizeof(double);
}

void
addStringOp(char op, char *data) {
	addOp(op);
	addString(data);
}


#ifdef __cplusplus
}
#endif



/* Line 268 of yacc.c  */
#line 342 "basicParse.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     B256PRINT = 258,
     B256INPUT = 259,
     B256KEY = 260,
     B256PIXEL = 261,
     B256RGB = 262,
     B256PLOT = 263,
     B256CIRCLE = 264,
     B256RECT = 265,
     B256POLY = 266,
     B256STAMP = 267,
     B256LINE = 268,
     B256FASTGRAPHICS = 269,
     B256GRAPHSIZE = 270,
     B256REFRESH = 271,
     B256CLS = 272,
     B256CLG = 273,
     B256IF = 274,
     B256THEN = 275,
     B256ELSE = 276,
     B256ENDIF = 277,
     B256WHILE = 278,
     B256ENDWHILE = 279,
     B256DO = 280,
     B256UNTIL = 281,
     B256FOR = 282,
     B256TO = 283,
     B256STEP = 284,
     B256NEXT = 285,
     B256OPEN = 286,
     B256OPENB = 287,
     B256READ = 288,
     B256WRITE = 289,
     B256CLOSE = 290,
     B256RESET = 291,
     B256GOTO = 292,
     B256GOSUB = 293,
     B256RETURN = 294,
     B256REM = 295,
     B256END = 296,
     B256SETCOLOR = 297,
     B256GTE = 298,
     B256LTE = 299,
     B256NE = 300,
     B256DIM = 301,
     B256REDIM = 302,
     B256NOP = 303,
     B256TOINT = 304,
     B256TOSTRING = 305,
     B256LENGTH = 306,
     B256MID = 307,
     B256LEFT = 308,
     B256RIGHT = 309,
     B256UPPER = 310,
     B256LOWER = 311,
     B256INSTR = 312,
     B256INSTRX = 313,
     B256CEIL = 314,
     B256FLOOR = 315,
     B256RAND = 316,
     B256SIN = 317,
     B256COS = 318,
     B256TAN = 319,
     B256ASIN = 320,
     B256ACOS = 321,
     B256ATAN = 322,
     B256ABS = 323,
     B256PI = 324,
     B256DEGREES = 325,
     B256RADIANS = 326,
     B256LOG = 327,
     B256LOGTEN = 328,
     B256SQR = 329,
     B256EXP = 330,
     B256AND = 331,
     B256OR = 332,
     B256XOR = 333,
     B256NOT = 334,
     B256PAUSE = 335,
     B256SOUND = 336,
     B256ASC = 337,
     B256CHR = 338,
     B256TOFLOAT = 339,
     B256READLINE = 340,
     B256WRITELINE = 341,
     B256BOOLEOF = 342,
     B256MOD = 343,
     B256INTDIV = 344,
     B256YEAR = 345,
     B256MONTH = 346,
     B256DAY = 347,
     B256HOUR = 348,
     B256MINUTE = 349,
     B256SECOND = 350,
     B256TEXT = 351,
     B256FONT = 352,
     B256TEXTWIDTH = 353,
     B256SAY = 354,
     B256SYSTEM = 355,
     B256VOLUME = 356,
     B256GRAPHWIDTH = 357,
     B256GRAPHHEIGHT = 358,
     B256GETSLICE = 359,
     B256PUTSLICE = 360,
     B256IMGLOAD = 361,
     B256SPRITEDIM = 362,
     B256SPRITELOAD = 363,
     B256SPRITESLICE = 364,
     B256SPRITEMOVE = 365,
     B256SPRITEHIDE = 366,
     B256SPRITESHOW = 367,
     B256SPRITEPLACE = 368,
     B256SPRITECOLLIDE = 369,
     B256SPRITEX = 370,
     B256SPRITEY = 371,
     B256SPRITEH = 372,
     B256SPRITEW = 373,
     B256SPRITEV = 374,
     B256WAVPLAY = 375,
     B256WAVSTOP = 376,
     B256WAVWAIT = 377,
     B256SIZE = 378,
     B256SEEK = 379,
     B256EXISTS = 380,
     B256BOOLTRUE = 381,
     B256BOOLFALSE = 382,
     B256MOUSEX = 383,
     B256MOUSEY = 384,
     B256MOUSEB = 385,
     B256CLICKCLEAR = 386,
     B256CLICKX = 387,
     B256CLICKY = 388,
     B256CLICKB = 389,
     B256GETCOLOR = 390,
     B256CLEAR = 391,
     B256BLACK = 392,
     B256WHITE = 393,
     B256RED = 394,
     B256DARKRED = 395,
     B256GREEN = 396,
     B256DARKGREEN = 397,
     B256BLUE = 398,
     B256DARKBLUE = 399,
     B256CYAN = 400,
     B256DARKCYAN = 401,
     B256PURPLE = 402,
     B256DARKPURPLE = 403,
     B256YELLOW = 404,
     B256DARKYELLOW = 405,
     B256ORANGE = 406,
     B256DARKORANGE = 407,
     B256GREY = 408,
     B256DARKGREY = 409,
     B256CHANGEDIR = 410,
     B256CURRENTDIR = 411,
     B256DIR = 412,
     B256DECIMAL = 413,
     B256DBOPEN = 414,
     B256DBCLOSE = 415,
     B256DBEXECUTE = 416,
     B256DBOPENSET = 417,
     B256DBCLOSESET = 418,
     B256DBROW = 419,
     B256DBINT = 420,
     B256DBFLOAT = 421,
     B256DBSTRING = 422,
     B256ONERROR = 423,
     B256OFFERROR = 424,
     B256LASTERROR = 425,
     B256LASTERRORMESSAGE = 426,
     B256LASTERRORLINE = 427,
     B256LASTERROREXTRA = 428,
     B256NETLISTEN = 429,
     B256NETCONNECT = 430,
     B256NETREAD = 431,
     B256NETWRITE = 432,
     B256NETCLOSE = 433,
     B256NETDATA = 434,
     B256NETADDRESS = 435,
     B256KILL = 436,
     B256MD5 = 437,
     B256SETSETTING = 438,
     B256GETSETTING = 439,
     B256PORTIN = 440,
     B256PORTOUT = 441,
     B256BINARYOR = 442,
     B256BINARYAND = 443,
     B256BINARYNOT = 444,
     B256IMGSAVE = 445,
     B256REPLACE = 446,
     B256COUNT = 447,
     B256EXPLODE = 448,
     B256REPLACEX = 449,
     B256COUNTX = 450,
     B256EXPLODEX = 451,
     B256IMPLODE = 452,
     B256OSTYPE = 453,
     B256MSEC = 454,
     B256EDITVISIBLE = 455,
     B256GRAPHVISIBLE = 456,
     B256OUTPUTVISIBLE = 457,
     B256EDITSIZE = 458,
     B256OUTPUTSIZE = 459,
     B256FUNCTION = 460,
     B256ENDFUNCTION = 461,
     B256THROWERROR = 462,
     B256SUBROUTINE = 463,
     B256ENDSUBROUTINE = 464,
     B256CALL = 465,
     B256GLOBAL = 466,
     B256READBYTE = 467,
     B256WRITEBYTE = 468,
     B256ADD1 = 469,
     B256SUB1 = 470,
     B256ADDEQUAL = 471,
     B256SUBEQUAL = 472,
     B256MULEQUAL = 473,
     B256DIVEQUAL = 474,
     B256REF = 475,
     B256LINENUM = 476,
     B256INTEGER = 477,
     B256FLOAT = 478,
     B256STRING = 479,
     B256VARIABLE = 480,
     B256STRINGVAR = 481,
     B256NEWVAR = 482,
     B256COLOR = 483,
     B256LABEL = 484,
     B256UMINUS = 485
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 332 "basicParse.y"

	int number;
	double floatnum;
	char *string;



/* Line 293 of yacc.c  */
#line 616 "basicParse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 628 "basicParse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  445
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   21335

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  250
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  109
/* YYNRULES -- Number of rules.  */
#define YYNRULES  589
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1391

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   485

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     239,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     240,   241,   235,   234,   242,   233,     2,   236,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   243,   246,
     230,   232,   231,   249,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   244,     2,   245,   238,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   247,     2,   248,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   237
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,    10,    13,    15,    17,    19,    21,
      23,    25,    27,    29,    31,    33,    35,    37,    39,    41,
      43,    44,    48,    52,    56,    59,    63,    65,    67,    72,
      77,    81,    83,    86,    88,    90,    93,    95,    99,   102,
     104,   106,   109,   111,   114,   116,   119,   121,   123,   126,
     128,   132,   134,   136,   138,   140,   142,   144,   146,   148,
     150,   152,   154,   156,   158,   160,   162,   164,   166,   168,
     170,   172,   174,   176,   178,   180,   182,   184,   186,   188,
     190,   192,   194,   196,   198,   200,   202,   204,   206,   208,
     210,   212,   214,   216,   218,   220,   222,   224,   226,   228,
     230,   232,   234,   236,   238,   240,   242,   244,   246,   248,
     250,   252,   254,   256,   258,   260,   262,   264,   266,   268,
     270,   272,   274,   276,   278,   280,   282,   286,   290,   298,
     306,   310,   314,   322,   330,   333,   336,   338,   340,   342,
     347,   354,   356,   358,   361,   368,   375,   384,   393,   397,
     406,   417,   426,   433,   442,   446,   453,   459,   465,   472,
     479,   486,   493,   502,   510,   518,   527,   536,   545,   554,
     558,   567,   578,   587,   594,   603,   607,   611,   615,   618,
     621,   625,   629,   633,   637,   641,   645,   649,   656,   665,
     668,   671,   674,   677,   682,   688,   690,   693,   695,   702,
     711,   714,   719,   722,   725,   732,   737,   742,   749,   758,
     769,   776,   785,   794,   805,   812,   821,   828,   837,   844,
     853,   856,   859,   862,   865,   868,   873,   876,   885,   896,
     905,   912,   921,   928,   939,   952,   963,   966,   973,   978,
     981,   988,   993,   996,  1003,  1008,  1011,  1018,  1023,  1026,
    1033,  1038,  1040,  1044,  1047,  1049,  1053,  1056,  1059,  1066,
    1071,  1075,  1082,  1086,  1093,  1096,  1102,  1110,  1113,  1119,
    1127,  1130,  1132,  1135,  1138,  1142,  1146,  1149,  1151,  1155,
    1157,  1161,  1168,  1177,  1186,  1197,  1204,  1213,  1222,  1233,
    1244,  1257,  1260,  1265,  1272,  1283,  1296,  1303,  1312,  1319,
    1328,  1331,  1334,  1336,  1340,  1343,  1346,  1349,  1351,  1355,
    1358,  1361,  1363,  1367,  1370,  1377,  1382,  1387,  1394,  1401,
    1410,  1413,  1420,  1425,  1427,  1431,  1434,  1437,  1444,  1451,
    1460,  1465,  1472,  1475,  1482,  1487,  1490,  1493,  1496,  1499,
    1503,  1507,  1509,  1513,  1515,  1519,  1521,  1523,  1527,  1531,
    1535,  1539,  1543,  1547,  1551,  1555,  1559,  1563,  1567,  1570,
    1573,  1577,  1581,  1585,  1588,  1592,  1596,  1600,  1604,  1608,
    1612,  1616,  1620,  1624,  1628,  1632,  1636,  1638,  1640,  1645,
    1650,  1656,  1662,  1668,  1674,  1679,  1685,  1691,  1697,  1703,
    1710,  1718,  1726,  1734,  1742,  1747,  1751,  1753,  1756,  1759,
    1762,  1765,  1770,  1775,  1780,  1785,  1790,  1795,  1802,  1811,
    1822,  1829,  1838,  1843,  1848,  1853,  1858,  1863,  1868,  1873,
    1878,  1883,  1888,  1893,  1898,  1903,  1908,  1913,  1915,  1919,
    1921,  1925,  1927,  1931,  1933,  1937,  1939,  1943,  1948,  1953,
    1955,  1959,  1961,  1965,  1967,  1971,  1973,  1977,  1979,  1983,
    1985,  1989,  1991,  1995,  1997,  2001,  2003,  2007,  2012,  2014,
    2018,  2020,  2024,  2026,  2030,  2032,  2036,  2038,  2042,  2044,
    2048,  2050,  2054,  2056,  2060,  2062,  2066,  2068,  2072,  2074,
    2078,  2080,  2084,  2086,  2090,  2092,  2096,  2098,  2102,  2104,
    2108,  2110,  2114,  2116,  2120,  2122,  2126,  2128,  2132,  2134,
    2138,  2140,  2144,  2146,  2150,  2152,  2156,  2158,  2162,  2164,
    2168,  2175,  2184,  2186,  2190,  2197,  2202,  2207,  2212,  2217,
    2222,  2226,  2231,  2236,  2238,  2242,  2244,  2248,  2250,  2254,
    2259,  2264,  2271,  2280,  2287,  2289,  2293,  2295,  2299,  2304,
    2308,  2313,  2318,  2323,  2327,  2331,  2335,  2339,  2341,  2346,
    2353,  2358,  2362,  2364,  2369,  2374,  2379,  2384,  2393,  2400,
    2407,  2418,  2420,  2424,  2429,  2431,  2435,  2440,  2442,  2446,
    2451,  2453,  2457,  2459,  2463,  2465,  2469,  2474,  2476,  2480,
    2485,  2492,  2497,  2501,  2510,  2521,  2530,  2535,  2542,  2547
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     251,     0,    -1,   252,   239,    -1,   252,   239,   251,    -1,
     253,   254,    -1,   254,    -1,   229,    -1,   263,    -1,   264,
      -1,   265,    -1,   267,    -1,   268,    -1,   270,    -1,   271,
      -1,   272,    -1,   273,    -1,   255,    -1,   260,    -1,   256,
      -1,   262,    -1,    -1,   205,   225,   257,    -1,   205,   226,
     257,    -1,   208,   225,   257,    -1,   240,   241,    -1,   240,
     258,   241,    -1,   225,    -1,   226,    -1,   220,   240,   225,
     241,    -1,   220,   240,   226,   241,    -1,   258,   242,   258,
      -1,   206,    -1,    41,   205,    -1,   259,    -1,   209,    -1,
      41,   208,    -1,   261,    -1,   284,    20,   273,    -1,   284,
      20,    -1,    21,    -1,    22,    -1,    41,    19,    -1,   266,
      -1,    23,   357,    -1,    24,    -1,    41,    23,    -1,   269,
      -1,    25,    -1,    26,   357,    -1,   274,    -1,   273,   243,
     274,    -1,   291,    -1,   292,    -1,   293,    -1,   294,    -1,
     295,    -1,   296,    -1,   319,    -1,   299,    -1,   301,    -1,
     302,    -1,   308,    -1,   309,    -1,   300,    -1,   287,    -1,
     288,    -1,   289,    -1,   290,    -1,   297,    -1,   317,    -1,
     283,    -1,   279,    -1,   282,    -1,   280,    -1,   281,    -1,
     275,    -1,   276,    -1,   277,    -1,   286,    -1,   285,    -1,
     310,    -1,   311,    -1,   312,    -1,   313,    -1,   314,    -1,
     315,    -1,   344,    -1,   298,    -1,   303,    -1,   304,    -1,
     305,    -1,   306,    -1,   307,    -1,   320,    -1,   321,    -1,
     322,    -1,   323,    -1,   324,    -1,   325,    -1,   326,    -1,
     327,    -1,   328,    -1,   329,    -1,   330,    -1,   331,    -1,
     316,    -1,   332,    -1,   333,    -1,   334,    -1,   335,    -1,
     336,    -1,   337,    -1,   338,    -1,   339,    -1,   340,    -1,
     341,    -1,   342,    -1,   343,    -1,   345,    -1,   346,    -1,
     347,    -1,   348,    -1,   349,    -1,   350,    -1,   351,    -1,
     278,    -1,    46,   225,   357,    -1,    46,   226,   357,    -1,
      46,   225,   240,   357,   242,   357,   241,    -1,    46,   226,
     240,   357,   242,   357,   241,    -1,    47,   225,   357,    -1,
      47,   226,   357,    -1,    47,   225,   240,   357,   242,   357,
     241,    -1,    47,   226,   240,   357,   242,   357,   241,    -1,
      80,   357,    -1,   207,   357,    -1,    17,    -1,    18,    -1,
      14,    -1,    15,   357,   242,   357,    -1,    15,   240,   357,
     242,   357,   241,    -1,    16,    -1,    41,    -1,    19,   357,
      -1,   226,   244,   357,   245,   232,   358,    -1,   226,   244,
     357,   245,   216,   358,    -1,   226,   244,   357,   242,   357,
     245,   232,   358,    -1,   226,   244,   357,   242,   357,   245,
     216,   358,    -1,   226,   232,   352,    -1,   226,   232,   193,
     240,   358,   242,   358,   241,    -1,   226,   232,   193,   240,
     358,   242,   358,   242,   357,   241,    -1,   226,   232,   196,
     240,   358,   242,   358,   241,    -1,   226,   244,   357,   245,
     232,   357,    -1,   226,   244,   357,   242,   357,   245,   232,
     357,    -1,   226,   232,   353,    -1,   225,   244,   357,   245,
     232,   357,    -1,   225,   244,   357,   245,   214,    -1,   225,
     244,   357,   245,   215,    -1,   225,   244,   357,   245,   216,
     357,    -1,   225,   244,   357,   245,   217,   357,    -1,   225,
     244,   357,   245,   218,   357,    -1,   225,   244,   357,   245,
     219,   357,    -1,   225,   244,   357,   242,   357,   245,   232,
     357,    -1,   225,   244,   357,   242,   357,   245,   214,    -1,
     225,   244,   357,   242,   357,   245,   215,    -1,   225,   244,
     357,   242,   357,   245,   216,   357,    -1,   225,   244,   357,
     242,   357,   245,   217,   357,    -1,   225,   244,   357,   242,
     357,   245,   218,   357,    -1,   225,   244,   357,   242,   357,
     245,   219,   357,    -1,   225,   232,   353,    -1,   225,   232,
     193,   240,   358,   242,   358,   241,    -1,   225,   232,   193,
     240,   358,   242,   358,   242,   357,   241,    -1,   225,   232,
     196,   240,   358,   242,   358,   241,    -1,   225,   244,   357,
     245,   232,   358,    -1,   225,   244,   357,   242,   357,   245,
     232,   358,    -1,   225,   232,   352,    -1,   225,   232,   357,
      -1,   225,   232,   358,    -1,   225,   214,    -1,   225,   215,
      -1,   225,   216,   357,    -1,   225,   217,   357,    -1,   225,
     218,   357,    -1,   225,   219,   357,    -1,   226,   232,   358,
      -1,   226,   232,   357,    -1,   226,   216,   358,    -1,    27,
     225,   232,   357,    28,   357,    -1,    27,   225,   232,   357,
      28,   357,    29,   357,    -1,    30,   225,    -1,    37,   225,
      -1,    38,   225,    -1,   210,   225,    -1,   210,   225,   240,
     241,    -1,   210,   225,   240,   356,   241,    -1,   169,    -1,
     168,   225,    -1,    39,    -1,    42,   357,   242,   357,   242,
     357,    -1,    42,   240,   357,   242,   357,   242,   357,   241,
      -1,    42,   357,    -1,    81,   240,   225,   241,    -1,    81,
     225,    -1,    81,   353,    -1,    81,   240,   357,   242,   357,
     241,    -1,    81,   357,   242,   357,    -1,     8,   357,   242,
     357,    -1,     8,   240,   357,   242,   357,   241,    -1,    13,
     357,   242,   357,   242,   357,   242,   357,    -1,    13,   240,
     357,   242,   357,   242,   357,   242,   357,   241,    -1,     9,
     357,   242,   357,   242,   357,    -1,     9,   240,   357,   242,
     357,   242,   357,   241,    -1,    10,   357,   242,   357,   242,
     357,   242,   357,    -1,    10,   240,   357,   242,   357,   242,
     357,   242,   357,   241,    -1,    96,   357,   242,   357,   242,
     358,    -1,    96,   240,   357,   242,   357,   242,   358,   241,
      -1,    96,   357,   242,   357,   242,   357,    -1,    96,   240,
     357,   242,   357,   242,   357,   241,    -1,    97,   358,   242,
     357,   242,   357,    -1,    97,   240,   358,   242,   357,   242,
     357,   241,    -1,    99,   358,    -1,    99,   357,    -1,   100,
     358,    -1,   101,   357,    -1,    11,   225,    -1,    11,   240,
     225,   241,    -1,    11,   353,    -1,    12,   357,   242,   357,
     242,   357,   242,   225,    -1,    12,   240,   357,   242,   357,
     242,   357,   242,   225,   241,    -1,    12,   357,   242,   357,
     242,   357,   242,   353,    -1,    12,   357,   242,   357,   242,
     225,    -1,    12,   240,   357,   242,   357,   242,   225,   241,
      -1,    12,   357,   242,   357,   242,   353,    -1,    12,   357,
     242,   357,   242,   357,   242,   357,   242,   225,    -1,    12,
     240,   357,   242,   357,   242,   357,   242,   357,   242,   225,
     241,    -1,    12,   357,   242,   357,   242,   357,   242,   357,
     242,   353,    -1,    31,   358,    -1,    31,   240,   357,   242,
     358,   241,    -1,    31,   357,   242,   358,    -1,    32,   358,
      -1,    32,   240,   357,   242,   358,   241,    -1,    32,   357,
     242,   358,    -1,    34,   358,    -1,    34,   240,   357,   242,
     358,   241,    -1,    34,   357,   242,   358,    -1,    86,   358,
      -1,    86,   240,   357,   242,   358,   241,    -1,    86,   357,
     242,   358,    -1,   213,   357,    -1,   213,   240,   357,   242,
     357,   241,    -1,   213,   357,   242,   357,    -1,    35,    -1,
      35,   240,   241,    -1,    35,   357,    -1,    36,    -1,    36,
     240,   241,    -1,    36,   357,    -1,   124,   357,    -1,   124,
     240,   357,   242,   357,   241,    -1,   124,   357,   242,   357,
      -1,   318,   242,   226,    -1,   318,   242,   226,   244,   357,
     245,    -1,   318,   242,   225,    -1,   318,   242,   225,   244,
     357,   245,    -1,     4,   226,    -1,     4,   226,   244,   357,
     245,    -1,     4,   226,   244,   357,   242,   357,   245,    -1,
       4,   225,    -1,     4,   225,   244,   357,   245,    -1,     4,
     225,   244,   357,   242,   357,   245,    -1,     4,   358,    -1,
       3,    -1,     3,   358,    -1,     3,   357,    -1,     3,   358,
     246,    -1,     3,   357,   246,    -1,   120,   358,    -1,   121,
      -1,   121,   240,   241,    -1,   122,    -1,   122,   240,   241,
      -1,   105,   357,   242,   357,   242,   358,    -1,   105,   240,
     357,   242,   357,   242,   358,   241,    -1,   105,   357,   242,
     357,   242,   358,   242,   357,    -1,   105,   240,   357,   242,
     357,   242,   358,   242,   357,   241,    -1,   106,   357,   242,
     357,   242,   358,    -1,   106,   240,   357,   242,   357,   242,
     358,   241,    -1,   106,   357,   242,   357,   242,   357,   242,
     358,    -1,   106,   240,   357,   242,   357,   242,   357,   242,
     358,   241,    -1,   106,   357,   242,   357,   242,   357,   242,
     357,   242,   358,    -1,   106,   240,   357,   242,   357,   242,
     357,   242,   357,   242,   358,   241,    -1,   107,   357,    -1,
     108,   357,   242,   358,    -1,   108,   240,   357,   242,   358,
     241,    -1,   109,   357,   242,   357,   242,   357,   242,   357,
     242,   357,    -1,   109,   240,   357,   242,   357,   242,   357,
     242,   357,   242,   357,   241,    -1,   113,   357,   242,   357,
     242,   357,    -1,   113,   240,   357,   242,   357,   242,   357,
     241,    -1,   110,   357,   242,   357,   242,   357,    -1,   108,
     240,   357,   242,   357,   242,   357,   241,    -1,   111,   357,
      -1,   112,   357,    -1,   131,    -1,   131,   240,   241,    -1,
     155,   358,    -1,   158,   357,    -1,   159,   358,    -1,   160,
      -1,   160,   240,   241,    -1,   161,   358,    -1,   162,   358,
      -1,   163,    -1,   163,   240,   241,    -1,   174,   357,    -1,
     174,   240,   357,   242,   357,   241,    -1,   174,   357,   242,
     357,    -1,   175,   358,   242,   357,    -1,   175,   240,   358,
     242,   357,   241,    -1,   175,   357,   242,   358,   242,   357,
      -1,   175,   240,   357,   242,   358,   242,   357,   241,    -1,
     177,   358,    -1,   177,   240,   357,   242,   358,   241,    -1,
     177,   357,   242,   358,    -1,   178,    -1,   178,   240,   241,
      -1,   178,   357,    -1,   181,   358,    -1,   181,   240,   357,
     242,   358,   241,    -1,   183,   358,   242,   358,   242,   358,
      -1,   183,   240,   358,   242,   358,   242,   358,   241,    -1,
     186,   357,   242,   357,    -1,   186,   240,   357,   242,   357,
     241,    -1,   190,   358,    -1,   190,   240,   358,   242,   358,
     241,    -1,   190,   358,   242,   358,    -1,   200,   357,    -1,
     201,   357,    -1,   202,   357,    -1,   211,   258,    -1,   247,
     355,   248,    -1,   247,   354,   248,    -1,   357,    -1,   357,
     242,   354,    -1,   358,    -1,   358,   242,   355,    -1,   357,
      -1,   358,    -1,   356,   242,   356,    -1,   240,   357,   241,
      -1,   357,   234,   357,    -1,   357,   233,   357,    -1,   357,
     235,   357,    -1,   357,    88,   357,    -1,   357,    89,   357,
      -1,   357,   236,   357,    -1,   357,   238,   357,    -1,   357,
     187,   357,    -1,   357,   188,   357,    -1,   189,   357,    -1,
     233,   357,    -1,   357,    76,   357,    -1,   357,    77,   357,
      -1,   357,    78,   357,    -1,    79,   357,    -1,   358,   232,
     358,    -1,   358,    45,   358,    -1,   358,   230,   358,    -1,
     358,   231,   358,    -1,   358,    43,   358,    -1,   358,    44,
     358,    -1,   357,   232,   357,    -1,   357,    45,   357,    -1,
     357,   230,   357,    -1,   357,   231,   357,    -1,   357,    43,
     357,    -1,   357,    44,   357,    -1,   223,    -1,   222,    -1,
     225,   244,   249,   245,    -1,   226,   244,   249,   245,    -1,
     225,   244,   249,   242,   245,    -1,   226,   244,   249,   242,
     245,    -1,   225,   244,   242,   249,   245,    -1,   226,   244,
     242,   249,   245,    -1,   225,   244,   357,   245,    -1,   225,
     244,   357,   245,   214,    -1,   225,   244,   357,   245,   215,
      -1,   214,   225,   244,   357,   245,    -1,   215,   225,   244,
     357,   245,    -1,   225,   244,   357,   242,   357,   245,    -1,
     225,   244,   357,   242,   357,   245,   214,    -1,   225,   244,
     357,   242,   357,   245,   215,    -1,   214,   225,   244,   357,
     242,   357,   245,    -1,   215,   225,   244,   357,   242,   357,
     245,    -1,   225,   240,   356,   241,    -1,   225,   240,   241,
      -1,   225,    -1,   225,   214,    -1,   225,   215,    -1,   214,
     225,    -1,   215,   225,    -1,    49,   240,   357,   241,    -1,
      49,   240,   358,   241,    -1,    84,   240,   357,   241,    -1,
      84,   240,   358,   241,    -1,    51,   240,   358,   241,    -1,
      82,   240,   358,   241,    -1,    57,   240,   358,   242,   358,
     241,    -1,    57,   240,   358,   242,   358,   242,   357,   241,
      -1,    57,   240,   358,   242,   358,   242,   357,   242,   357,
     241,    -1,    58,   240,   358,   242,   358,   241,    -1,    58,
     240,   358,   242,   358,   242,   357,   241,    -1,    59,   240,
     357,   241,    -1,    60,   240,   357,   241,    -1,    62,   240,
     357,   241,    -1,    63,   240,   357,   241,    -1,    64,   240,
     357,   241,    -1,    65,   240,   357,   241,    -1,    66,   240,
     357,   241,    -1,    67,   240,   357,   241,    -1,    70,   240,
     357,   241,    -1,    71,   240,   357,   241,    -1,    72,   240,
     357,   241,    -1,    73,   240,   357,   241,    -1,    74,   240,
     357,   241,    -1,    75,   240,   357,   241,    -1,    68,   240,
     357,   241,    -1,    61,    -1,    61,   240,   241,    -1,    69,
      -1,    69,   240,   241,    -1,   126,    -1,   126,   240,   241,
      -1,   127,    -1,   127,   240,   241,    -1,    87,    -1,    87,
     240,   241,    -1,    87,   240,   357,   241,    -1,   125,   240,
     358,   241,    -1,    90,    -1,    90,   240,   241,    -1,    91,
      -1,    91,   240,   241,    -1,    92,    -1,    92,   240,   241,
      -1,    93,    -1,    93,   240,   241,    -1,    94,    -1,    94,
     240,   241,    -1,    95,    -1,    95,   240,   241,    -1,   102,
      -1,   102,   240,   241,    -1,   103,    -1,   103,   240,   241,
      -1,   123,    -1,   123,   240,   241,    -1,   123,   240,   357,
     241,    -1,     5,    -1,     5,   240,   241,    -1,   128,    -1,
     128,   240,   241,    -1,   129,    -1,   129,   240,   241,    -1,
     130,    -1,   130,   240,   241,    -1,   132,    -1,   132,   240,
     241,    -1,   133,    -1,   133,   240,   241,    -1,   134,    -1,
     134,   240,   241,    -1,   136,    -1,   136,   240,   241,    -1,
     137,    -1,   137,   240,   241,    -1,   138,    -1,   138,   240,
     241,    -1,   139,    -1,   139,   240,   241,    -1,   140,    -1,
     140,   240,   241,    -1,   141,    -1,   141,   240,   241,    -1,
     142,    -1,   142,   240,   241,    -1,   143,    -1,   143,   240,
     241,    -1,   144,    -1,   144,   240,   241,    -1,   145,    -1,
     145,   240,   241,    -1,   146,    -1,   146,   240,   241,    -1,
     147,    -1,   147,   240,   241,    -1,   148,    -1,   148,   240,
     241,    -1,   149,    -1,   149,   240,   241,    -1,   150,    -1,
     150,   240,   241,    -1,   151,    -1,   151,   240,   241,    -1,
     152,    -1,   152,   240,   241,    -1,   153,    -1,   153,   240,
     241,    -1,   154,    -1,   154,   240,   241,    -1,     6,   240,
     357,   242,   357,   241,    -1,     7,   240,   357,   242,   357,
     242,   357,   241,    -1,   135,    -1,   135,   240,   241,    -1,
     114,   240,   357,   242,   357,   241,    -1,   115,   240,   357,
     241,    -1,   116,   240,   357,   241,    -1,   117,   240,   357,
     241,    -1,   118,   240,   357,   241,    -1,   119,   240,   357,
     241,    -1,   164,   240,   241,    -1,   165,   240,   357,   241,
      -1,   166,   240,   357,   241,    -1,   170,    -1,   170,   240,
     241,    -1,   172,    -1,   172,   240,   241,    -1,   179,    -1,
     179,   240,   241,    -1,   179,   240,   357,   241,    -1,   185,
     240,   357,   241,    -1,   192,   240,   358,   242,   358,   241,
      -1,   192,   240,   358,   242,   358,   242,   357,   241,    -1,
     195,   240,   358,   242,   358,   241,    -1,   198,    -1,   198,
     240,   241,    -1,   199,    -1,   199,   240,   241,    -1,    98,
     240,   358,   241,    -1,   212,   240,   241,    -1,   212,   240,
     357,   241,    -1,   220,   240,   225,   241,    -1,   220,   240,
     226,   241,    -1,   240,   358,   241,    -1,   358,   234,   358,
      -1,   357,   234,   358,    -1,   358,   234,   357,    -1,   224,
      -1,   226,   244,   357,   245,    -1,   226,   244,   357,   242,
     357,   245,    -1,   226,   240,   356,   241,    -1,   226,   240,
     241,    -1,   226,    -1,    83,   240,   357,   241,    -1,    50,
     240,   357,   241,    -1,    55,   240,   358,   241,    -1,    56,
     240,   358,   241,    -1,    52,   240,   358,   242,   357,   242,
     357,   241,    -1,    53,   240,   358,   242,   357,   241,    -1,
      54,   240,   358,   242,   357,   241,    -1,   104,   240,   357,
     242,   357,   242,   357,   242,   357,   241,    -1,    33,    -1,
      33,   240,   241,    -1,    33,   240,   357,   241,    -1,    85,
      -1,    85,   240,   241,    -1,    85,   240,   357,   241,    -1,
     156,    -1,   156,   240,   241,    -1,   167,   240,   357,   241,
      -1,   171,    -1,   171,   240,   241,    -1,   173,    -1,   173,
     240,   241,    -1,   176,    -1,   176,   240,   241,    -1,   176,
     240,   357,   241,    -1,   180,    -1,   180,   240,   241,    -1,
     182,   240,   358,   241,    -1,   184,   240,   358,   242,   358,
     241,    -1,   157,   240,   358,   241,    -1,   157,   240,   241,
      -1,   191,   240,   358,   242,   358,   242,   358,   241,    -1,
     191,   240,   358,   242,   358,   242,   358,   242,   357,   241,
      -1,   194,   240,   358,   242,   358,   242,   358,   241,    -1,
     197,   240,   226,   241,    -1,   197,   240,   226,   242,   358,
     241,    -1,   197,   240,   225,   241,    -1,   197,   240,   225,
     242,   358,   241,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   364,   364,   365,   368,   369,   372,   383,   384,   385,
     386,   387,   393,   394,   400,   401,   402,   403,   404,   405,
     407,   410,   440,   470,   498,   498,   502,   506,   510,   514,
     518,   522,   522,   525,   545,   545,   547,   566,   580,   586,
     614,   615,   617,   640,   652,   653,   655,   681,   687,   706,
     706,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,   756,   757,
     758,   759,   760,   761,   762,   763,   764,   765,   766,   767,
     768,   769,   770,   771,   772,   773,   774,   775,   776,   777,
     778,   779,   780,   781,   782,   783,   786,   790,   794,   795,
     798,   802,   806,   807,   810,   813,   816,   817,   820,   823,
     824,   827,   830,   833,   846,   847,   857,   858,   870,   874,
     875,   876,   877,   882,   887,   894,   897,   905,   913,   923,
     933,   943,   953,   956,   963,   970,   980,   991,  1001,  1012,
    1016,  1019,  1022,  1025,  1030,  1035,  1044,  1045,  1050,  1056,
    1062,  1067,  1073,  1078,  1087,  1088,  1093,  1101,  1110,  1120,
    1138,  1147,  1156,  1157,  1158,  1161,  1164,  1167,  1181,  1182,
    1183,  1186,  1187,  1188,  1189,  1190,  1193,  1194,  1197,  1198,
    1202,  1203,  1206,  1207,  1210,  1211,  1212,  1213,  1216,  1217,
    1220,  1221,  1224,  1227,  1230,  1231,  1232,  1235,  1236,  1237,
    1238,  1239,  1240,  1241,  1242,  1243,  1246,  1247,  1248,  1249,
    1250,  1251,  1254,  1255,  1256,  1259,  1260,  1261,  1264,  1265,
    1266,  1269,  1270,  1271,  1274,  1275,  1276,  1279,  1280,  1281,
    1284,  1285,  1286,  1287,  1288,  1289,  1290,  1291,  1292,  1293,
    1296,  1299,  1300,  1301,  1302,  1303,  1306,  1309,  1310,  1313,
    1314,  1317,  1318,  1319,  1320,  1322,  1323,  1324,  1325,  1326,
    1327,  1330,  1333,  1334,  1337,  1338,  1341,  1342,  1345,  1346,
    1349,  1352,  1355,  1356,  1359,  1362,  1365,  1368,  1369,  1372,
    1375,  1378,  1379,  1382,  1383,  1384,  1387,  1388,  1389,  1390,
    1393,  1394,  1395,  1398,  1399,  1400,  1403,  1404,  1407,  1408,
    1411,  1412,  1415,  1416,  1417,  1420,  1423,  1426,  1429,  1445,
    1448,  1451,  1452,  1455,  1456,  1459,  1460,  1461,  1465,  1466,
    1467,  1468,  1469,  1470,  1471,  1472,  1473,  1474,  1475,  1476,
    1477,  1478,  1479,  1480,  1481,  1482,  1483,  1484,  1485,  1486,
    1487,  1488,  1489,  1490,  1491,  1492,  1493,  1494,  1495,  1496,
    1497,  1498,  1499,  1500,  1501,  1502,  1513,  1524,  1534,  1544,
    1545,  1556,  1567,  1577,  1587,  1591,  1595,  1602,  1609,  1616,
    1623,  1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,
    1639,  1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,
    1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,
    1659,  1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,
    1669,  1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,
    1679,  1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,
    1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,
    1699,  1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,
    1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,
    1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,
    1729,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,
    1739,  1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,
    1749,  1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,
    1759,  1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,
    1769,  1770,  1771,  1777,  1778,  1779,  1780,  1781,  1782,  1783,
    1784,  1785,  1786,  1794,  1795,  1796,  1797,  1798,  1799,  1800,
    1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,  1810,
    1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,  1820,
    1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,  1830
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "B256PRINT", "B256INPUT", "B256KEY",
  "B256PIXEL", "B256RGB", "B256PLOT", "B256CIRCLE", "B256RECT", "B256POLY",
  "B256STAMP", "B256LINE", "B256FASTGRAPHICS", "B256GRAPHSIZE",
  "B256REFRESH", "B256CLS", "B256CLG", "B256IF", "B256THEN", "B256ELSE",
  "B256ENDIF", "B256WHILE", "B256ENDWHILE", "B256DO", "B256UNTIL",
  "B256FOR", "B256TO", "B256STEP", "B256NEXT", "B256OPEN", "B256OPENB",
  "B256READ", "B256WRITE", "B256CLOSE", "B256RESET", "B256GOTO",
  "B256GOSUB", "B256RETURN", "B256REM", "B256END", "B256SETCOLOR",
  "B256GTE", "B256LTE", "B256NE", "B256DIM", "B256REDIM", "B256NOP",
  "B256TOINT", "B256TOSTRING", "B256LENGTH", "B256MID", "B256LEFT",
  "B256RIGHT", "B256UPPER", "B256LOWER", "B256INSTR", "B256INSTRX",
  "B256CEIL", "B256FLOOR", "B256RAND", "B256SIN", "B256COS", "B256TAN",
  "B256ASIN", "B256ACOS", "B256ATAN", "B256ABS", "B256PI", "B256DEGREES",
  "B256RADIANS", "B256LOG", "B256LOGTEN", "B256SQR", "B256EXP", "B256AND",
  "B256OR", "B256XOR", "B256NOT", "B256PAUSE", "B256SOUND", "B256ASC",
  "B256CHR", "B256TOFLOAT", "B256READLINE", "B256WRITELINE", "B256BOOLEOF",
  "B256MOD", "B256INTDIV", "B256YEAR", "B256MONTH", "B256DAY", "B256HOUR",
  "B256MINUTE", "B256SECOND", "B256TEXT", "B256FONT", "B256TEXTWIDTH",
  "B256SAY", "B256SYSTEM", "B256VOLUME", "B256GRAPHWIDTH",
  "B256GRAPHHEIGHT", "B256GETSLICE", "B256PUTSLICE", "B256IMGLOAD",
  "B256SPRITEDIM", "B256SPRITELOAD", "B256SPRITESLICE", "B256SPRITEMOVE",
  "B256SPRITEHIDE", "B256SPRITESHOW", "B256SPRITEPLACE",
  "B256SPRITECOLLIDE", "B256SPRITEX", "B256SPRITEY", "B256SPRITEH",
  "B256SPRITEW", "B256SPRITEV", "B256WAVPLAY", "B256WAVSTOP",
  "B256WAVWAIT", "B256SIZE", "B256SEEK", "B256EXISTS", "B256BOOLTRUE",
  "B256BOOLFALSE", "B256MOUSEX", "B256MOUSEY", "B256MOUSEB",
  "B256CLICKCLEAR", "B256CLICKX", "B256CLICKY", "B256CLICKB",
  "B256GETCOLOR", "B256CLEAR", "B256BLACK", "B256WHITE", "B256RED",
  "B256DARKRED", "B256GREEN", "B256DARKGREEN", "B256BLUE", "B256DARKBLUE",
  "B256CYAN", "B256DARKCYAN", "B256PURPLE", "B256DARKPURPLE", "B256YELLOW",
  "B256DARKYELLOW", "B256ORANGE", "B256DARKORANGE", "B256GREY",
  "B256DARKGREY", "B256CHANGEDIR", "B256CURRENTDIR", "B256DIR",
  "B256DECIMAL", "B256DBOPEN", "B256DBCLOSE", "B256DBEXECUTE",
  "B256DBOPENSET", "B256DBCLOSESET", "B256DBROW", "B256DBINT",
  "B256DBFLOAT", "B256DBSTRING", "B256ONERROR", "B256OFFERROR",
  "B256LASTERROR", "B256LASTERRORMESSAGE", "B256LASTERRORLINE",
  "B256LASTERROREXTRA", "B256NETLISTEN", "B256NETCONNECT", "B256NETREAD",
  "B256NETWRITE", "B256NETCLOSE", "B256NETDATA", "B256NETADDRESS",
  "B256KILL", "B256MD5", "B256SETSETTING", "B256GETSETTING", "B256PORTIN",
  "B256PORTOUT", "B256BINARYOR", "B256BINARYAND", "B256BINARYNOT",
  "B256IMGSAVE", "B256REPLACE", "B256COUNT", "B256EXPLODE", "B256REPLACEX",
  "B256COUNTX", "B256EXPLODEX", "B256IMPLODE", "B256OSTYPE", "B256MSEC",
  "B256EDITVISIBLE", "B256GRAPHVISIBLE", "B256OUTPUTVISIBLE",
  "B256EDITSIZE", "B256OUTPUTSIZE", "B256FUNCTION", "B256ENDFUNCTION",
  "B256THROWERROR", "B256SUBROUTINE", "B256ENDSUBROUTINE", "B256CALL",
  "B256GLOBAL", "B256READBYTE", "B256WRITEBYTE", "B256ADD1", "B256SUB1",
  "B256ADDEQUAL", "B256SUBEQUAL", "B256MULEQUAL", "B256DIVEQUAL",
  "B256REF", "B256LINENUM", "B256INTEGER", "B256FLOAT", "B256STRING",
  "B256VARIABLE", "B256STRINGVAR", "B256NEWVAR", "B256COLOR", "B256LABEL",
  "'<'", "'>'", "'='", "'-'", "'+'", "'*'", "'/'", "B256UMINUS", "'^'",
  "'\\n'", "'('", "')'", "','", "':'", "'['", "']'", "';'", "'{'", "'}'",
  "'?'", "$accept", "program", "validline", "label", "validstatement",
  "functionstmt", "subroutinestmt", "functionvariablelist",
  "functionvariables", "endfunctionexpr", "endfunctionstmt",
  "endsubroutineexpr", "endsubroutinestmt", "compoundifstmt", "ifstmt",
  "elsestmt", "endifexpr", "endifstmt", "whilestmt", "endwhileexpr",
  "endwhilestmt", "dostmt", "untilstmt", "compoundstmt", "statement",
  "dimstmt", "redimstmt", "pausestmt", "throwerrorstmt", "clearstmt",
  "fastgraphicsstmt", "graphsizestmt", "refreshstmt", "endstmt", "ifexpr",
  "strarrayassign", "arrayassign", "numassign", "stringassign", "forstmt",
  "nextstmt", "gotostmt", "gosubstmt", "callstmt", "offerrorstmt",
  "onerrorstmt", "returnstmt", "colorstmt", "soundstmt", "plotstmt",
  "linestmt", "circlestmt", "rectstmt", "textstmt", "fontstmt", "saystmt",
  "systemstmt", "volumestmt", "polystmt", "stampstmt", "openstmt",
  "writestmt", "writelinestmt", "writebytestmt", "closestmt", "resetstmt",
  "seekstmt", "inputstmt", "inputexpr", "printstmt", "wavplaystmt",
  "wavstopstmt", "wavwaitstmt", "putslicestmt", "imgloadstmt",
  "spritedimstmt", "spriteloadstmt", "spriteslicestmt", "spriteplacestmt",
  "spritemovestmt", "spritehidestmt", "spriteshowstmt", "clickclearstmt",
  "changedirstmt", "decimalstmt", "dbopenstmt", "dbclosestmt",
  "dbexecutestmt", "dbopensetstmt", "dbclosesetstmt", "netlistenstmt",
  "netconnectstmt", "netwritestmt", "netclosestmt", "killstmt",
  "setsettingstmt", "portoutstmt", "imgsavestmt", "editvisiblestmt",
  "graphvisiblestmt", "outputvisiblestmt", "globalstmt",
  "immediatestrlist", "immediatelist", "floatlist", "stringlist",
  "explist", "floatexpr", "stringexpr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
      60,    62,    61,    45,    43,    42,    47,   485,    94,    10,
      40,    41,    44,    58,    91,    93,    59,   123,   125,    63
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   250,   251,   251,   252,   252,   253,   254,   254,   254,
     254,   254,   254,   254,   254,   254,   254,   254,   254,   254,
     254,   255,   255,   256,   257,   257,   258,   258,   258,   258,
     258,   259,   259,   260,   261,   261,   262,   263,   264,   265,
     266,   266,   267,   268,   269,   269,   270,   271,   272,   273,
     273,   274,   274,   274,   274,   274,   274,   274,   274,   274,
     274,   274,   274,   274,   274,   274,   274,   274,   274,   274,
     274,   274,   274,   274,   274,   274,   274,   274,   274,   274,
     274,   274,   274,   274,   274,   274,   274,   274,   274,   274,
     274,   274,   274,   274,   274,   274,   274,   274,   274,   274,
     274,   274,   274,   274,   274,   274,   274,   274,   274,   274,
     274,   274,   274,   274,   274,   274,   274,   274,   274,   274,
     274,   274,   274,   274,   274,   274,   275,   275,   275,   275,
     276,   276,   276,   276,   277,   278,   279,   279,   280,   281,
     281,   282,   283,   284,   285,   285,   285,   285,   285,   285,
     285,   285,   285,   285,   285,   286,   286,   286,   286,   286,
     286,   286,   286,   286,   286,   286,   286,   286,   286,   286,
     286,   286,   286,   286,   286,   286,   287,   287,   287,   287,
     287,   287,   287,   287,   288,   288,   288,   289,   289,   290,
     291,   292,   293,   293,   293,   294,   295,   296,   297,   297,
     297,   298,   298,   298,   298,   298,   299,   299,   300,   300,
     301,   301,   302,   302,   303,   303,   303,   303,   304,   304,
     305,   305,   306,   307,   308,   308,   308,   309,   309,   309,
     309,   309,   309,   309,   309,   309,   310,   310,   310,   310,
     310,   310,   311,   311,   311,   312,   312,   312,   313,   313,
     313,   314,   314,   314,   315,   315,   315,   316,   316,   316,
     317,   317,   317,   317,   317,   317,   317,   317,   317,   317,
     318,   319,   319,   319,   319,   319,   320,   321,   321,   322,
     322,   323,   323,   323,   323,   324,   324,   324,   324,   324,
     324,   325,   326,   326,   327,   327,   328,   328,   329,   329,
     330,   331,   332,   332,   333,   334,   335,   336,   336,   337,
     338,   339,   339,   340,   340,   340,   341,   341,   341,   341,
     342,   342,   342,   343,   343,   343,   344,   344,   345,   345,
     346,   346,   347,   347,   347,   348,   349,   350,   351,   352,
     353,   354,   354,   355,   355,   356,   356,   356,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   357,   358,   358,   358,   358,   358,   358,   358,
     358,   358,   358,   358,   358,   358,   358,   358,   358,   358,
     358,   358,   358,   358,   358,   358,   358,   358,   358,   358,
     358,   358,   358,   358,   358,   358,   358,   358,   358,   358,
     358,   358,   358,   358,   358,   358,   358,   358,   358,   358
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     3,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     3,     3,     3,     2,     3,     1,     1,     4,     4,
       3,     1,     2,     1,     1,     2,     1,     3,     2,     1,
       1,     2,     1,     2,     1,     2,     1,     1,     2,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     7,     7,
       3,     3,     7,     7,     2,     2,     1,     1,     1,     4,
       6,     1,     1,     2,     6,     6,     8,     8,     3,     8,
      10,     8,     6,     8,     3,     6,     5,     5,     6,     6,
       6,     6,     8,     7,     7,     8,     8,     8,     8,     3,
       8,    10,     8,     6,     8,     3,     3,     3,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     6,     8,     2,
       2,     2,     2,     4,     5,     1,     2,     1,     6,     8,
       2,     4,     2,     2,     6,     4,     4,     6,     8,    10,
       6,     8,     8,    10,     6,     8,     6,     8,     6,     8,
       2,     2,     2,     2,     2,     4,     2,     8,    10,     8,
       6,     8,     6,    10,    12,    10,     2,     6,     4,     2,
       6,     4,     2,     6,     4,     2,     6,     4,     2,     6,
       4,     1,     3,     2,     1,     3,     2,     2,     6,     4,
       3,     6,     3,     6,     2,     5,     7,     2,     5,     7,
       2,     1,     2,     2,     3,     3,     2,     1,     3,     1,
       3,     6,     8,     8,    10,     6,     8,     8,    10,    10,
      12,     2,     4,     6,    10,    12,     6,     8,     6,     8,
       2,     2,     1,     3,     2,     2,     2,     1,     3,     2,
       2,     1,     3,     2,     6,     4,     4,     6,     6,     8,
       2,     6,     4,     1,     3,     2,     2,     6,     6,     8,
       4,     6,     2,     6,     4,     2,     2,     2,     2,     3,
       3,     1,     3,     1,     3,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
       3,     3,     3,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     1,     1,     4,     4,
       5,     5,     5,     5,     4,     5,     5,     5,     5,     6,
       7,     7,     7,     7,     4,     3,     1,     2,     2,     2,
       2,     4,     4,     4,     4,     4,     4,     6,     8,    10,
       6,     8,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     1,     3,     1,
       3,     1,     3,     1,     3,     1,     3,     4,     4,     1,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     3,     1,     3,     1,     3,     4,     1,     3,
       1,     3,     1,     3,     1,     3,     1,     3,     1,     3,
       1,     3,     1,     3,     1,     3,     1,     3,     1,     3,
       1,     3,     1,     3,     1,     3,     1,     3,     1,     3,
       1,     3,     1,     3,     1,     3,     1,     3,     1,     3,
       1,     3,     1,     3,     1,     3,     1,     3,     1,     3,
       6,     8,     1,     3,     6,     4,     4,     4,     4,     4,
       3,     4,     4,     1,     3,     1,     3,     1,     3,     4,
       4,     6,     8,     6,     1,     3,     1,     3,     4,     3,
       4,     4,     4,     3,     3,     3,     3,     1,     4,     6,
       4,     3,     1,     4,     4,     4,     4,     8,     6,     6,
      10,     1,     3,     4,     1,     3,     4,     1,     3,     4,
       1,     3,     1,     3,     1,     3,     4,     1,     3,     4,
       6,     4,     3,     8,    10,     8,     4,     6,     4,     6
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
      20,   271,     0,     0,     0,     0,     0,     0,     0,   138,
       0,   141,   136,   137,     0,    39,    40,     0,    44,    47,
       0,     0,     0,     0,     0,     0,   251,   254,     0,     0,
     197,   142,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   277,   279,     0,   302,     0,     0,     0,
     307,     0,     0,   311,     0,   195,     0,     0,     0,   323,
       0,     0,     0,     0,     0,     0,     0,     0,    31,     0,
       0,    34,     0,     0,     0,     0,     0,     6,     0,     0,
      20,     5,    16,    18,    33,    17,    36,    19,     7,     8,
       9,    42,    10,    11,    46,    12,    13,    14,    15,    49,
      75,    76,    77,   125,    71,    73,    74,    72,    70,     0,
      79,    78,    64,    65,    66,    67,    51,    52,    53,    54,
      55,    56,    68,    87,    58,    63,    59,    60,    88,    89,
      90,    91,    92,    61,    62,    80,    81,    82,    83,    84,
      85,   105,    69,     0,    57,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,    86,
     118,   119,   120,   121,   122,   123,   124,   458,     0,     0,
     561,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   427,     0,     0,     0,     0,     0,     0,
       0,   429,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   564,   435,   439,   441,   443,   445,   447,   449,
       0,   451,   453,     0,     0,     0,     0,     0,     0,     0,
     455,     0,   431,   433,   460,   462,   464,   466,   468,   470,
     512,   472,   474,   476,   478,   480,   482,   484,   486,   488,
     490,   492,   494,   496,   498,   500,   502,   504,   506,   508,
     567,     0,     0,     0,     0,     0,   523,   570,   525,   572,
     574,   527,   577,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   534,   536,     0,     0,     0,     0,   377,   376,
     547,   396,   552,     0,     0,   273,   272,   396,   552,     0,
     270,     0,     0,     0,     0,     0,     0,     0,   224,     0,
       0,   226,     0,     0,     0,     0,     0,     0,   143,    43,
      48,     0,   189,     0,     0,   236,     0,     0,   239,     0,
       0,   242,     0,   253,     0,   256,   190,   191,    41,    45,
      32,    35,     0,   200,     0,     0,     0,     0,   134,   396,
       0,   203,     0,     0,     0,   245,     0,     0,     0,     0,
     221,   220,   222,   223,     0,     0,     0,     0,   291,     0,
       0,     0,     0,     0,   300,   301,     0,     0,   276,     0,
       0,     0,   257,     0,   304,   305,   306,     0,   309,   310,
       0,   196,     0,   313,     0,     0,     0,     0,     0,   320,
       0,   325,     0,   326,     0,     0,     0,     0,     0,   332,
     335,   336,   337,     0,     0,   135,     0,   192,     0,    26,
      27,   338,     0,   248,   178,   179,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     1,     2,     4,     0,    38,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   363,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     358,     0,     0,     0,     0,     0,     0,     0,     0,   399,
     400,     0,   397,   398,     0,     0,     0,     0,   359,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   275,
       0,     0,     0,     0,     0,     0,     0,   274,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   341,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   252,   255,     0,     0,     0,   126,     0,   127,
       0,   130,     0,   131,   396,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   278,   280,     0,     0,   303,   308,
     312,     0,     0,     0,     0,     0,     0,     0,     0,   324,
       0,     0,     0,     0,     0,     0,     0,     0,    21,    22,
      23,     0,     0,     0,     0,     0,   180,   181,   182,   183,
       0,     0,     0,   175,   169,   176,   177,     0,   186,     0,
       0,   148,   154,   185,   184,     0,     3,   142,    50,    37,
     262,   260,   459,     0,     0,   562,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     428,     0,     0,     0,     0,     0,     0,     0,   430,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   565,
       0,   436,     0,   440,   442,   444,   446,   448,   450,     0,
     452,   454,     0,     0,     0,     0,     0,     0,     0,   456,
       0,     0,   432,   434,   461,   463,   465,   467,   469,   471,
     513,   473,   475,   477,   479,   481,   483,   485,   487,   489,
     491,   493,   495,   497,   499,   501,   503,   505,   507,   509,
     568,   582,     0,   520,     0,     0,     0,   524,   571,   526,
     573,   575,     0,   528,     0,   578,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   535,   537,   539,     0,     0,
       0,     0,     0,   395,     0,   345,   346,     0,     0,     0,
     551,     0,     0,     0,     0,   348,   543,   374,   375,   371,
     360,   361,   362,   352,   353,   356,   357,   372,   373,   370,
     350,   349,   545,   351,   354,   355,   368,   369,   365,   366,
     367,   364,   546,   544,     0,     0,     0,   206,     0,     0,
       0,     0,   225,   340,     0,     0,     0,     0,     0,     0,
     139,     0,     0,   238,     0,   241,     0,   244,     0,     0,
       0,     0,     0,     0,   201,     0,   205,     0,   247,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   292,     0,
       0,     0,     0,     0,     0,   259,     0,   315,     0,     0,
       0,   316,     0,   322,     0,     0,     0,     0,   330,     0,
     334,    24,     0,   193,     0,     0,     0,    30,     0,   250,
       0,     0,     0,   343,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   563,   401,   402,   554,   405,     0,
       0,     0,   555,   556,     0,     0,   412,   413,   414,   415,
     416,   417,   418,   419,   426,   420,   421,   422,   423,   424,
     425,   406,   553,   403,   404,   566,   437,   538,     0,     0,
     515,   516,   517,   518,   519,   457,   438,   581,   521,   522,
     569,   576,   529,   579,     0,   530,     0,     0,     0,     0,
     588,     0,   586,     0,   540,     0,     0,   541,   542,   394,
       0,     0,     0,   378,     0,   384,   550,     0,     0,   379,
       0,   548,     0,   384,     0,   548,     0,     0,     0,     0,
       0,   342,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    25,   194,    28,    29,     0,
       0,     0,   339,     0,     0,   156,   157,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   387,     0,   388,   347,
     382,   380,     0,   385,   386,   383,   381,     0,     0,     0,
     207,     0,   210,     0,     0,     0,   396,   232,     0,     0,
       0,   140,   187,   237,   240,   243,     0,   198,     0,     0,
       0,     0,   204,   246,     0,   216,   214,     0,   218,     0,
     281,     0,     0,   285,     0,   293,     0,     0,   298,     0,
     296,   258,   314,     0,   317,   318,   321,   327,     0,   328,
     331,   333,   249,     0,     0,   344,     0,   158,   159,   160,
     161,   155,   173,     0,     0,     0,   145,   152,   144,   263,
     261,   510,     0,     0,   558,   559,   407,     0,   410,     0,
       0,   514,   580,     0,   531,     0,     0,   533,   589,   587,
       0,     0,   389,   549,   389,   549,     0,     0,     0,   396,
       0,     0,     0,     0,     0,     0,   128,   129,   132,   133,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   163,   164,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   392,   393,   390,   391,   211,
       0,   212,   231,     0,   396,   229,     0,     0,   208,   188,
     199,   217,   215,   219,   282,     0,   283,     0,   286,     0,
     287,   299,     0,     0,   297,   319,   329,   170,     0,   172,
     165,   166,   167,   168,   162,   174,   149,     0,   151,   147,
     153,   146,   511,   557,   408,     0,   411,     0,   583,     0,
     532,   585,     0,   396,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   213,   228,
       0,   233,   235,   209,   284,     0,   288,   289,     0,   294,
     171,   150,   409,   560,   584,     0,     0,     0,   234,   290,
     295
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    88,    89,    90,    91,    92,    93,   678,   431,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   693,   321,   607,   952,   834,   309,   313
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -664
static const yytype_int16 yypact[] =
{
      82,  6568,  6763,  6958,  7153,  7348,  -114,  7543,  7738,  -664,
    7933,  -664,  -664,  -664,  6568,  -664,  -664,  6568,  -664,  -664,
    6568,  -213,  -164,  8128,  8323,  8518,  8713,  8908,  -155,  -143,
    -664,    -8,  9103,  -174,   -68,  6568,  3011,  9298,  9493,  9688,
    6568,  6568,  6568,  9883, 10078,  6568, 10273, 10468,  6568,  6568,
    6568, 10663,  6568,  -168,  -138, 10858,  -130,  6568,  6568,  6568,
    -125,  6568,  6568,  -118,   -98,  -664, 11053, 11248, 11443, 11638,
   11833, 12028, 12223, 12418,  6568,  6568,  6568,   -55,  -664,  6568,
     -72,  -664,   -27,    41, 12613,   -78,  -163,  -664,   132,   -38,
   14211,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,   -36,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,   185,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,   -17,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,   -13,    -4,     6,
      22,    24,    54,    60,    69,    72,    74,    78,    80,    84,
      94,   102,   109,   112,   121,   126,   134,   136,   137,   139,
     141,   142,   143,   144,   146,   147,   151,   158,  6568,   160,
     162,   164,   170,   172,   174,   176,   181,   192,   193,   194,
     204,   205,   206,   207,   208,   210,   219,   221,   249,   250,
     255,   264,   265,   268,   269,   272,   276,   280,   281,   295,
     302,   305,   306,   309,   310,   311,   316,   321,   322,   327,
     328,   329,   351,   352,   353,   354,   356,   359,   361,   363,
     368,   370,   372,   375,   376,   377,   378,   379,   380,   386,
     388,   390,   392,   396,   397,   400,  6568,   402,   404,   406,
     407,   411,   417,   418,   419,    56,    79,   420,  -664,  -664,
    -664,    33,  -180,  6568,  6568,   545,   -16,   149,  -109, 21083,
     226,  6568,   634,   226,  6568, 15948,  6568, 16000,  -664,    97,
    6568,  -664,  6568, 16025,  6568, 16041,  6568, 16063, 21083, 21083,
   21083,    17,  -664,  6568, 16128,   226,  6568, 16241,   226,  6568,
   16259,   226,  3608, 21083,  3803, 21083,  -664,  -664,  -664,  -664,
    -664,  -664,  6568, 16279, 12808, 13003, 13198, 13393, 21083,   248,
   13588,  -664, 16297,  6568, 16335,   226,  6568, 16349,  6568,    44,
   21083,   226,   226, 21083,  6568, 16363,  6568, 16531, 21083,  6568,
   16545,  6568, 16559, 16583, 21083, 21083,  6568, 16597,   226,   131,
     153,  6568, 16611,   225,   226, 21083,   226,   314,   226,   226,
     425,  -664,  6568, 16635,  6568, 16649,   165,  6568, 16663,   226,
    3998, 21083,  6568,   226,  6568,   675,  6568, 16831,  6568,   769,
   21083, 21083, 21083,   427,   427, 21083,   427,   428,   429,  -664,
    -664,   430,  6568, 16845,  -664,  -664,  6568,  6568,  6568,  6568,
    2613,  6568,  6568,  2812,  6568,  -664,  6377,  -664, 14430, 14430,
     -40,   433,  6568,  6568,  4193,  6568,  6568,  6568,  6568,  6568,
    6568,  6568,  6568,  6568,  6568,  6568,  6568,   434,  6568,  6568,
    6568,  6568,  6568,  6568,  6568,   435,  6568,  6568,  6568,  6568,
    6568,  6568,   211,  6568,  6568,  6568,  4388,  4583,   440,   441,
     442,   444,   448,   449,  6568,   451,   452,  6568,  6568,  6568,
    6568,  6568,  6568,  6568,  4778,  6568,   453,   459,   460,   464,
     465,   468,   475,   480,   488,   490,   493,   494,   495,   501,
     503,   507,   514,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   529,   530,   531,  4973,   532,  6568,  6568,  6568,
     533,   541,   543,   547,  5168,  5363,   548,  6568,  6568,  6568,
     211,  6568,  6568,  6568,  6568,   -14,   549,   554,  5558,   426,
     555,    -6,  -664,  -664,  5753,  1782,  5948,  2412,   211, 18435,
      99,  6568,  6568,  6568,  6568,  6568,  6568,  6568,  6568,  6568,
    6568,  6568,  6568,  6568,  6568,  6568,  6568,  6568,  6568,  -664,
    6568,  6568,  6568,  6568,  6568,  6568,  6568,  -664,  1782,  2412,
    1253,  6568, 14810,  6568, 14867,  6568,   559,   423, 16859, 14892,
    6568, 14987,  6568, 15043,  6568,  6568, 15067,  6568, 15095,  6568,
   15119,  6568,  -664,  -664, 15156,  6568,  6568, 21083,  6568, 21083,
    6568, 21083,  6568, 21083,  -182, 15171,  6568, 15246,  6568, 15338,
    6568,   116,  6568, 15374,  6568, 15397,  6568, 15413,  6568, 15453,
    6568,  6568, 15469,  6568,  -664,  -664, 15489,  6568,  -664,  -664,
    -664, 15505,  6568, 15620,   188,  6568,  6568, 15672,  6568,  -664,
   15689,   283,  6568, 15708,  6568,   483,  6568,   119,  -664,  -664,
    -664,  6143,     9,    41, 15728,  6568, 21083, 21083, 21083, 21083,
     561,   565,  6568,  -664,  -664, 21083,   226,   742,   226,   568,
     569,  -664,  -664, 21083,   226,  1194,  -664,  -664,  -664,   -36,
     558,   566,  -664, 16883, 16897,  -664, 18449, 18463,  1779, 18662,
    1899,   782,   789,   888,  1956,  2014,   901,   983, 18676, 18690,
    -664, 18714, 18728, 18742, 18766, 18780, 18794, 18993,  -664, 19007,
   19021, 19045, 19059, 19073, 19097,  2056, 19111, 19125,  2072,  -664,
   19324,  -664, 19338,  -664,  -664,  -664,  -664,  -664,  -664,  2094,
    -664,  -664, 16911, 16935, 19352, 19376, 19390, 19404, 19428,  -664,
   19442,  2099,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  2136,  -664, 19456, 19655, 19669,  -664,  -664,  -664,
    -664,  -664, 19683,  -664, 19707,  -664,  2159,  1001, 19721,  1014,
    1058,  1081,  1103,    -3,    11,  -664,  -664,  -664, 19735,  6568,
    6568,   570,   574,  -664,    38, 21083,   226,   567,   -73,  1560,
    -664,    64,   575,   -46,  1940,  -664,  -664,   -12,   -12,   -12,
   14460, 16165, 21097,   211,   211,    63,    63,   -12,   -12,   -12,
     -71,   -71,  -664,   211,   211,  -664,   583,   583,   583,   583,
     583,   583,   -71,  -664,  2031,  2047,  6568, 21083,  6568, 16949,
    6568, 16963,  -664,  -664,  6568,  6568, 17131,  6568, 17145,  6568,
   21083,   610,  6568,   226,  6568,   226,  6568,   226,  6568, 17159,
   15745, 15797, 15823, 15912,  -664,  6568, 21083,  6568,   226,  6568,
   17183,  6568, 17197,  6568, 17211,  6568, 17235,  6568,   226,  6568,
   17249, 17263,  6568, 17431,  6568, 21083,  6568, 21083,  6568,  6568,
    1123, 21083,  6568,   226,  6568,  6568,  1158,  6568, 21083,  6568,
     226,  -664,    75,  -664,    95,   582,   594,   430,  6568, 21083,
    6568,  6568,   588,  1214,  6568,   209,  6568,  6568,  6568,  -211,
    6568,  6568,  6568,  6568,  -664,  -664,  -664,  -664,  -664,  6568,
    6568,  6568,  -664,  -664,  6568,  6568,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  6568,  6568,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  6568,  -664,  6568,  6568,  6568,  6568,
    -664,  6568,  -664,  6568,  -664,  2150, 14436,  -664,  -664,  -664,
    6568,   592,   593,  -664,  6568,   154,  -664,   602,   611,  -664,
    6568,  -664,  6568,  -159,  6568,   -94, 19759, 17445,  6568, 17459,
    6568,  -664, 17483,  3210, 17497,  6568, 19773,  6568,  2172,  2180,
    2207, 17511,  6568,  6568,  6568,  6568,  6568, 19787,  2302, 17535,
    6568, 17549,  6568, 17563,  6568, 17731,  6568, 17745,  2382, 17759,
    6568,  6568, 17783,  6568, 19986, 20000,  1307, 20014,  6568,  2399,
    2799,  1352,  6568, 20038,  2998,  -664,  -664,  -664,  -664, 20052,
    1376,  1422,  -664,  6568,  1328,  -664,  -664,  6568,  6568,  6568,
    6568,  6568,  1464,  1477, 14489,  6568,  6568, 14557, 14574, 20066,
   17797, 17811, 20090, 20104,   496,   509, 17835, 20118,  3197,  1482,
     515,  1531,  3396,  6113,  6141,  6568,  -664,  6568,  -664,   597,
    -664,  -664, 14640,  -664,  -664,  -664,  -664, 14659, 14695, 14754,
    -664,  6568, 21083,  6568, 17849, 13783,   267,  -664, 17863,  6568,
   18031,  -664,   619,  -664,  -664,  -664,  6568, 21083, 20317, 20331,
   20345, 20369,  -664,  -664,  6568, 21083,   226,  6568, 21083,  6568,
    1586,  6568, 18045,   226,  6568,  -664,  6568, 18059, 21083,  6568,
   21083,  -664,  -664,  6568,  -664, 21083,  -664,  -664,  6568,   226,
    -664,  -664,  -664,  6568,  6568,  -664,   315, 21083, 21083, 21083,
   21083, 21083,   226,  6568,  6568,  -153,   226, 21083,   226,  -664,
    -664,  -664,  6568,  6568,  -664,  -664,  -664,  6568,  -664,  6568,
    6568,  -664,  -664,  6568,  -664,  6568,  6568,  -664,  -664,  -664,
   14772, 14791,   156,  -664,   -59,   -93, 20383, 18083,  6568,   -67,
   18097,  3409, 18111,  6568,  6568, 20397,  -664,  -664,  -664,  -664,
   20421,  6199, 20435,   562,  6568, 18135,  6205,  6568, 20449, 18149,
    6568, 20648, 20662,  6211,   659,  6261,  -664,  -664,  6568,  6568,
    6568,  6568,  6568,   709,  6286,  6568,  6568, 20676, 20700, 15928,
   20714, 18163,   724, 20728, 13948,  -664,  -664,  -664,  -664,  -664,
    6568, 21083,  -664, 13978,   279,  -664, 18331,  6568, 21083, 21083,
    -664,  -664,  -664,  -664,  -664,  6568, 21083,  6568,  -664, 18345,
     226,  -664,  6568, 18359,  -664,  -664,  -664,  -664,  6568,  -664,
   21083, 21083, 21083, 21083, 21083,   226,  -664,  6568,  -664,   226,
   21083,   226,  -664,  -664,  -664,  6568,  -664,  6568,  -664,  6568,
    -664,  -664, 20752,    14, 18383,  -217, 20766, 20780, 18397, 13975,
    6568, 18411,  6568, 20979, 20993, 21007, 21031, 21045,  -664,  -664,
     633,  -664,  -664,  -664,  -664,  6568,  -664,   226,  6568, 21083,
    -664,  -664,  -664,  -664,  -664,   618, 14034, 21059,  -664,  -664,
    -664
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -664,   414,  -664,  -664,   771,  -664,  -664,  -386,  -663,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,   413,   415,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,   431,   -35,   -11,  -232,  -556,    -1,  1138
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -270
static const yytype_int16 yytable[] =
{
     305,   361,   312,   315,   317,  1115,   323,   325,  1371,   327,
     841,   348,   331,   328,   942,   349,   329,   577,   578,   330,
     947,  1116,   334,   337,   340,   343,   345,   590,   591,   592,
     320,   353,   562,   563,   358,   362,   364,   367,   679,   370,
     680,   373,   375,   377,   378,   380,   382,   383,   384,   385,
     387,   354,   355,   442,   392,  1143,  1144,   395,   564,   904,
     566,   332,   565,  1285,   567,   403,   405,   408,   411,   443,
     346,   417,   389,   420,   421,   422,   577,   578,   425,  1286,
    -268,   444,   347,   433,  -268,     1,     2,   590,   591,   592,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,   390,    15,    16,    17,    18,    19,    20,    21,
     393,   318,    22,    23,    24,   397,    25,    26,    27,    28,
      29,    30,   400,    31,    32,   944,   319,   401,    33,    34,
    -264,   566,   445,   320,  -264,   599,   434,   435,   436,   437,
     438,   439,   590,   591,   592,  -265,  -266,   562,   563,  -265,
    -266,   577,   578,   426,   440,  1297,  1298,   356,   357,   590,
     591,   592,    35,    36,   586,   587,   441,   588,    37,  1032,
     423,   424,  1033,   564,  1302,   579,   580,   565,    38,    39,
    -269,    40,    41,    42,  -269,   710,   711,    43,    44,    45,
      46,    47,    48,    49,    50,    51,  1038,   350,   427,  1039,
     351,   446,    52,    53,    54,   449,    55,   448,   590,   591,
     592,   823,   824,    56,   593,   594,   595,   482,   596,   831,
     832,   584,   585,   586,   587,   450,   588,   451,   562,   563,
     597,   590,   591,   592,   945,   946,   452,    57,  1020,  1021,
      58,    59,    60,    61,    62,    63,   453,   562,   563,   615,
      64,    65,  1022,  1023,   564,  1369,    66,    67,   565,    68,
      69,   428,   454,    70,   455,    71,   429,   430,    72,   590,
     591,   592,    73,   564,   593,   594,   595,   565,   596,  1029,
    1030,   559,    74,    75,    76,   550,   642,    77,    78,    79,
      80,    81,    82,    83,   456,    84,   584,   585,   586,   587,
     457,   588,   568,   569,   560,  1036,  1030,    85,    86,   458,
     600,    87,   459,   602,   460,   604,  1095,   683,   461,   608,
     462,   609,   606,   611,   463,   613,   590,   591,   592,   593,
     594,   595,   616,   596,   464,   618,  1096,  1030,   620,   428,
     846,   569,   465,   569,   429,   430,   593,   594,   595,   466,
     596,   624,   467,   627,   629,   631,   633,   846,   911,   635,
     941,   468,   637,   562,   563,   639,   469,   569,  1143,  1144,
    1297,  1298,   654,   643,   470,   645,   471,   472,   647,   473,
     649,   474,   475,   476,   477,   652,   478,   479,  -267,   564,
     656,   480,  -267,   598,   655,   593,   594,   595,   481,   596,
     483,   661,   484,   663,   485,   694,   667,   666,   702,   569,
     486,   670,   487,   569,   488,   673,   489,   569,   593,   594,
     595,   490,   596,  1105,  1106,  1107,  1108,  1109,  1110,   846,
     929,   684,   491,   492,   493,   686,   687,   688,   689,   695,
     697,  1111,   703,   705,   494,   495,   496,   497,   498,   588,
     499,   713,   714,   716,   717,   719,   593,   594,   595,   500,
     596,   501,   562,   563,   728,   729,   658,   731,   732,   733,
     734,   735,   736,   737,  1139,   739,   740,   741,   742,   743,
     744,   562,   563,   746,   747,   750,   752,  -202,   564,   502,
     503,  -202,   565,   562,   563,   504,   762,   763,   764,   765,
     766,   767,   768,   770,   505,   506,  -230,   564,   507,   508,
    -230,   565,   509,   593,   594,   595,   510,   596,  -227,   564,
     511,   512,  -227,   565,   846,   935,   590,   591,   592,  1276,
    1277,  1278,  1279,  1280,  1281,   513,   804,   805,   806,   590,
     591,   592,   514,   812,   814,   515,   516,  1282,   818,   517,
     518,   519,   590,   591,   592,   659,   520,   828,   590,   591,
     592,   521,   522,   835,   839,   835,   844,   523,   524,   525,
     847,   848,   849,   850,   851,   852,   853,   854,   855,   856,
     857,   858,   859,   860,   861,   863,   864,   865,   571,   572,
     573,   526,   527,   528,   529,   872,   530,   874,   875,   531,
     877,   532,   879,   533,   881,   590,   591,   592,   534,   886,
     535,   888,   536,   890,   891,   537,   538,   539,   540,   541,
     542,   574,   575,   576,   899,   900,   543,   901,   544,   902,
     545,   903,   546,   577,   578,   906,   547,   548,  1057,   910,
     549,   912,   551,   914,   552,   916,   553,   554,  1254,   920,
     921,   555,   923,   571,   572,   573,   925,   556,   557,   558,
     561,   927,   571,   572,   573,   931,   660,   677,   681,   682,
     829,   883,   683,   938,   712,   730,   738,   571,   572,   573,
     835,   753,   754,   755,   949,   756,   574,   575,   576,   757,
     758,   608,   760,   761,   772,   574,   575,   576,   577,   578,
     773,   774,   590,   591,   592,   775,   776,   577,   578,   777,
     574,   575,   576,   593,   594,   595,   778,   596,   590,   591,
     592,   779,   577,   578,   846,   939,   593,   594,   595,   780,
     596,   781,   579,   580,   782,   783,   784,  1226,  1227,   593,
     594,   595,   785,   596,   786,   593,   594,   595,   787,   596,
    1228,  1229,   590,   591,   592,   788,  1234,  1235,   789,   790,
     791,   792,   793,   794,   795,   796,   797,   590,   591,   592,
     798,   799,   800,   803,   807,   581,   582,   583,   584,   585,
     586,   587,   808,   588,   809,   571,   572,   573,   810,   815,
     825,   589,   593,   594,   595,   826,   596,   579,   580,   830,
     882,   950,   960,  1314,  1315,   951,   579,   580,   956,   957,
     961,  1027,   590,   591,   592,  1028,  1031,   596,   574,   575,
     576,   579,   580,  1097,  1037,   590,   591,   592,  1025,  1026,
     577,   578,   590,   591,   592,  1098,  1102,  1140,  1141,  1030,
     581,   582,   583,   584,   585,   586,   587,  1145,   588,   581,
     582,   583,   584,   585,   586,   587,  1146,   588,  1385,  1388,
     706,   447,   709,   708,   581,   582,   583,   584,   585,   586,
     587,  1205,   588,  1051,   701,  1046,   601,  1047,     0,  1049,
       0,     0,     0,   608,  1052,     0,  1054,     0,  1056,   593,
     594,   595,     0,   596,     0,     0,     0,  1061,     0,     0,
    1327,  1328,     0,     0,  1067,   593,   594,   595,  1069,   596,
    1071,     0,  1073,     0,  1075,     0,  1077,   672,  1079,     0,
       0,  1082,     0,  1084,     0,  1085,     0,     0,  1087,   579,
     580,   590,   591,   592,     0,     0,  1093,     0,     0,   593,
     594,   595,     0,   596,   590,   591,   592,  1099,     0,     0,
    1336,  1337,     0,  1104,   593,   594,   595,  1114,   596,  1117,
    1118,  1119,  1120,     0,     0,  1348,  1349,     0,  1121,  1122,
    1123,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,     0,     0,     0,   954,     0,     0,   955,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1126,  1127,   593,
     594,   595,     0,   596,     0,     0,     0,     0,     0,     0,
       0,   676,   593,   594,   595,     0,   596,     0,  1157,   593,
     594,   595,     0,   596,   969,     0,   590,   591,   592,   835,
       0,   970,     0,  1142,     0,     0,     0,     0,     0,  1147,
       0,  1148,     0,  1149,   590,   591,   592,  1152,     0,  1154,
       0,     0,  1158,     0,  1160,     0,  1162,   590,   591,   592,
       0,  1167,  1168,  1169,  1170,  1171,     0,     0,     0,  1175,
       0,  1178,     0,     0,     0,  1182,     0,     0,     0,  1187,
    1188,     0,  1190,     0,     0,     0,     0,  1195,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   590,   591,   592,     0,     0,  1207,  1208,  1209,  1210,
    1211,     0,     0,     0,     0,  1217,     0,     0,   593,   594,
     595,     0,   596,     0,   590,   591,   592,     0,     0,     0,
     971,   593,   594,   595,  1240,   596,  1241,     0,     0,   306,
     310,     0,     0,   974,     0,     0,   590,   591,   592,     0,
    1246,     0,  1247,     0,  1250,     0,     0,     0,  1252,     0,
       0,   335,   338,   341,     0,  1255,   590,   591,   592,     0,
       0,     0,     0,  1260,     0,   365,  1262,   369,   371,   372,
    1265,     0,     0,  1268,     0,  1269,     0,     0,  1271,     0,
     388,     0,  1272,     0,     0,   394,     0,   396,     0,   398,
     399,   590,   591,   592,     0,   406,   409,     0,   413,   415,
       0,   419,     0,   593,   594,   595,  1305,   596,     0,     0,
       0,  1287,  1288,     0,     0,   975,  1289,     0,  1290,  1291,
       0,   593,   594,   595,  1293,   596,     0,   571,   572,   573,
       0,     0,     0,  1014,   593,   594,   595,  1301,   596,     0,
    1306,     0,  1308,  1309,     0,     0,  1016,   590,   591,   592,
       0,     0,     0,  1316,     0,     0,  1319,     0,     0,  1323,
     574,   575,   576,     0,     0,     0,     0,  1330,  1331,  1332,
    1333,  1334,   577,   578,     0,  1340,     0,     0,   593,   594,
     595,     0,   596,     0,     0,     0,   571,   572,   573,  1352,
    1017,     0,  1354,     0,     0,     0,  1356,     0,     0,     0,
       0,   593,   594,   595,  1357,   596,  1358,     0,     0,     0,
    1372,  1361,     0,  1018,     0,     0,     0,  1363,     0,   574,
     575,   576,     0,   593,   594,   595,  1364,   596,     0,     0,
       0,   577,   578,     0,  1365,  1019,  1366,     0,  1367,     0,
     590,   591,   592,   593,   594,   595,     0,   596,     0,     0,
       0,  1379,     0,     0,     0,  1088,     0,     0,     0,     0,
       0,   571,   572,   573,     0,     0,     0,  1387,     0,     0,
       0,   579,   580,     0,     0,     0,     0,     0,   593,   594,
     595,     0,   596,     0,     0,   590,   591,   592,     0,     0,
    1092,     0,     0,     0,   574,   575,   576,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   577,   578,     0,   590,
     591,   592,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,     0,     0,   958,     0,     0,   959,
     579,   580,   570,     0,   593,   594,   595,     0,   596,   570,
       0,     0,   570,     0,   570,     0,  1103,     0,     0,     0,
     570,     0,   570,     0,   570,   590,   591,   592,     0,     0,
       0,   570,     0,     0,   570,     0,     0,   570,     0,     0,
     570,     0,   570,   581,   582,   583,   584,   585,   586,   587,
     570,   588,     0,     0,   845,   876,     0,     0,   570,     0,
       0,   570,     0,     0,   570,     0,   641,   590,   591,   592,
       0,     0,   570,     0,   570,   579,   580,   570,     0,   570,
     590,   591,   592,     0,   570,   590,   591,   592,     0,   570,
       0,     0,     0,     0,     0,     0,     0,   593,   594,   595,
     570,   596,   664,     0,     0,   570,     0,     0,   570,  1193,
     570,     0,   671,     0,   570,     0,   675,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,     0,     0,
     570,     0,     0,  1206,   590,   591,   592,     0,   696,     0,
     698,   704,   593,   594,   595,     0,   596,     0,     0,     0,
       0,     0,     0,   718,  1198,   720,   721,   722,   723,   724,
     725,   726,   727,   571,   572,   573,   593,   594,   595,     0,
     596,     0,     0,     0,     0,     0,     0,     0,  1203,     0,
       0,   745,     0,   748,     0,     0,     0,     0,     0,   590,
     591,   592,   759,     0,     0,     0,   574,   575,   576,     0,
       0,     0,     0,   771,     0,     0,     0,     0,   577,   578,
       0,     0,   593,   594,   595,     0,   596,     0,     0,     0,
       0,     0,     0,     0,  1204,     0,     0,     0,     0,     0,
       0,     0,     0,   802,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   816,   817,     0,     0,   819,
     820,   821,   822,     0,   593,   594,   595,     0,   596,     0,
       0,     0,   836,     0,   836,     0,  1213,   593,   594,   595,
       0,   596,   593,   594,   595,     0,   596,     0,     0,  1214,
       0,     0,     0,   862,  1233,     0,     0,     0,   866,   867,
     868,   869,   870,   871,   873,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   579,   580,     0,
       0,     0,     0,     0,     0,   893,     0,   895,     0,   897,
       0,   593,   594,   595,   570,   596,   570,     0,   570,     0,
     570,     0,     0,  1236,     0,     0,   908,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   918,   187,   188,   189,
     581,   582,   583,   584,   585,   586,   587,     0,   588,     0,
       0,     0,  1034,   930,     0,  1035,   933,     0,     0,     0,
     936,     0,     0,     0,   940,   190,   593,   594,   595,   836,
     596,     0,   590,   591,   592,     0,     0,     0,  1264,     0,
     953,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,     0,     0,
       0,   218,     0,     0,   219,   220,   221,   222,     0,   223,
       0,     0,   224,   225,   226,   227,   228,   229,     0,     0,
     230,     0,     0,     0,   231,   232,   233,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   234,   235,   236,   237,
     238,   239,     0,     0,     0,   240,     0,   241,   242,   243,
     244,   245,   246,     0,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,     0,   270,   271,
       0,     0,   590,   591,   592,     0,   272,   273,   274,   275,
       0,     0,   276,   277,   278,   279,     0,     0,   280,     0,
       0,   281,   282,     0,   283,     0,   284,   285,     0,     0,
       0,   286,     0,   287,   288,     0,   289,   290,     0,   291,
     292,   293,     0,   571,   572,   573,     0,     0,     0,     0,
       0,     0,     0,     0,   294,     0,   295,   296,     0,   590,
     591,   592,   297,     0,   298,   299,   300,   301,   302,   593,
     594,   595,     0,   596,     0,   303,   574,   575,   576,     0,
     966,     0,   304,     0,   837,     0,     0,     0,   577,   578,
    1058,   838,  1059,     0,  1060,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1068,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1078,     0,   590,   591,   592,
       0,     0,     0,     0,     0,     0,  1086,     0,     0,     0,
    1089,     0,  1090,  1091,   571,   572,   573,  1094,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1100,  1101,
     571,   572,   573,     0,  1112,  1113,     0,     0,     0,   590,
     591,   592,     0,     0,     0,     0,     0,   574,   575,   576,
       0,     0,  1124,  1125,     0,   590,   591,   592,     0,   577,
     578,     0,     0,   574,   575,   576,     0,   579,   580,   593,
     594,   595,     0,   596,     0,   577,   578,   590,   591,   592,
     968,     0,   590,   591,   592,     0,     0,     0,     0,     0,
       0,     0,  1128,     0,  1129,  1130,  1131,  1132,     0,  1133,
       0,  1134,     0,     0,     0,     0,     0,     0,   836,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   590,
     591,   592,  1040,     0,     0,  1041,   593,   594,   595,     0,
     596,     0,     0,   571,   572,   573,     0,   972,     0,     0,
       0,     0,   590,   591,   592,     0,     0,     0,  1176,     0,
       0,     0,  1180,     0,  1183,   590,   591,   592,   579,   580,
       0,     0,     0,   590,   591,   592,   574,   575,   576,     0,
    1199,     0,     0,     0,   579,   580,     0,     0,   577,   578,
       0,   953,     0,     0,   593,   594,   595,     0,   596,  1212,
     590,   591,   592,  1216,  1218,   973,     0,     0,     0,     0,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
       0,     0,     0,  1042,     0,     0,  1043,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   593,   594,   595,  1044,
     596,     0,  1045,     0,     0,     0,     0,   991,     0,     0,
       0,     0,   593,   594,   595,     0,   596,     0,     0,     0,
       0,     0,  1261,   994,     0,     0,     0,  1263,     0,  1266,
       0,     0,     0,     0,   593,   594,   595,     0,   596,   593,
     594,   595,     0,   596,     0,   997,  1273,   579,   580,     0,
    1006,  1274,  1275,     0,     0,   590,   591,   592,     0,     0,
       0,  1283,  1284,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   593,   594,   595,     0,
     596,  1292,     0,     0,  1294,     0,     0,  1007,     0,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   593,
     594,   595,  1135,   596,     0,  1136,     0,     0,     0,     0,
    1013,     0,   593,   594,   595,  1320,   596,     0,     0,     0,
     593,   594,   595,  1163,   596,     0,     0,   187,   188,   189,
    1335,  1164,     0,  1339,  1341,   590,   591,   592,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   593,   594,   595,
       0,   596,   590,   591,   592,   190,     0,     0,  1165,     0,
       0,     0,     0,     0,     0,  1359,     0,     0,     0,     0,
       0,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,     0,     0,
       0,   218,     0,     0,   219,   220,   221,   222,  1377,   223,
       0,     0,   224,   225,   226,   227,   228,   229,     0,     0,
     230,     0,     0,  1386,   231,   232,   233,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   234,   235,   236,   237,
     238,   239,   593,   594,   595,   240,   596,   241,   242,   243,
     244,   245,   246,  1173,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,     0,   270,   271,
       0,     0,     0,     0,     0,     0,   272,   273,   274,   275,
       0,     0,   276,   277,   278,   279,     0,     0,   280,     0,
       0,   281,   282,     0,   283,     0,   284,   285,     0,     0,
       0,   286,     0,   287,   288,     0,   289,   290,     0,   291,
     292,   293,   593,   594,   595,     0,   596,     0,   187,   188,
     189,     0,     0,  1185,   294,     0,   295,   296,     0,   593,
     594,   595,   297,   596,   298,   299,   300,   301,   302,     0,
    1196,     0,     0,     0,     0,   303,   190,     0,     0,     0,
       0,     0,   304,     0,   842,     0,     0,     0,     0,     0,
       0,   843,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,   690,   289,   290,   691,
     291,   292,   293,     0,     0,     0,     0,   187,   188,   189,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,     0,   590,   591,   592,   190,   303,     0,     0,     0,
       0,     0,     0,   304,     0,     0,     0,     0,     0,     0,
     692,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,     0,     0,
       0,   218,     0,     0,   219,   220,   221,   222,     0,   223,
       0,     0,   224,   225,   226,   227,   228,   229,     0,     0,
     230,     0,     0,     0,   231,   232,   233,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   234,   235,   236,   237,
     238,   239,     0,     0,     0,   240,     0,   241,   242,   243,
     244,   245,   246,     0,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,     0,   270,   271,
       0,     0,     0,     0,     0,     0,   272,   273,   274,   275,
       0,     0,   276,   277,   278,   279,     0,     0,   280,     0,
       0,   281,   282,     0,   283,     0,   284,   285,     0,     0,
       0,   286,     0,   287,   288,   699,   289,   290,   700,   291,
     292,   293,     0,     0,     0,     0,   187,   188,   189,     0,
       0,     0,     0,     0,   294,     0,   295,   296,     0,   593,
     594,   595,   297,   596,   298,   299,   300,   301,   302,     0,
    1197,   590,   591,   592,   190,   303,     0,     0,     0,     0,
       0,     0,   304,     0,     0,     0,     0,     0,     0,   692,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,     0,     0,     0,
     218,     0,     0,   219,   220,   221,   222,     0,   223,     0,
       0,   224,   225,   226,   227,   228,   229,     0,     0,   230,
       0,     0,     0,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   234,   235,   236,   237,   238,
     239,     0,     0,     0,   240,     0,   241,   242,   243,   244,
     245,   246,     0,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,     0,   270,   271,     0,
       0,     0,     0,     0,     0,   272,   273,   274,   275,     0,
       0,   276,   277,   278,   279,     0,     0,   280,     0,     0,
     281,   282,     0,   283,     0,   284,   285,     0,     0,     0,
     286,     0,   287,   288,     0,   289,   290,     0,   291,   292,
     293,     0,     0,     0,     0,   187,   188,   189,     0,     0,
       0,     0,     0,   294,     0,   295,   296,     0,   593,   594,
     595,   297,   596,   298,   299,   300,   359,   302,     0,  1201,
     590,   591,   592,   190,   303,     0,     0,     0,     0,     0,
       0,   360,     0,     0,     0,     0,     0,     0,   320,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,     0,     0,     0,   218,
       0,     0,   219,   220,   221,   222,     0,   223,     0,     0,
     224,   225,   226,   227,   228,   229,     0,     0,   230,     0,
       0,     0,   231,   232,   233,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   234,   235,   236,   237,   238,   239,
       0,     0,     0,   240,     0,   241,   242,   243,   244,   245,
     246,     0,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,     0,   270,   271,     0,     0,
       0,     0,     0,     0,   272,   273,   274,   275,     0,     0,
     276,   277,   278,   279,     0,     0,   280,     0,     0,   281,
     282,     0,   283,     0,   284,   285,     0,     0,     0,   286,
       0,   287,   288,     0,   289,   290,     0,   291,   292,   293,
       0,     0,     0,     0,   187,   188,   189,     0,     0,     0,
       0,     0,   294,     0,   295,   296,     0,   593,   594,   595,
     297,   596,   298,   299,   300,  1156,   302,     0,  1232,   590,
     591,   592,   190,   303,     0,     0,     0,     0,     0,     0,
     304,     0,     0,     0,     0,     0,     0,   320,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,     0,     0,     0,   218,     0,
       0,   219,   220,   221,   222,     0,   223,     0,     0,   224,
     225,   226,   227,   228,   229,     0,     0,   230,     0,     0,
       0,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   234,   235,   236,   237,   238,   239,     0,
       0,     0,   240,     0,   241,   242,   243,   244,   245,   246,
       0,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,     0,   270,   271,     0,     0,     0,
       0,     0,     0,   272,   273,   274,   275,     0,     0,   276,
     277,   278,   279,     0,     0,   280,     0,     0,   281,   282,
       0,   283,     0,   284,   285,     0,     0,     0,   286,     0,
     287,   288,     0,   289,   290,     0,   291,   292,   293,     0,
       0,     0,     0,   187,   188,   189,     0,     0,     0,     0,
       0,   294,     0,   295,   296,     0,   593,   594,   595,   297,
     596,   298,   299,   300,  1304,   302,     0,  1237,     0,     0,
       0,   190,   303,     0,     0,     0,     0,     0,     0,   304,
       0,     0,     0,     0,     0,     0,   320,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   304,   622,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   304,   623,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   304,   669,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   304,   715,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   304,   749,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   304,   751,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   304,   769,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   304,   801,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   304,   811,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   304,   813,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   304,   827,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   304,   833,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,   590,   591,   592,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,   590,   591,   592,     0,   304,   840,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,   590,   591,   592,   231,   232,   233,   590,   591,
     592,     0,     0,     0,   590,   591,   592,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,   590,   591,   592,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,   590,
     591,   592,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   593,   594,   595,     0,   596,     0,     0,
       0,     0,     0,     0,  1238,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   593,   594,   595,     0,   596,   303,     0,     0,     0,
       1,     2,  1239,   304,   943,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,     0,    15,    16,
      17,    18,    19,    20,    21,     0,     0,    22,    23,    24,
       0,    25,    26,    27,    28,    29,    30,     0,    31,    32,
       0,     0,     0,    33,    34,     0,     0,     0,     0,   593,
     594,   595,     0,   596,     0,   593,   594,   595,     0,   596,
    1312,   593,   594,   595,     0,   596,  1318,     0,     0,     0,
       0,     0,  1326,     0,     0,     0,     0,    35,    36,     0,
       0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    38,    39,     0,    40,    41,    42,     0,
       0,     0,    43,    44,    45,    46,    47,    48,    49,    50,
      51,   593,   594,   595,     0,   596,     0,    52,    53,    54,
       0,    55,  1329,     0,     0,     0,     0,     0,    56,     0,
       0,     0,     0,     0,     0,     0,   593,   594,   595,     0,
     596,     0,     0,     0,     0,     0,     0,  1338,     0,     0,
       0,     0,    57,     0,     0,    58,    59,    60,    61,    62,
      63,     0,     0,     0,     0,    64,    65,     0,     0,     0,
       0,    66,    67,     0,    68,    69,     0,     0,    70,     0,
      71,     0,     0,    72,     0,     0,     0,    73,     0,     0,
       0,     0,     0,   187,   188,   189,     0,    74,    75,    76,
       0,     0,    77,    78,    79,    80,    81,    82,    83,     0,
      84,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   190,    85,    86,     0,     0,    87,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   -20,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   304,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   307,   308,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   304,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   311,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   314,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   316,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   322,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   324,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   326,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   333,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   336,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   339,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   342,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   344,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   352,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   363,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   366,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   368,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   374,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   376,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   379,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   381,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   386,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   391,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   402,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   404,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   407,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   410,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   412,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   414,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   416,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   418,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   432,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   626,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   628,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   301,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   630,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,   301,   302,
       0,   190,     0,     0,     0,     0,   303,     0,     0,     0,
       0,     0,     0,   632,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,     0,     0,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   187,   188,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,   634,   302,     0,   190,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,   304,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,     0,   218,     0,     0,   219,   220,   221,   222,     0,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
       0,   230,     0,     0,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
     237,   238,   239,     0,     0,     0,   240,     0,   241,   242,
     243,   244,   245,   246,     0,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,     0,   270,
     271,     0,     0,     0,     0,     0,     0,   272,   273,   274,
     275,     0,     0,   276,   277,   278,   279,     0,     0,   280,
       0,     0,   281,   282,     0,   283,     0,   284,   285,     0,
       0,     0,   286,     0,   287,   288,     0,   289,   290,     0,
     291,   292,   293,   187,   188,   189,     0,     0,     0,     0,
       0,   590,   591,   592,     0,   294,     0,   295,   296,     0,
       0,     0,     0,   297,     0,   298,   299,   300,  1249,   302,
       0,   190,     0,     0,     0,     0,   303,     0,   590,   591,
     592,     0,     0,   304,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,     0,     0,     0,   218,     0,     0,
     219,   220,   221,   222,     0,   223,     0,     0,   224,   225,
     226,   227,   228,   229,     0,     0,   230,   590,   591,   592,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   234,   235,   236,   237,   238,   239,     0,     0,
       0,   240,     0,   241,   242,   243,   244,   245,   246,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     0,   270,   271,     0,     0,     0,     0,
       0,     0,   272,   273,   274,   275,     0,     0,   276,   277,
     278,   279,     0,     0,   280,     0,     0,   281,   282,     0,
     283,     0,   284,   285,     0,     0,     0,   286,     0,   287,
     288,     0,   289,   290,     0,   291,   292,   293,   593,   594,
     595,     0,   596,     0,     0,     0,     0,     0,     0,  1351,
     294,     0,   295,   296,     0,     0,     0,     0,   297,     0,
     298,   299,   300,  1353,   302,   593,   594,   595,     0,   596,
       0,   303,     0,     0,     1,     2,  1376,     0,   304,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,     0,    15,    16,    17,    18,    19,    20,    21,     0,
       0,    22,    23,    24,     0,    25,    26,    27,    28,    29,
      30,     0,    31,    32,     0,     0,     0,    33,    34,     0,
       0,     0,     0,     0,   593,   594,   595,     0,   596,     0,
       0,     0,     0,     0,     0,  1389,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    35,    36,     0,     0,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    38,    39,     0,
      40,    41,    42,     0,     0,     0,    43,    44,    45,    46,
      47,    48,    49,    50,    51,     0,     0,     0,     0,     0,
       0,    52,    53,    54,     0,    55,     0,     0,     0,     0,
       0,     0,    56,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    57,     0,     0,    58,
      59,    60,    61,    62,    63,     0,     0,     0,     0,    64,
      65,     0,     0,     0,     0,    66,    67,     0,    68,    69,
       0,     0,    70,     0,    71,     0,     0,    72,     0,     0,
       0,    73,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    74,    75,    76,     0,     0,    77,    78,    79,    80,
      81,    82,    83,     0,    84,     0,     0,     0,     0,     0,
       0,     0,     0,     1,     2,     0,    85,    86,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,     0,
       0,     0,     0,     0,     0,     0,     0,    21,     0,     0,
      22,    23,    24,     0,    25,    26,    27,    28,    29,    30,
       0,   707,    32,     0,     0,     0,    33,    34,     0,   571,
     572,   573,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   571,   572,   573,     0,     0,     0,     0,
      35,    36,   574,   575,   576,     0,    37,     0,     0,     0,
       0,     0,     0,     0,   577,   578,    38,    39,     0,    40,
      41,    42,   571,   572,   573,    43,    44,    45,    46,    47,
      48,    49,    50,    51,     0,     0,     0,     0,   577,   578,
      52,    53,    54,     0,    55,     0,     0,     0,     0,     0,
       0,    56,     0,     0,     0,   574,   575,   576,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   577,   578,     0,
       0,     0,     0,     0,     0,    57,     0,     0,    58,    59,
      60,    61,    62,    63,     0,     0,     0,     0,    64,    65,
     571,   572,   573,     0,    66,    67,     0,    68,    69,     0,
       0,    70,     0,    71,     0,     0,    72,   571,   572,   573,
      73,     0,     0,   579,   580,     0,     0,     0,     0,     0,
      74,    75,    76,   574,   575,   576,     0,    79,     0,     0,
      82,    83,     0,    84,     0,   577,   578,   579,   580,     0,
     574,   575,   576,     0,     0,    85,    86,     0,     0,     0,
       0,     0,   577,   578,     0,     0,   581,   582,   583,   584,
     585,   586,   587,     0,   588,     0,   579,   580,  1137,     0,
       0,  1138,     0,   571,   572,   573,     0,     0,     0,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,     0,
       0,     0,   571,   572,   573,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   574,   575,   576,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   577,   578,
       0,     0,     0,     0,  1215,   574,   575,   576,   571,   572,
     573,     0,     0,     0,   579,   580,     0,   577,   578,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   579,   580,     0,     0,     0,     0,     0,     0,     0,
       0,   574,   575,   576,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   577,   578,     0,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,     0,   571,   572,   573,
       0,     0,  1219,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,     0,   571,   572,   573,     0,  1220,
       0,     0,     0,     0,     0,     0,     0,   579,   580,     0,
     574,   575,   576,     0,   571,   572,   573,     0,     0,     0,
       0,     0,   577,   578,     0,     0,   579,   580,   574,   575,
     576,     0,     0,   571,   572,   573,     0,     0,     0,     0,
     577,   578,     0,     0,     0,     0,     0,   574,   575,   576,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   577,
     578,     0,   579,   580,     0,  1242,   574,   575,   576,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   577,   578,
       0,     0,     0,     0,  1243,     0,     0,     0,     0,     0,
     571,   572,   573,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,     0,   571,   572,   573,     0,     0,
    1244,   579,   580,   574,   575,   576,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   577,   578,     0,     0,   579,
     580,     0,     0,     0,     0,     0,     0,     0,   574,   575,
     576,     0,     0,     0,     0,     0,     0,     0,   579,   580,
     577,   578,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,     0,     0,     0,   579,   580,  1245,
       0,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,     0,     0,     0,     0,     0,     0,  1295,     0,     0,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     571,   572,   573,     0,     0,     0,  1296,     0,     0,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,     0,
       0,   845,   878,     0,   579,   580,     0,     0,     0,     0,
       0,     0,     0,   574,   575,   576,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   577,   578,     0,     0,   579,
     580,     0,     0,     0,     0,     0,   571,   572,   573,     0,
       0,     0,     0,     0,     0,     0,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,     0,     0,   845,   880,
     571,   572,   573,     0,     0,     0,     0,     0,     0,   574,
     575,   576,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   577,   578,   845,   885,     0,     0,     0,   571,   572,
     573,     0,     0,   574,   575,   576,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   577,   578,     0,     0,     0,
       0,     0,   571,   572,   573,     0,     0,     0,     0,     0,
       0,   574,   575,   576,   579,   580,     0,     0,     0,     0,
       0,     0,     0,   577,   578,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   574,   575,   576,     0,   571,
     572,   573,     0,     0,     0,     0,     0,   577,   578,     0,
       0,     0,     0,     0,   571,   572,   573,   581,   582,   583,
     584,   585,   586,   587,     0,   588,     0,     0,   845,   887,
     579,   580,   574,   575,   576,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   577,   578,     0,   574,   575,   576,
       0,     0,     0,     0,   579,   580,     0,     0,     0,   577,
     578,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   579,   580,   845,   889,     0,     0,     0,   571,
     572,   573,     0,     0,     0,     0,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   579,   580,   845,   892,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   574,   575,   576,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   577,   578,   845,   894,     0,     0,
       0,     0,     0,   579,   580,     0,     0,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   579,   580,
     845,   896,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   571,   572,   573,     0,     0,   581,   582,   583,   584,
     585,   586,   587,     0,   588,     0,     0,   845,   898,     0,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
       0,     0,   845,   905,   574,   575,   576,   571,   572,   573,
       0,     0,     0,     0,     0,     0,   577,   578,     0,     0,
       0,     0,     0,   579,   580,     0,     0,     0,     0,     0,
     571,   572,   573,     0,     0,     0,     0,     0,     0,     0,
     574,   575,   576,     0,     0,     0,   571,   572,   573,     0,
       0,     0,   577,   578,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   574,   575,   576,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   577,   578,   845,   907,   574,
     575,   576,     0,     0,     0,     0,   571,   572,   573,     0,
       0,   577,   578,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   571,   572,   573,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   579,   580,     0,     0,   574,
     575,   576,   571,   572,   573,     0,     0,     0,     0,     0,
       0,   577,   578,     0,     0,   574,   575,   576,   571,   572,
     573,     0,     0,     0,     0,     0,     0,   577,   578,     0,
       0,   579,   580,     0,     0,   574,   575,   576,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   577,   578,   845,
     909,   574,   575,   576,   579,   580,     0,     0,     0,     0,
       0,     0,     0,   577,   578,     0,     0,     0,     0,     0,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,     0,   845,   913,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,     0,     0,   845,   915,
     579,   580,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,     0,   845,   917,   579,   580,     0,     0,
       0,     0,     0,   571,   572,   573,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   579,   580,     0,     0,
       0,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   579,   580,   845,   919,   574,   575,   576,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   577,   578,
     845,   922,     0,     0,     0,   571,   572,   573,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,     0,
     845,   924,   571,   572,   573,   581,   582,   583,   584,   585,
     586,   587,     0,   588,     0,     0,   845,   926,   574,   575,
     576,   571,   572,   573,     0,     0,     0,     0,     0,     0,
     577,   578,     0,     0,     0,   574,   575,   576,     0,     0,
       0,   571,   572,   573,     0,     0,     0,   577,   578,     0,
       0,     0,     0,     0,   574,   575,   576,     0,   571,   572,
     573,     0,     0,     0,     0,     0,   577,   578,     0,     0,
       0,     0,     0,     0,   574,   575,   576,   579,   580,     0,
       0,     0,     0,     0,     0,     0,   577,   578,     0,     0,
       0,   574,   575,   576,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   577,   578,     0,     0,     0,     0,     0,
     571,   572,   573,     0,     0,     0,     0,     0,     0,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   579,
     580,   845,   928,     0,     0,     0,   571,   572,   573,     0,
       0,     0,     0,   574,   575,   576,   579,   580,     0,     0,
       0,     0,     0,     0,     0,   577,   578,     0,     0,     0,
       0,     0,     0,     0,     0,   579,   580,     0,     0,   574,
     575,   576,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   577,   578,   845,   932,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,     0,
     845,   934,   579,   580,     0,     0,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,     0,   845,
     937,     0,     0,     0,     0,   571,   572,   573,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,     0,   845,
     948,   571,   572,   573,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   579,   580,   845,  1063,   574,   575,
     576,   571,   572,   573,     0,     0,     0,     0,     0,     0,
     577,   578,     0,     0,   574,   575,   576,     0,     0,     0,
     579,   580,     0,     0,     0,     0,   577,   578,     0,     0,
       0,     0,     0,     0,   574,   575,   576,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   577,   578,   845,  1064,
       0,     0,     0,   571,   572,   573,     0,     0,     0,     0,
       0,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,     0,   845,  1065,     0,     0,   571,   572,
     573,     0,     0,     0,     0,     0,   574,   575,   576,     0,
       0,     0,     0,     0,   571,   572,   573,     0,   577,   578,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   579,
     580,   574,   575,   576,     0,     0,   571,   572,   573,     0,
       0,     0,     0,   577,   578,   579,   580,   574,   575,   576,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   577,
     578,     0,     0,     0,     0,   579,   580,     0,     0,   574,
     575,   576,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   577,   578,   845,  1066,     0,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,     0,  1344,
    1345,   571,   572,   573,     0,     0,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   579,   580,     0,
     603,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   574,   575,   576,     0,   571,   572,
     573,     0,   579,   580,     0,     0,   577,   578,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   579,   580,
     581,   582,   583,   584,   585,   586,   587,     0,   588,     0,
       0,   574,   605,     0,     0,     0,     0,     0,     0,     0,
     579,   580,     0,   577,   578,   581,   582,   583,   584,   585,
     586,   587,     0,   588,     0,     0,     0,   610,     0,     0,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
       0,     0,     0,   612,   571,   572,   573,     0,     0,     0,
       0,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   571,   572,   573,   614,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   579,   580,   574,   575,   576,
       0,     0,   571,   572,   573,     0,     0,     0,     0,   577,
     578,     0,     0,     0,     0,   574,   575,   576,     0,     0,
     571,   572,   573,     0,     0,     0,     0,   577,   578,     0,
       0,     0,   579,   580,     0,   574,   575,   576,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   577,   578,     0,
     617,     0,     0,   574,   575,   576,     0,     0,   571,   572,
     573,     0,     0,     0,     0,   577,   578,     0,     0,     0,
       0,     0,   571,   572,   573,   581,   582,   583,   584,   585,
     586,   587,     0,   588,     0,     0,   571,   572,   573,     0,
       0,   574,   575,   576,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   577,   578,   574,   575,   576,   579,   580,
       0,     0,     0,     0,     0,     0,     0,   577,   578,   574,
     575,   576,     0,     0,     0,     0,   579,   580,     0,     0,
       0,   577,   578,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   579,   580,     0,     0,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
       0,     0,     0,   619,   579,   580,     0,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,     0,
       0,   621,     0,     0,     0,     0,     0,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,     0,
       0,   625,   579,   580,     0,     0,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   579,   580,     0,   636,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     579,   580,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   571,   572,   573,   638,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   571,   572,
     573,   640,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   571,   572,   573,   644,     0,   574,   575,   576,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   577,
     578,   574,   575,   576,     0,     0,   571,   572,   573,     0,
       0,     0,     0,   577,   578,   574,   575,   576,     0,     0,
     571,   572,   573,     0,     0,     0,     0,   577,   578,     0,
       0,     0,     0,     0,   571,   572,   573,     0,     0,   574,
     575,   576,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   577,   578,   574,   575,   576,     0,     0,   571,   572,
     573,     0,     0,     0,     0,   577,   578,   574,   575,   576,
       0,     0,   571,   572,   573,     0,     0,     0,     0,   577,
     578,     0,     0,     0,     0,     0,   571,   572,   573,     0,
       0,   574,   575,   576,     0,     0,     0,     0,   579,   580,
       0,     0,     0,   577,   578,   574,   575,   576,     0,     0,
       0,     0,   579,   580,     0,     0,     0,   577,   578,   574,
     575,   576,     0,     0,     0,     0,   579,   580,     0,     0,
       0,   577,   578,     0,     0,     0,     0,     0,     0,     0,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     579,   580,     0,   646,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   579,   580,     0,   648,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   579,   580,
       0,   650,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   579,   580,     0,   651,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   579,   580,     0,   653,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     579,   580,     0,   657,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   571,   572,   573,   662,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   571,   572,
     573,   665,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   571,   572,   573,   668,     0,   574,   575,   576,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   577,
     578,   574,   575,   576,     0,     0,   571,   572,   573,     0,
       0,     0,     0,   577,   578,   574,   575,   576,     0,     0,
     571,   572,   573,     0,     0,     0,     0,   577,   578,     0,
       0,     0,     0,     0,   571,   572,   573,     0,     0,   574,
     575,   576,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   577,   578,   574,   575,   576,     0,     0,   571,   572,
     573,     0,     0,     0,     0,   577,   578,   574,   575,   576,
       0,     0,   571,   572,   573,     0,     0,     0,     0,   577,
     578,     0,     0,     0,     0,     0,   571,   572,   573,     0,
       0,   574,   575,   576,     0,     0,     0,     0,   579,   580,
       0,     0,     0,   577,   578,   574,   575,   576,     0,     0,
       0,     0,   579,   580,     0,     0,     0,   577,   578,   574,
     575,   576,     0,     0,     0,     0,   579,   580,     0,     0,
       0,   577,   578,     0,     0,     0,     0,     0,     0,     0,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     579,   580,     0,   674,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   579,   580,     0,   685,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   579,   580,
       0,   884,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   579,   580,     0,   962,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   579,   580,     0,   963,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     579,   580,     0,   998,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   571,   572,   573,   999,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   571,   572,
     573,  1048,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   571,   572,   573,  1050,     0,   574,   575,   576,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   577,
     578,   574,   575,   576,     0,     0,   571,   572,   573,     0,
       0,     0,     0,   577,   578,   574,   575,   576,     0,     0,
     571,   572,   573,     0,     0,     0,     0,   577,   578,     0,
       0,     0,     0,     0,   571,   572,   573,     0,     0,   574,
     575,   576,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   577,   578,   574,   575,   576,     0,     0,   571,   572,
     573,     0,     0,     0,     0,   577,   578,   574,   575,   576,
       0,     0,   571,   572,   573,     0,     0,     0,     0,   577,
     578,     0,     0,     0,     0,     0,   571,   572,   573,     0,
       0,   574,   575,   576,     0,     0,     0,     0,   579,   580,
       0,     0,     0,   577,   578,   574,   575,   576,     0,     0,
       0,     0,   579,   580,     0,     0,     0,   577,   578,   574,
     575,   576,     0,     0,     0,     0,   579,   580,     0,     0,
       0,   577,   578,     0,     0,     0,     0,     0,     0,     0,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     579,   580,     0,  1053,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   579,   580,     0,  1055,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   579,   580,
       0,  1062,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   579,   580,     0,  1070,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   579,   580,     0,  1072,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     579,   580,     0,  1074,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   571,   572,   573,  1076,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   571,   572,
     573,  1080,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   571,   572,   573,  1081,     0,   574,   575,   576,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   577,
     578,   574,   575,   576,     0,     0,   571,   572,   573,     0,
       0,     0,     0,   577,   578,   574,   575,   576,     0,     0,
     571,   572,   573,     0,     0,     0,     0,   577,   578,     0,
       0,     0,     0,     0,   571,   572,   573,     0,     0,   574,
     575,   576,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   577,   578,   574,   575,   576,     0,     0,   571,   572,
     573,     0,     0,     0,     0,   577,   578,   574,   575,   576,
       0,     0,   571,   572,   573,     0,     0,     0,     0,   577,
     578,     0,     0,     0,     0,     0,   571,   572,   573,     0,
       0,   574,   575,   576,     0,     0,     0,     0,   579,   580,
       0,     0,     0,   577,   578,   574,   575,   576,     0,     0,
       0,     0,   579,   580,     0,     0,     0,   577,   578,   574,
     575,   576,     0,     0,     0,     0,   579,   580,     0,     0,
       0,   577,   578,     0,     0,     0,     0,     0,     0,     0,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     579,   580,     0,  1083,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   579,   580,     0,  1151,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   579,   580,
       0,  1153,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   579,   580,     0,  1155,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   579,   580,     0,  1159,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     579,   580,     0,  1166,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   571,   572,   573,  1174,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   571,   572,
     573,  1177,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   571,   572,   573,  1179,     0,   574,   575,   576,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   577,
     578,   574,   575,   576,     0,     0,   571,   572,   573,     0,
       0,     0,     0,   577,   578,   574,   575,   576,     0,     0,
     571,   572,   573,     0,     0,     0,     0,   577,   578,     0,
       0,     0,     0,     0,   571,   572,   573,     0,     0,   574,
     575,   576,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   577,   578,   574,   575,   576,     0,     0,   571,   572,
     573,     0,     0,     0,     0,   577,   578,   574,   575,   576,
       0,     0,   571,   572,   573,     0,     0,     0,     0,   577,
     578,     0,     0,     0,     0,     0,   571,   572,   573,     0,
       0,   574,   575,   576,     0,     0,     0,     0,   579,   580,
       0,     0,     0,   577,   578,   574,   575,   576,     0,     0,
       0,     0,   579,   580,     0,     0,     0,   577,   578,   574,
     575,   576,     0,     0,     0,     0,   579,   580,     0,     0,
       0,   577,   578,     0,     0,     0,     0,     0,     0,     0,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     579,   580,     0,  1181,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   579,   580,     0,  1184,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   579,   580,
       0,  1186,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   579,   580,     0,  1189,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   579,   580,     0,  1222,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     579,   580,     0,  1223,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   571,   572,   573,  1230,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   571,   572,
     573,  1248,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   571,   572,   573,  1251,     0,   574,   575,   576,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   577,
     578,   574,   575,   576,     0,     0,   571,   572,   573,     0,
       0,     0,     0,   577,   578,   574,   575,   576,     0,     0,
     571,   572,   573,     0,     0,     0,     0,   577,   578,     0,
       0,     0,     0,     0,   571,   572,   573,     0,     0,   574,
     575,   576,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   577,   578,   574,   575,   576,     0,     0,   571,   572,
     573,     0,     0,     0,     0,   577,   578,   574,   575,   576,
       0,     0,   571,   572,   573,     0,     0,     0,     0,   577,
     578,     0,     0,     0,     0,     0,   571,   572,   573,     0,
       0,   574,   575,   576,     0,     0,     0,     0,   579,   580,
       0,     0,     0,   577,   578,   574,   575,   576,     0,     0,
       0,     0,   579,   580,     0,     0,     0,   577,   578,   574,
     575,   576,     0,     0,     0,     0,   579,   580,     0,     0,
       0,   577,   578,     0,     0,     0,     0,     0,     0,     0,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     579,   580,     0,  1253,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   579,   580,     0,  1267,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   579,   580,
       0,  1270,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   579,   580,     0,  1300,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   579,   580,     0,  1303,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     579,   580,     0,  1307,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   571,   572,   573,  1317,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   571,   572,
     573,  1322,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   571,   572,   573,  1347,     0,   574,   575,   576,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   577,
     578,   574,   575,   576,     0,     0,   571,   572,   573,     0,
       0,     0,     0,   577,   578,   574,   575,   576,     0,     0,
     571,   572,   573,     0,     0,     0,     0,   577,   578,     0,
       0,     0,     0,     0,   571,   572,   573,     0,     0,   574,
     575,   576,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   577,   578,   574,   575,   576,     0,     0,   571,   572,
     573,     0,     0,     0,     0,   577,   578,   574,   575,   576,
       0,     0,   571,   572,   573,     0,     0,     0,     0,   577,
     578,     0,     0,     0,     0,     0,   571,   572,   573,     0,
       0,   574,   575,   576,     0,     0,     0,     0,   579,   580,
       0,     0,     0,   577,   578,   574,   575,   576,     0,     0,
       0,     0,   579,   580,     0,     0,     0,   577,   578,   574,
     575,   576,     0,     0,     0,     0,   579,   580,     0,     0,
       0,   577,   578,     0,     0,     0,     0,     0,     0,     0,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     579,   580,     0,  1355,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   579,   580,     0,  1360,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   579,   580,
       0,  1362,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   579,   580,     0,  1370,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   579,   580,     0,  1375,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     579,   580,     0,  1378,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,     0,     0,   845,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,     0,
     964,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,     0,   965,   571,   572,   573,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   571,
     572,   573,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   571,   572,   573,     0,     0,   574,   575,
     576,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     577,   578,   574,   575,   576,     0,     0,   571,   572,   573,
       0,     0,     0,     0,   577,   578,   574,   575,   576,     0,
       0,   571,   572,   573,     0,     0,     0,     0,   577,   578,
       0,     0,     0,     0,     0,   571,   572,   573,     0,     0,
     574,   575,   576,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   577,   578,   574,   575,   576,     0,     0,   571,
     572,   573,     0,     0,     0,     0,   577,   578,   574,   575,
     576,     0,     0,   571,   572,   573,     0,     0,     0,     0,
     577,   578,     0,     0,     0,     0,     0,   571,   572,   573,
       0,     0,   574,   575,   576,     0,     0,     0,     0,   579,
     580,     0,     0,     0,   577,   578,   574,   575,   576,     0,
       0,     0,     0,   579,   580,     0,     0,     0,   577,   578,
     574,   575,   576,     0,     0,     0,     0,   579,   580,     0,
       0,     0,   577,   578,     0,     0,     0,     0,     0,     0,
       0,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   579,   580,   967,     0,     0,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   579,   580,   976,     0,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   579,
     580,   977,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   579,   580,   978,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   579,   580,   979,
       0,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   579,   580,   980,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   581,   582,   583,   584,
     585,   586,   587,     0,   588,     0,     0,   981,     0,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,     0,
       0,   982,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,     0,   983,   571,   572,   573,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     571,   572,   573,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   571,   572,   573,     0,     0,   574,
     575,   576,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   577,   578,   574,   575,   576,     0,     0,   571,   572,
     573,     0,     0,     0,     0,   577,   578,   574,   575,   576,
       0,     0,   571,   572,   573,     0,     0,     0,     0,   577,
     578,     0,     0,     0,     0,     0,   571,   572,   573,     0,
       0,   574,   575,   576,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   577,   578,   574,   575,   576,     0,     0,
     571,   572,   573,     0,     0,     0,     0,   577,   578,   574,
     575,   576,     0,     0,   571,   572,   573,     0,     0,     0,
       0,   577,   578,     0,     0,     0,     0,     0,   571,   572,
     573,     0,     0,   574,   575,   576,     0,     0,     0,     0,
     579,   580,     0,     0,     0,   577,   578,   574,   575,   576,
       0,     0,     0,     0,   579,   580,     0,     0,     0,   577,
     578,   574,   575,   576,     0,     0,     0,     0,   579,   580,
       0,     0,     0,   577,   578,     0,     0,     0,     0,     0,
       0,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   579,   580,   984,     0,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   579,   580,   985,     0,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     579,   580,   986,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   579,   580,   987,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   579,   580,
     988,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   579,   580,   989,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,     0,     0,   990,     0,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
       0,     0,   992,     0,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,     0,     0,   993,   571,   572,   573,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   571,   572,   573,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   571,   572,   573,     0,     0,
     574,   575,   576,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   577,   578,   574,   575,   576,     0,     0,   571,
     572,   573,     0,     0,     0,     0,   577,   578,   574,   575,
     576,     0,     0,   571,   572,   573,     0,     0,     0,     0,
     577,   578,     0,     0,     0,     0,     0,   571,   572,   573,
       0,     0,   574,   575,   576,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   577,   578,   574,   575,   576,     0,
       0,   571,   572,   573,     0,     0,     0,     0,   577,   578,
     574,   575,   576,     0,     0,   571,   572,   573,     0,     0,
       0,     0,   577,   578,     0,     0,     0,     0,     0,   571,
     572,   573,     0,     0,   574,   575,   576,     0,     0,     0,
       0,   579,   580,     0,     0,     0,   577,   578,   574,   575,
     576,     0,     0,     0,     0,   579,   580,     0,     0,     0,
     577,   578,   574,   575,   576,     0,     0,     0,     0,   579,
     580,     0,     0,     0,   577,   578,     0,     0,     0,     0,
       0,     0,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   579,   580,   995,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   579,   580,   996,
       0,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   579,   580,  1000,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   579,   580,  1001,     0,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   579,
     580,  1002,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   579,   580,  1003,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,     0,  1004,
       0,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,     0,     0,  1005,     0,     0,   581,   582,   583,   584,
     585,   586,   587,     0,   588,     0,     0,  1008,   571,   572,
     573,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   571,   572,   573,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   571,   572,   573,     0,
       0,   574,   575,   576,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   577,   578,   574,   575,   576,     0,     0,
     571,   572,   573,     0,     0,     0,     0,   577,   578,   574,
     575,   576,     0,     0,   571,   572,   573,     0,     0,     0,
       0,   577,   578,     0,     0,     0,     0,     0,   571,   572,
     573,     0,     0,   574,   575,   576,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   577,   578,   574,   575,   576,
       0,     0,   571,   572,   573,     0,     0,     0,     0,   577,
     578,   574,   575,   576,     0,     0,   571,   572,   573,     0,
       0,     0,     0,   577,   578,     0,     0,     0,     0,     0,
     571,   572,   573,     0,     0,   574,   575,   576,     0,     0,
       0,     0,   579,   580,     0,     0,     0,   577,   578,   574,
     575,   576,     0,     0,     0,     0,   579,   580,     0,     0,
       0,   577,   578,   574,   575,   576,     0,     0,     0,     0,
     579,   580,     0,     0,     0,   577,   578,     0,     0,     0,
       0,     0,     0,     0,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   579,   580,  1009,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   579,   580,
    1010,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   579,   580,  1011,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   579,   580,  1012,     0,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     579,   580,  1015,     0,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   579,   580,  1024,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,     0,
    1150,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,     0,  1161,     0,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,     0,     0,  1172,   571,
     572,   573,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   571,   572,   573,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   571,   572,   573,
       0,     0,   574,   575,   576,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   577,   578,   574,   575,   576,     0,
       0,   571,   572,   573,     0,     0,     0,     0,   577,   578,
     574,   575,   576,     0,     0,   571,   572,   573,     0,     0,
       0,     0,   577,   578,     0,     0,     0,     0,     0,   571,
     572,   573,     0,     0,   574,   575,   576,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   577,   578,   574,   575,
     576,     0,     0,   571,   572,   573,     0,     0,     0,     0,
     577,   578,   574,   575,   576,     0,     0,   571,   572,   573,
       0,     0,     0,     0,   577,   578,     0,     0,     0,     0,
       0,   571,   572,   573,     0,     0,   574,   575,   576,     0,
       0,     0,     0,   579,   580,     0,     0,     0,   577,   578,
     574,   575,   576,     0,     0,     0,     0,   579,   580,     0,
       0,     0,   577,   578,   574,   575,   576,     0,     0,     0,
       0,   579,   580,     0,     0,     0,   577,   578,     0,     0,
       0,     0,     0,     0,     0,     0,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   579,   580,  1191,     0,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   579,
     580,  1192,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   579,   580,  1194,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   579,   580,  1200,
       0,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   579,   580,  1202,     0,     0,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   579,   580,  1221,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,     0,
       0,  1224,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,     0,  1225,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,     0,  1231,
     571,   572,   573,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   571,   572,   573,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   571,   572,
     573,     0,     0,   574,   575,   576,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   577,   578,   574,   575,   576,
       0,     0,   571,   572,   573,     0,     0,     0,     0,   577,
     578,   574,   575,   576,     0,     0,   571,   572,   573,     0,
       0,     0,     0,   577,   578,     0,     0,     0,     0,     0,
     571,   572,   573,     0,     0,   574,   575,   576,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   577,   578,   574,
     575,   576,     0,     0,   571,   572,   573,     0,     0,     0,
       0,   577,   578,   574,   575,   576,     0,     0,   571,   572,
     573,     0,     0,     0,     0,   577,   578,     0,     0,     0,
       0,     0,   571,   572,   573,     0,     0,   574,   575,   576,
       0,     0,     0,     0,   579,   580,     0,     0,     0,   577,
     578,   574,   575,   576,     0,     0,     0,     0,   579,   580,
       0,     0,     0,   577,   578,   574,   575,   576,     0,     0,
       0,     0,   579,   580,     0,     0,     0,   577,   578,     0,
       0,     0,     0,     0,     0,     0,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   579,   580,  1256,     0,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     579,   580,  1257,     0,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   579,   580,  1258,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   579,   580,
    1259,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   579,   580,  1299,     0,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   579,   580,  1310,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
       0,     0,  1311,     0,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,     0,     0,  1313,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,     0,
    1321,   571,   572,   573,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   571,   572,   573,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   571,
     572,   573,     0,     0,   574,   575,   576,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   577,   578,   574,   575,
     576,     0,     0,   571,   572,   573,     0,     0,     0,     0,
     577,   578,   574,   575,   576,     0,     0,   571,   572,   573,
       0,     0,     0,     0,   577,   578,     0,     0,     0,     0,
       0,   571,   572,   573,     0,     0,   574,   575,   576,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   577,   578,
     574,   575,   576,     0,     0,   571,   572,   573,     0,     0,
       0,     0,   577,   578,   574,   575,   576,     0,     0,   571,
     572,   573,     0,     0,     0,     0,   577,   578,     0,     0,
       0,     0,     0,   571,   572,   573,     0,     0,   574,   575,
     576,     0,     0,     0,     0,   579,   580,     0,     0,     0,
     577,   578,   574,   575,   576,     0,     0,     0,     0,   579,
     580,     0,     0,     0,   577,   578,   574,   575,   576,     0,
       0,     0,     0,   579,   580,     0,     0,     0,   577,   578,
       0,     0,     0,     0,     0,     0,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   579,   580,  1324,
       0,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   579,   580,  1325,     0,     0,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   579,   580,  1342,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   579,
     580,  1343,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   579,   580,  1346,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   579,   580,  1350,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,     0,     0,  1368,     0,     0,   581,   582,   583,   584,
     585,   586,   587,     0,   588,     0,     0,  1373,     0,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,     0,
       0,  1374,   571,   572,   573,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   571,   572,   573,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     571,   572,   573,     0,     0,   574,   575,   576,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   577,   578,   574,
     575,   576,     0,     0,   571,   572,   573,     0,     0,     0,
       0,   577,   578,   574,   575,   576,     0,     0,   571,   572,
     573,     0,     0,     0,     0,   577,   578,     0,     0,     0,
       0,     0,   571,   572,   573,     0,     0,   574,   575,   576,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   577,
     578,   574,   575,   576,     0,     0,   571,   572,   573,     0,
       0,     0,     0,   577,   578,   574,   575,   576,     0,     0,
     571,   572,   573,     0,     0,     0,     0,   577,   578,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   574,
     575,   576,     0,     0,     0,     0,   579,   580,     0,     0,
       0,   577,   578,   574,   575,     0,     0,     0,     0,     0,
     579,   580,     0,     0,     0,   577,   578,     0,     0,     0,
       0,     0,     0,     0,   579,   580,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   579,   580,
    1380,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   579,   580,  1381,     0,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   579,   580,  1382,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     579,   580,  1383,     0,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   579,   580,  1384,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,     0,
    1390,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,     0,     0,     0,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-664))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       1,    36,     3,     4,     5,   216,     7,     8,   225,    10,
     566,    19,   225,    14,   677,    23,    17,    88,    89,    20,
     683,   232,    23,    24,    25,    26,    27,    43,    44,    45,
     247,    32,   214,   215,    35,    36,    37,    38,   424,    40,
     426,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,   225,   226,   216,    55,   214,   215,    58,   240,   241,
     240,   225,   244,   216,   244,    66,    67,    68,    69,   232,
     225,    72,   240,    74,    75,    76,    88,    89,    79,   232,
     239,   244,   225,    84,   243,     3,     4,    43,    44,    45,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,   240,    21,    22,    23,    24,    25,    26,    27,
     240,   225,    30,    31,    32,   240,    34,    35,    36,    37,
      38,    39,   240,    41,    42,   681,   240,   225,    46,    47,
     239,   240,     0,   247,   243,   244,   214,   215,   216,   217,
     218,   219,    43,    44,    45,   239,   239,   214,   215,   243,
     243,    88,    89,   225,   232,   214,   215,   225,   226,    43,
      44,    45,    80,    81,   235,   236,   244,   238,    86,   242,
     225,   226,   245,   240,   241,   187,   188,   244,    96,    97,
     239,    99,   100,   101,   243,   225,   226,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   242,   205,   225,   245,
     208,   239,   120,   121,   122,    20,   124,   243,    43,    44,
      45,   225,   226,   131,   230,   231,   232,   218,   234,   225,
     226,   233,   234,   235,   236,   242,   238,   240,   214,   215,
     246,    43,    44,    45,   225,   226,   240,   155,   241,   242,
     158,   159,   160,   161,   162,   163,   240,   214,   215,   232,
     168,   169,   241,   242,   240,   241,   174,   175,   244,   177,
     178,   220,   240,   181,   240,   183,   225,   226,   186,    43,
      44,    45,   190,   240,   230,   231,   232,   244,   234,   241,
     242,   225,   200,   201,   202,   286,   242,   205,   206,   207,
     208,   209,   210,   211,   240,   213,   233,   234,   235,   236,
     240,   238,   303,   304,   225,   241,   242,   225,   226,   240,
     311,   229,   240,   314,   240,   316,   241,   242,   240,   320,
     240,   322,   225,   324,   240,   326,    43,    44,    45,   230,
     231,   232,   333,   234,   240,   336,   241,   242,   339,   220,
     241,   342,   240,   344,   225,   226,   230,   231,   232,   240,
     234,   352,   240,   354,   355,   356,   357,   241,   242,   360,
     241,   240,   363,   214,   215,   366,   240,   368,   214,   215,
     214,   215,   241,   374,   240,   376,   240,   240,   379,   240,
     381,   240,   240,   240,   240,   386,   240,   240,   239,   240,
     391,   240,   243,   244,   241,   230,   231,   232,   240,   234,
     240,   402,   240,   404,   240,   440,   407,   242,   443,   410,
     240,   412,   240,   414,   240,   416,   240,   418,   230,   231,
     232,   240,   234,   214,   215,   216,   217,   218,   219,   241,
     242,   432,   240,   240,   240,   436,   437,   438,   439,   440,
     441,   232,   443,   444,   240,   240,   240,   240,   240,   238,
     240,   452,   453,   454,   455,   456,   230,   231,   232,   240,
     234,   240,   214,   215,   465,   466,   241,   468,   469,   470,
     471,   472,   473,   474,  1030,   476,   477,   478,   479,   480,
     481,   214,   215,   484,   485,   486,   487,   239,   240,   240,
     240,   243,   244,   214,   215,   240,   497,   498,   499,   500,
     501,   502,   503,   504,   240,   240,   239,   240,   240,   240,
     243,   244,   240,   230,   231,   232,   240,   234,   239,   240,
     240,   240,   243,   244,   241,   242,    43,    44,    45,   214,
     215,   216,   217,   218,   219,   240,   537,   538,   539,    43,
      44,    45,   240,   544,   545,   240,   240,   232,   549,   240,
     240,   240,    43,    44,    45,   241,   240,   558,    43,    44,
      45,   240,   240,   564,   565,   566,   567,   240,   240,   240,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,    43,    44,
      45,   240,   240,   240,   240,   596,   240,   598,   599,   240,
     601,   240,   603,   240,   605,    43,    44,    45,   240,   610,
     240,   612,   240,   614,   615,   240,   240,   240,   240,   240,
     240,    76,    77,    78,   625,   626,   240,   628,   240,   630,
     240,   632,   240,    88,    89,   636,   240,   240,    28,   640,
     240,   642,   240,   644,   240,   646,   240,   240,    29,   650,
     651,   240,   653,    43,    44,    45,   657,   240,   240,   240,
     240,   662,    43,    44,    45,   666,   241,   240,   240,   240,
     244,   248,   242,   674,   241,   241,   241,    43,    44,    45,
     681,   241,   241,   241,   685,   241,    76,    77,    78,   241,
     241,   692,   241,   241,   241,    76,    77,    78,    88,    89,
     241,   241,    43,    44,    45,   241,   241,    88,    89,   241,
      76,    77,    78,   230,   231,   232,   241,   234,    43,    44,
      45,   241,    88,    89,   241,   242,   230,   231,   232,   241,
     234,   241,   187,   188,   241,   241,   241,   241,   242,   230,
     231,   232,   241,   234,   241,   230,   231,   232,   241,   234,
     241,   242,    43,    44,    45,   241,   241,   242,   241,   241,
     241,   241,   241,   241,   241,   241,   241,    43,    44,    45,
     241,   241,   241,   241,   241,   230,   231,   232,   233,   234,
     235,   236,   241,   238,   241,    43,    44,    45,   241,   241,
     241,   246,   230,   231,   232,   241,   234,   187,   188,   244,
     241,   240,   244,   241,   242,   240,   187,   188,   240,   240,
     244,   241,    43,    44,    45,   241,   249,   234,    76,    77,
      78,   187,   188,   241,   249,    43,    44,    45,   829,   830,
      88,    89,    43,    44,    45,   241,   248,   245,   245,   242,
     230,   231,   232,   233,   234,   235,   236,   245,   238,   230,
     231,   232,   233,   234,   235,   236,   245,   238,   225,   241,
     446,    90,   449,   448,   230,   231,   232,   233,   234,   235,
     236,  1103,   238,   884,   443,   876,   242,   878,    -1,   880,
      -1,    -1,    -1,   884,   885,    -1,   887,    -1,   889,   230,
     231,   232,    -1,   234,    -1,    -1,    -1,   898,    -1,    -1,
     241,   242,    -1,    -1,   905,   230,   231,   232,   909,   234,
     911,    -1,   913,    -1,   915,    -1,   917,   242,   919,    -1,
      -1,   922,    -1,   924,    -1,   926,    -1,    -1,   929,   187,
     188,    43,    44,    45,    -1,    -1,   937,    -1,    -1,   230,
     231,   232,    -1,   234,    43,    44,    45,   948,    -1,    -1,
     241,   242,    -1,   954,   230,   231,   232,   958,   234,   960,
     961,   962,   963,    -1,    -1,   241,   242,    -1,   969,   970,
     971,    -1,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,    -1,    -1,    -1,   242,    -1,    -1,   245,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   998,   999,   230,
     231,   232,    -1,   234,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   242,   230,   231,   232,    -1,   234,    -1,  1053,   230,
     231,   232,    -1,   234,   242,    -1,    43,    44,    45,  1030,
      -1,   242,    -1,  1034,    -1,    -1,    -1,    -1,    -1,  1040,
      -1,  1042,    -1,  1044,    43,    44,    45,  1048,    -1,  1050,
      -1,    -1,  1053,    -1,  1055,    -1,  1057,    43,    44,    45,
      -1,  1062,  1063,  1064,  1065,  1066,    -1,    -1,    -1,  1070,
      -1,  1072,    -1,    -1,    -1,  1076,    -1,    -1,    -1,  1080,
    1081,    -1,  1083,    -1,    -1,    -1,    -1,  1088,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    43,    44,    45,    -1,    -1,  1107,  1108,  1109,  1110,
    1111,    -1,    -1,    -1,    -1,  1116,    -1,    -1,   230,   231,
     232,    -1,   234,    -1,    43,    44,    45,    -1,    -1,    -1,
     242,   230,   231,   232,  1135,   234,  1137,    -1,    -1,     1,
       2,    -1,    -1,   242,    -1,    -1,    43,    44,    45,    -1,
    1151,    -1,  1153,    -1,  1155,    -1,    -1,    -1,  1159,    -1,
      -1,    23,    24,    25,    -1,  1166,    43,    44,    45,    -1,
      -1,    -1,    -1,  1174,    -1,    37,  1177,    39,    40,    41,
    1181,    -1,    -1,  1184,    -1,  1186,    -1,    -1,  1189,    -1,
      52,    -1,  1193,    -1,    -1,    57,    -1,    59,    -1,    61,
      62,    43,    44,    45,    -1,    67,    68,    -1,    70,    71,
      -1,    73,    -1,   230,   231,   232,  1251,   234,    -1,    -1,
      -1,  1222,  1223,    -1,    -1,   242,  1227,    -1,  1229,  1230,
      -1,   230,   231,   232,  1235,   234,    -1,    43,    44,    45,
      -1,    -1,    -1,   242,   230,   231,   232,  1248,   234,    -1,
    1251,    -1,  1253,  1254,    -1,    -1,   242,    43,    44,    45,
      -1,    -1,    -1,  1264,    -1,    -1,  1267,    -1,    -1,  1270,
      76,    77,    78,    -1,    -1,    -1,    -1,  1278,  1279,  1280,
    1281,  1282,    88,    89,    -1,  1286,    -1,    -1,   230,   231,
     232,    -1,   234,    -1,    -1,    -1,    43,    44,    45,  1300,
     242,    -1,  1303,    -1,    -1,    -1,  1307,    -1,    -1,    -1,
      -1,   230,   231,   232,  1315,   234,  1317,    -1,    -1,    -1,
    1355,  1322,    -1,   242,    -1,    -1,    -1,  1328,    -1,    76,
      77,    78,    -1,   230,   231,   232,  1337,   234,    -1,    -1,
      -1,    88,    89,    -1,  1345,   242,  1347,    -1,  1349,    -1,
      43,    44,    45,   230,   231,   232,    -1,   234,    -1,    -1,
      -1,  1362,    -1,    -1,    -1,   242,    -1,    -1,    -1,    -1,
      -1,    43,    44,    45,    -1,    -1,    -1,  1378,    -1,    -1,
      -1,   187,   188,    -1,    -1,    -1,    -1,    -1,   230,   231,
     232,    -1,   234,    -1,    -1,    43,    44,    45,    -1,    -1,
     242,    -1,    -1,    -1,    76,    77,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    88,    89,    -1,    43,
      44,    45,    -1,    -1,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,    -1,    -1,    -1,   242,    -1,    -1,   245,
     187,   188,   304,    -1,   230,   231,   232,    -1,   234,   311,
      -1,    -1,   314,    -1,   316,    -1,   242,    -1,    -1,    -1,
     322,    -1,   324,    -1,   326,    43,    44,    45,    -1,    -1,
      -1,   333,    -1,    -1,   336,    -1,    -1,   339,    -1,    -1,
     342,    -1,   344,   230,   231,   232,   233,   234,   235,   236,
     352,   238,    -1,    -1,   241,   242,    -1,    -1,   360,    -1,
      -1,   363,    -1,    -1,   366,    -1,   368,    43,    44,    45,
      -1,    -1,   374,    -1,   376,   187,   188,   379,    -1,   381,
      43,    44,    45,    -1,   386,    43,    44,    45,    -1,   391,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,   231,   232,
     402,   234,   404,    -1,    -1,   407,    -1,    -1,   410,   242,
     412,    -1,   414,    -1,   416,    -1,   418,    -1,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,    -1,    -1,    -1,
     432,    -1,    -1,   245,    43,    44,    45,    -1,   440,    -1,
     442,   443,   230,   231,   232,    -1,   234,    -1,    -1,    -1,
      -1,    -1,    -1,   455,   242,   457,   458,   459,   460,   461,
     462,   463,   464,    43,    44,    45,   230,   231,   232,    -1,
     234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,
      -1,   483,    -1,   485,    -1,    -1,    -1,    -1,    -1,    43,
      44,    45,   494,    -1,    -1,    -1,    76,    77,    78,    -1,
      -1,    -1,    -1,   505,    -1,    -1,    -1,    -1,    88,    89,
      -1,    -1,   230,   231,   232,    -1,   234,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   535,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   547,   548,    -1,    -1,   551,
     552,   553,   554,    -1,   230,   231,   232,    -1,   234,    -1,
      -1,    -1,   564,    -1,   566,    -1,   242,   230,   231,   232,
      -1,   234,   230,   231,   232,    -1,   234,    -1,    -1,   242,
      -1,    -1,    -1,   585,   242,    -1,    -1,    -1,   590,   591,
     592,   593,   594,   595,   596,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   187,   188,    -1,
      -1,    -1,    -1,    -1,    -1,   617,    -1,   619,    -1,   621,
      -1,   230,   231,   232,   626,   234,   628,    -1,   630,    -1,
     632,    -1,    -1,   242,    -1,    -1,   638,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   648,     5,     6,     7,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,    -1,
      -1,    -1,   242,   665,    -1,   245,   668,    -1,    -1,    -1,
     672,    -1,    -1,    -1,   676,    33,   230,   231,   232,   681,
     234,    -1,    43,    44,    45,    -1,    -1,    -1,   242,    -1,
     692,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    -1,    -1,
      -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,    87,
      -1,    -1,    90,    91,    92,    93,    94,    95,    -1,    -1,
      98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,   117,
     118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,    -1,   156,   157,
      -1,    -1,    43,    44,    45,    -1,   164,   165,   166,   167,
      -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,    -1,
      -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,    -1,
      -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,   197,
     198,   199,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,    43,
      44,    45,   220,    -1,   222,   223,   224,   225,   226,   230,
     231,   232,    -1,   234,    -1,   233,    76,    77,    78,    -1,
     241,    -1,   240,    -1,   242,    -1,    -1,    -1,    88,    89,
     892,   249,   894,    -1,   896,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   907,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   917,    -1,    43,    44,    45,
      -1,    -1,    -1,    -1,    -1,    -1,   928,    -1,    -1,    -1,
     932,    -1,   934,   935,    43,    44,    45,   939,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   950,   951,
      43,    44,    45,    -1,   956,   957,    -1,    -1,    -1,    43,
      44,    45,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,
      -1,    -1,   974,   975,    -1,    43,    44,    45,    -1,    88,
      89,    -1,    -1,    76,    77,    78,    -1,   187,   188,   230,
     231,   232,    -1,   234,    -1,    88,    89,    43,    44,    45,
     241,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1014,    -1,  1016,  1017,  1018,  1019,    -1,  1021,
      -1,  1023,    -1,    -1,    -1,    -1,    -1,    -1,  1030,    -1,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,    43,
      44,    45,   242,    -1,    -1,   245,   230,   231,   232,    -1,
     234,    -1,    -1,    43,    44,    45,    -1,   241,    -1,    -1,
      -1,    -1,    43,    44,    45,    -1,    -1,    -1,  1070,    -1,
      -1,    -1,  1074,    -1,  1076,    43,    44,    45,   187,   188,
      -1,    -1,    -1,    43,    44,    45,    76,    77,    78,    -1,
    1092,    -1,    -1,    -1,   187,   188,    -1,    -1,    88,    89,
      -1,  1103,    -1,    -1,   230,   231,   232,    -1,   234,  1111,
      43,    44,    45,  1115,  1116,   241,    -1,    -1,    -1,    -1,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
      -1,    -1,    -1,   242,    -1,    -1,   245,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   230,   231,   232,   242,
     234,    -1,   245,    -1,    -1,    -1,    -1,   241,    -1,    -1,
      -1,    -1,   230,   231,   232,    -1,   234,    -1,    -1,    -1,
      -1,    -1,  1174,   241,    -1,    -1,    -1,  1179,    -1,  1181,
      -1,    -1,    -1,    -1,   230,   231,   232,    -1,   234,   230,
     231,   232,    -1,   234,    -1,   241,  1198,   187,   188,    -1,
     241,  1203,  1204,    -1,    -1,    43,    44,    45,    -1,    -1,
      -1,  1213,  1214,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   230,   231,   232,    -1,
     234,  1233,    -1,    -1,  1236,    -1,    -1,   241,    -1,    -1,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   230,
     231,   232,   242,   234,    -1,   245,    -1,    -1,    -1,    -1,
     241,    -1,   230,   231,   232,  1267,   234,    -1,    -1,    -1,
     230,   231,   232,   241,   234,    -1,    -1,     5,     6,     7,
    1282,   241,    -1,  1285,  1286,    43,    44,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,   231,   232,
      -1,   234,    43,    44,    45,    33,    -1,    -1,   241,    -1,
      -1,    -1,    -1,    -1,    -1,  1317,    -1,    -1,    -1,    -1,
      -1,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    -1,    -1,
      -1,    79,    -1,    -1,    82,    83,    84,    85,  1360,    87,
      -1,    -1,    90,    91,    92,    93,    94,    95,    -1,    -1,
      98,    -1,    -1,  1375,   102,   103,   104,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,   117,
     118,   119,   230,   231,   232,   123,   234,   125,   126,   127,
     128,   129,   130,   241,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,    -1,   156,   157,
      -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,   167,
      -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,    -1,
      -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,    -1,
      -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,   197,
     198,   199,   230,   231,   232,    -1,   234,    -1,     5,     6,
       7,    -1,    -1,   241,   212,    -1,   214,   215,    -1,   230,
     231,   232,   220,   234,   222,   223,   224,   225,   226,    -1,
     241,    -1,    -1,    -1,    -1,   233,    33,    -1,    -1,    -1,
      -1,    -1,   240,    -1,   242,    -1,    -1,    -1,    -1,    -1,
      -1,   249,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,    -1,    -1,    -1,    -1,     5,     6,     7,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    -1,    43,    44,    45,    33,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,    -1,    -1,    -1,    -1,
     247,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    -1,    -1,
      -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,    87,
      -1,    -1,    90,    91,    92,    93,    94,    95,    -1,    -1,
      98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,   117,
     118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,    -1,   156,   157,
      -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,   167,
      -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,    -1,
      -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,    -1,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,    -1,     5,     6,     7,    -1,
      -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,   230,
     231,   232,   220,   234,   222,   223,   224,   225,   226,    -1,
     241,    43,    44,    45,    33,   233,    -1,    -1,    -1,    -1,
      -1,    -1,   240,    -1,    -1,    -1,    -1,    -1,    -1,   247,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    -1,    -1,    -1,
      79,    -1,    -1,    82,    83,    84,    85,    -1,    87,    -1,
      -1,    90,    91,    92,    93,    94,    95,    -1,    -1,    98,
      -1,    -1,    -1,   102,   103,   104,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,   115,   116,   117,   118,
     119,    -1,    -1,    -1,   123,    -1,   125,   126,   127,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,    -1,   156,   157,    -1,
      -1,    -1,    -1,    -1,    -1,   164,   165,   166,   167,    -1,
      -1,   170,   171,   172,   173,    -1,    -1,   176,    -1,    -1,
     179,   180,    -1,   182,    -1,   184,   185,    -1,    -1,    -1,
     189,    -1,   191,   192,    -1,   194,   195,    -1,   197,   198,
     199,    -1,    -1,    -1,    -1,     5,     6,     7,    -1,    -1,
      -1,    -1,    -1,   212,    -1,   214,   215,    -1,   230,   231,
     232,   220,   234,   222,   223,   224,   225,   226,    -1,   241,
      43,    44,    45,    33,   233,    -1,    -1,    -1,    -1,    -1,
      -1,   240,    -1,    -1,    -1,    -1,    -1,    -1,   247,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    -1,    -1,    -1,    79,
      -1,    -1,    82,    83,    84,    85,    -1,    87,    -1,    -1,
      90,    91,    92,    93,    94,    95,    -1,    -1,    98,    -1,
      -1,    -1,   102,   103,   104,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,   115,   116,   117,   118,   119,
      -1,    -1,    -1,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,    -1,   156,   157,    -1,    -1,
      -1,    -1,    -1,    -1,   164,   165,   166,   167,    -1,    -1,
     170,   171,   172,   173,    -1,    -1,   176,    -1,    -1,   179,
     180,    -1,   182,    -1,   184,   185,    -1,    -1,    -1,   189,
      -1,   191,   192,    -1,   194,   195,    -1,   197,   198,   199,
      -1,    -1,    -1,    -1,     5,     6,     7,    -1,    -1,    -1,
      -1,    -1,   212,    -1,   214,   215,    -1,   230,   231,   232,
     220,   234,   222,   223,   224,   225,   226,    -1,   241,    43,
      44,    45,    33,   233,    -1,    -1,    -1,    -1,    -1,    -1,
     240,    -1,    -1,    -1,    -1,    -1,    -1,   247,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,
      -1,    82,    83,    84,    85,    -1,    87,    -1,    -1,    90,
      91,    92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,
      -1,   102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,   115,   116,   117,   118,   119,    -1,
      -1,    -1,   123,    -1,   125,   126,   127,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,
      -1,    -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,
     171,   172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,
      -1,   182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,
     191,   192,    -1,   194,   195,    -1,   197,   198,   199,    -1,
      -1,    -1,    -1,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,   212,    -1,   214,   215,    -1,   230,   231,   232,   220,
     234,   222,   223,   224,   225,   226,    -1,   241,    -1,    -1,
      -1,    33,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,
      -1,    -1,    -1,    -1,    -1,    -1,   247,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,   241,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,   241,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,   241,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,   241,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,   241,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,   241,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,   241,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,   241,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,   241,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,   241,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,   241,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,   241,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    43,    44,    45,    -1,   240,   241,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    43,    44,    45,   102,   103,   104,    43,    44,
      45,    -1,    -1,    -1,    43,    44,    45,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    43,    44,    45,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    43,
      44,    45,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,   230,   231,   232,    -1,   234,    -1,    -1,
      -1,    -1,    -1,    -1,   241,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,   230,   231,   232,    -1,   234,   233,    -1,    -1,    -1,
       3,     4,   241,   240,   241,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    -1,    21,    22,
      23,    24,    25,    26,    27,    -1,    -1,    30,    31,    32,
      -1,    34,    35,    36,    37,    38,    39,    -1,    41,    42,
      -1,    -1,    -1,    46,    47,    -1,    -1,    -1,    -1,   230,
     231,   232,    -1,   234,    -1,   230,   231,   232,    -1,   234,
     241,   230,   231,   232,    -1,   234,   241,    -1,    -1,    -1,
      -1,    -1,   241,    -1,    -1,    -1,    -1,    80,    81,    -1,
      -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    97,    -1,    99,   100,   101,    -1,
      -1,    -1,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   230,   231,   232,    -1,   234,    -1,   120,   121,   122,
      -1,   124,   241,    -1,    -1,    -1,    -1,    -1,   131,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   230,   231,   232,    -1,
     234,    -1,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,
      -1,    -1,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,    -1,    -1,   168,   169,    -1,    -1,    -1,
      -1,   174,   175,    -1,   177,   178,    -1,    -1,   181,    -1,
     183,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,    -1,
      -1,    -1,    -1,     5,     6,     7,    -1,   200,   201,   202,
      -1,    -1,   205,   206,   207,   208,   209,   210,   211,    -1,
     213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,   225,   226,    -1,    -1,   229,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   239,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    33,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      87,    -1,    -1,    90,    91,    92,    93,    94,    95,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,   171,   172,   173,    -1,    -1,   176,
      -1,    -1,   179,   180,    -1,   182,    -1,   184,   185,    -1,
      -1,    -1,   189,    -1,   191,   192,    -1,   194,   195,    -1,
     197,   198,   199,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    43,    44,    45,    -1,   212,    -1,   214,   215,    -1,
      -1,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    33,    -1,    -1,    -1,    -1,   233,    -1,    43,    44,
      45,    -1,    -1,   240,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    94,    95,    -1,    -1,    98,    43,    44,    45,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,    -1,   170,   171,
     172,   173,    -1,    -1,   176,    -1,    -1,   179,   180,    -1,
     182,    -1,   184,   185,    -1,    -1,    -1,   189,    -1,   191,
     192,    -1,   194,   195,    -1,   197,   198,   199,   230,   231,
     232,    -1,   234,    -1,    -1,    -1,    -1,    -1,    -1,   241,
     212,    -1,   214,   215,    -1,    -1,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,   230,   231,   232,    -1,   234,
      -1,   233,    -1,    -1,     3,     4,   241,    -1,   240,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    -1,    21,    22,    23,    24,    25,    26,    27,    -1,
      -1,    30,    31,    32,    -1,    34,    35,    36,    37,    38,
      39,    -1,    41,    42,    -1,    -1,    -1,    46,    47,    -1,
      -1,    -1,    -1,    -1,   230,   231,   232,    -1,   234,    -1,
      -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    80,    81,    -1,    -1,    -1,    -1,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    97,    -1,
      99,   100,   101,    -1,    -1,    -1,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,    -1,    -1,    -1,    -1,
      -1,   120,   121,   122,    -1,   124,    -1,    -1,    -1,    -1,
      -1,    -1,   131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   155,    -1,    -1,   158,
     159,   160,   161,   162,   163,    -1,    -1,    -1,    -1,   168,
     169,    -1,    -1,    -1,    -1,   174,   175,    -1,   177,   178,
      -1,    -1,   181,    -1,   183,    -1,    -1,   186,    -1,    -1,
      -1,   190,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   200,   201,   202,    -1,    -1,   205,   206,   207,   208,
     209,   210,   211,    -1,   213,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,    -1,   225,   226,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,    -1,
      30,    31,    32,    -1,    34,    35,    36,    37,    38,    39,
      -1,    41,    42,    -1,    -1,    -1,    46,    47,    -1,    43,
      44,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,
      80,    81,    76,    77,    78,    -1,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    88,    89,    96,    97,    -1,    99,
     100,   101,    43,    44,    45,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,    -1,    -1,    -1,    88,    89,
     120,   121,   122,    -1,   124,    -1,    -1,    -1,    -1,    -1,
      -1,   131,    -1,    -1,    -1,    76,    77,    78,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,   155,    -1,    -1,   158,   159,
     160,   161,   162,   163,    -1,    -1,    -1,    -1,   168,   169,
      43,    44,    45,    -1,   174,   175,    -1,   177,   178,    -1,
      -1,   181,    -1,   183,    -1,    -1,   186,    43,    44,    45,
     190,    -1,    -1,   187,   188,    -1,    -1,    -1,    -1,    -1,
     200,   201,   202,    76,    77,    78,    -1,   207,    -1,    -1,
     210,   211,    -1,   213,    -1,    88,    89,   187,   188,    -1,
      76,    77,    78,    -1,    -1,   225,   226,    -1,    -1,    -1,
      -1,    -1,    88,    89,    -1,    -1,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,    -1,   187,   188,   242,    -1,
      -1,   245,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,    -1,
      -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,    88,    89,
      -1,    -1,    -1,    -1,   245,    76,    77,    78,    43,    44,
      45,    -1,    -1,    -1,   187,   188,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   187,   188,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    76,    77,    78,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    89,    -1,    -1,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,    -1,    43,    44,    45,
      -1,    -1,   245,    -1,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,    -1,    -1,    43,    44,    45,    -1,   245,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   187,   188,    -1,
      76,    77,    78,    -1,    43,    44,    45,    -1,    -1,    -1,
      -1,    -1,    88,    89,    -1,    -1,   187,   188,    76,    77,
      78,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,    88,
      89,    -1,   187,   188,    -1,   245,    76,    77,    78,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,    88,    89,
      -1,    -1,    -1,    -1,   245,    -1,    -1,    -1,    -1,    -1,
      43,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,    -1,    43,    44,    45,    -1,    -1,
     245,   187,   188,    76,    77,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    88,    89,    -1,    -1,   187,
     188,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    76,    77,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   187,   188,
      88,    89,    -1,    -1,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,    -1,    -1,    -1,    -1,   187,   188,   245,
      -1,    -1,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,    -1,    -1,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
      43,    44,    45,    -1,    -1,    -1,   245,    -1,    -1,    -1,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,    -1,
      -1,   241,   242,    -1,   187,   188,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    76,    77,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    88,    89,    -1,    -1,   187,
     188,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,    -1,    -1,   241,   242,
      43,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,    76,
      77,    78,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,    88,    89,   241,   242,    -1,    -1,    -1,    43,    44,
      45,    -1,    -1,    76,    77,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    76,    77,    78,   187,   188,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    76,    77,    78,    -1,    43,
      44,    45,    -1,    -1,    -1,    -1,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    43,    44,    45,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,    -1,    -1,   241,   242,
     187,   188,    76,    77,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    88,    89,    -1,    76,    77,    78,
      -1,    -1,    -1,    -1,   187,   188,    -1,    -1,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   187,   188,   241,   242,    -1,    -1,    -1,    43,
      44,    45,    -1,    -1,    -1,    -1,    -1,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   187,   188,   241,   242,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    76,    77,    78,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,    88,    89,   241,   242,    -1,    -1,
      -1,    -1,    -1,   187,   188,    -1,    -1,    -1,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   187,   188,
     241,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    43,    44,    45,    -1,    -1,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,    -1,    -1,   241,   242,    -1,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
      -1,    -1,   241,   242,    76,    77,    78,    43,    44,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,   187,   188,    -1,    -1,    -1,    -1,    -1,
      43,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      76,    77,    78,    -1,    -1,    -1,    43,    44,    45,    -1,
      -1,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    76,    77,    78,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,    88,    89,   241,   242,    76,
      77,    78,    -1,    -1,    -1,    -1,    43,    44,    45,    -1,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   187,   188,    -1,    -1,    76,
      77,    78,    43,    44,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    88,    89,    -1,    -1,    76,    77,    78,    43,    44,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    88,    89,    -1,
      -1,   187,   188,    -1,    -1,    76,    77,    78,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,    88,    89,   241,
     242,    76,    77,    78,   187,   188,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
     187,   188,    -1,    -1,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,    -1,    -1,   241,   242,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,    -1,    -1,   241,   242,
     187,   188,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,    -1,    -1,   241,   242,   187,   188,    -1,    -1,
      -1,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   187,   188,    -1,    -1,
      -1,    -1,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   187,   188,   241,   242,    76,    77,    78,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,    88,    89,
     241,   242,    -1,    -1,    -1,    43,    44,    45,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,    -1,    -1,
     241,   242,    43,    44,    45,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,    -1,    -1,   241,   242,    76,    77,
      78,    43,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      88,    89,    -1,    -1,    -1,    76,    77,    78,    -1,    -1,
      -1,    43,    44,    45,    -1,    -1,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    76,    77,    78,    -1,    43,    44,
      45,    -1,    -1,    -1,    -1,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    76,    77,    78,   187,   188,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    88,    89,    -1,    -1,
      -1,    76,    77,    78,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      43,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   187,
     188,   241,   242,    -1,    -1,    -1,    43,    44,    45,    -1,
      -1,    -1,    -1,    76,    77,    78,   187,   188,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   187,   188,    -1,    -1,    76,
      77,    78,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,    88,    89,   241,   242,   187,   188,    -1,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,    -1,    -1,
     241,   242,   187,   188,    -1,    -1,    -1,    -1,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,    -1,    -1,   241,
     242,    -1,    -1,    -1,    -1,    43,    44,    45,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,    -1,    -1,   241,
     242,    43,    44,    45,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   187,   188,   241,   242,    76,    77,
      78,    43,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      88,    89,    -1,    -1,    76,    77,    78,    -1,    -1,    -1,
     187,   188,    -1,    -1,    -1,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    76,    77,    78,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,    88,    89,   241,   242,
      -1,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,    -1,    -1,   241,   242,    -1,    -1,    43,    44,
      45,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,    -1,
      -1,    -1,    -1,    -1,    43,    44,    45,    -1,    88,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   187,
     188,    76,    77,    78,    -1,    -1,    43,    44,    45,    -1,
      -1,    -1,    -1,    88,    89,   187,   188,    76,    77,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      89,    -1,    -1,    -1,    -1,   187,   188,    -1,    -1,    76,
      77,    78,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,    88,    89,   241,   242,    -1,    -1,    -1,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,    -1,    -1,   241,
     242,    43,    44,    45,    -1,    -1,    -1,    -1,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   187,   188,    -1,
     242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    76,    77,    78,    -1,    43,    44,
      45,    -1,   187,   188,    -1,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   187,   188,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,    -1,
      -1,    76,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     187,   188,    -1,    88,    89,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,    -1,    -1,    -1,   242,    -1,    -1,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
      -1,    -1,    -1,   242,    43,    44,    45,    -1,    -1,    -1,
      -1,    -1,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,    43,    44,    45,   242,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   187,   188,    76,    77,    78,
      -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,    88,
      89,    -1,    -1,    -1,    -1,    76,    77,    78,    -1,    -1,
      43,    44,    45,    -1,    -1,    -1,    -1,    88,    89,    -1,
      -1,    -1,   187,   188,    -1,    76,    77,    78,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,    88,    89,    -1,
     242,    -1,    -1,    76,    77,    78,    -1,    -1,    43,    44,
      45,    -1,    -1,    -1,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    43,    44,    45,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,    -1,    -1,    43,    44,    45,    -1,
      -1,    76,    77,    78,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    89,    76,    77,    78,   187,   188,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,    89,    76,
      77,    78,    -1,    -1,    -1,    -1,   187,   188,    -1,    -1,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   187,   188,    -1,    -1,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
      -1,    -1,    -1,   242,   187,   188,    -1,    -1,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,    -1,    -1,
      -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,    -1,    -1,
      -1,   242,   187,   188,    -1,    -1,    -1,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   187,   188,    -1,   242,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     187,   188,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,    43,    44,    45,   242,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,    43,    44,
      45,   242,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,    43,    44,    45,   242,    -1,    76,    77,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      89,    76,    77,    78,    -1,    -1,    43,    44,    45,    -1,
      -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,
      43,    44,    45,    -1,    -1,    -1,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    43,    44,    45,    -1,    -1,    76,
      77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    88,    89,    76,    77,    78,    -1,    -1,    43,    44,
      45,    -1,    -1,    -1,    -1,    88,    89,    76,    77,    78,
      -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,    -1,
      -1,    76,    77,    78,    -1,    -1,    -1,    -1,   187,   188,
      -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,
      -1,    -1,   187,   188,    -1,    -1,    -1,    88,    89,    76,
      77,    78,    -1,    -1,    -1,    -1,   187,   188,    -1,    -1,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     187,   188,    -1,   242,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   187,   188,    -1,   242,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   187,   188,
      -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   187,   188,    -1,   242,    -1,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   187,   188,    -1,   242,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     187,   188,    -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,    43,    44,    45,   242,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,    43,    44,
      45,   242,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,    43,    44,    45,   242,    -1,    76,    77,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      89,    76,    77,    78,    -1,    -1,    43,    44,    45,    -1,
      -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,
      43,    44,    45,    -1,    -1,    -1,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    43,    44,    45,    -1,    -1,    76,
      77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    88,    89,    76,    77,    78,    -1,    -1,    43,    44,
      45,    -1,    -1,    -1,    -1,    88,    89,    76,    77,    78,
      -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,    -1,
      -1,    76,    77,    78,    -1,    -1,    -1,    -1,   187,   188,
      -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,
      -1,    -1,   187,   188,    -1,    -1,    -1,    88,    89,    76,
      77,    78,    -1,    -1,    -1,    -1,   187,   188,    -1,    -1,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     187,   188,    -1,   242,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   187,   188,    -1,   242,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   187,   188,
      -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   187,   188,    -1,   242,    -1,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   187,   188,    -1,   242,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     187,   188,    -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,    43,    44,    45,   242,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,    43,    44,
      45,   242,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,    43,    44,    45,   242,    -1,    76,    77,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      89,    76,    77,    78,    -1,    -1,    43,    44,    45,    -1,
      -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,
      43,    44,    45,    -1,    -1,    -1,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    43,    44,    45,    -1,    -1,    76,
      77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    88,    89,    76,    77,    78,    -1,    -1,    43,    44,
      45,    -1,    -1,    -1,    -1,    88,    89,    76,    77,    78,
      -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,    -1,
      -1,    76,    77,    78,    -1,    -1,    -1,    -1,   187,   188,
      -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,
      -1,    -1,   187,   188,    -1,    -1,    -1,    88,    89,    76,
      77,    78,    -1,    -1,    -1,    -1,   187,   188,    -1,    -1,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     187,   188,    -1,   242,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   187,   188,    -1,   242,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   187,   188,
      -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   187,   188,    -1,   242,    -1,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   187,   188,    -1,   242,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     187,   188,    -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,    43,    44,    45,   242,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,    43,    44,
      45,   242,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,    43,    44,    45,   242,    -1,    76,    77,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      89,    76,    77,    78,    -1,    -1,    43,    44,    45,    -1,
      -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,
      43,    44,    45,    -1,    -1,    -1,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    43,    44,    45,    -1,    -1,    76,
      77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    88,    89,    76,    77,    78,    -1,    -1,    43,    44,
      45,    -1,    -1,    -1,    -1,    88,    89,    76,    77,    78,
      -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,    -1,
      -1,    76,    77,    78,    -1,    -1,    -1,    -1,   187,   188,
      -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,
      -1,    -1,   187,   188,    -1,    -1,    -1,    88,    89,    76,
      77,    78,    -1,    -1,    -1,    -1,   187,   188,    -1,    -1,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     187,   188,    -1,   242,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   187,   188,    -1,   242,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   187,   188,
      -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   187,   188,    -1,   242,    -1,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   187,   188,    -1,   242,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     187,   188,    -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,    43,    44,    45,   242,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,    43,    44,
      45,   242,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,    43,    44,    45,   242,    -1,    76,    77,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      89,    76,    77,    78,    -1,    -1,    43,    44,    45,    -1,
      -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,
      43,    44,    45,    -1,    -1,    -1,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    43,    44,    45,    -1,    -1,    76,
      77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    88,    89,    76,    77,    78,    -1,    -1,    43,    44,
      45,    -1,    -1,    -1,    -1,    88,    89,    76,    77,    78,
      -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,    -1,
      -1,    76,    77,    78,    -1,    -1,    -1,    -1,   187,   188,
      -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,
      -1,    -1,   187,   188,    -1,    -1,    -1,    88,    89,    76,
      77,    78,    -1,    -1,    -1,    -1,   187,   188,    -1,    -1,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     187,   188,    -1,   242,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   187,   188,    -1,   242,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   187,   188,
      -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   187,   188,    -1,   242,    -1,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   187,   188,    -1,   242,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     187,   188,    -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,    43,    44,    45,   242,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,    43,    44,
      45,   242,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,    43,    44,    45,   242,    -1,    76,    77,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      89,    76,    77,    78,    -1,    -1,    43,    44,    45,    -1,
      -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,
      43,    44,    45,    -1,    -1,    -1,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    43,    44,    45,    -1,    -1,    76,
      77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    88,    89,    76,    77,    78,    -1,    -1,    43,    44,
      45,    -1,    -1,    -1,    -1,    88,    89,    76,    77,    78,
      -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,    -1,
      -1,    76,    77,    78,    -1,    -1,    -1,    -1,   187,   188,
      -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,
      -1,    -1,   187,   188,    -1,    -1,    -1,    88,    89,    76,
      77,    78,    -1,    -1,    -1,    -1,   187,   188,    -1,    -1,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     187,   188,    -1,   242,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   187,   188,    -1,   242,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   187,   188,
      -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   187,   188,    -1,   242,    -1,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   187,   188,    -1,   242,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     187,   188,    -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,    43,    44,    45,   242,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,    43,    44,
      45,   242,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,    43,    44,    45,   242,    -1,    76,    77,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      89,    76,    77,    78,    -1,    -1,    43,    44,    45,    -1,
      -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,
      43,    44,    45,    -1,    -1,    -1,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    43,    44,    45,    -1,    -1,    76,
      77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    88,    89,    76,    77,    78,    -1,    -1,    43,    44,
      45,    -1,    -1,    -1,    -1,    88,    89,    76,    77,    78,
      -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,    -1,
      -1,    76,    77,    78,    -1,    -1,    -1,    -1,   187,   188,
      -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,
      -1,    -1,   187,   188,    -1,    -1,    -1,    88,    89,    76,
      77,    78,    -1,    -1,    -1,    -1,   187,   188,    -1,    -1,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     187,   188,    -1,   242,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   187,   188,    -1,   242,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   187,   188,
      -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   187,   188,    -1,   242,    -1,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   187,   188,    -1,   242,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     187,   188,    -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,    -1,    -1,   241,    -1,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,    -1,    -1,
     241,    -1,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,    -1,    -1,   241,    43,    44,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,
      44,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    43,    44,    45,    -1,    -1,    76,    77,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      88,    89,    76,    77,    78,    -1,    -1,    43,    44,    45,
      -1,    -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,
      -1,    43,    44,    45,    -1,    -1,    -1,    -1,    88,    89,
      -1,    -1,    -1,    -1,    -1,    43,    44,    45,    -1,    -1,
      76,    77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,    43,
      44,    45,    -1,    -1,    -1,    -1,    88,    89,    76,    77,
      78,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,
      -1,    -1,    76,    77,    78,    -1,    -1,    -1,    -1,   187,
     188,    -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,
      -1,    -1,    -1,   187,   188,    -1,    -1,    -1,    88,    89,
      76,    77,    78,    -1,    -1,    -1,    -1,   187,   188,    -1,
      -1,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   187,   188,   241,    -1,    -1,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   187,   188,   241,    -1,    -1,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   187,
     188,   241,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   187,   188,   241,    -1,    -1,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   187,   188,   241,
      -1,    -1,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   187,   188,   241,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,    -1,    -1,   241,    -1,    -1,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,    -1,
      -1,   241,    -1,    -1,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,    -1,    -1,   241,    43,    44,    45,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      43,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    43,    44,    45,    -1,    -1,    76,
      77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    88,    89,    76,    77,    78,    -1,    -1,    43,    44,
      45,    -1,    -1,    -1,    -1,    88,    89,    76,    77,    78,
      -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,    -1,
      -1,    76,    77,    78,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,
      43,    44,    45,    -1,    -1,    -1,    -1,    88,    89,    76,
      77,    78,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    43,    44,
      45,    -1,    -1,    76,    77,    78,    -1,    -1,    -1,    -1,
     187,   188,    -1,    -1,    -1,    88,    89,    76,    77,    78,
      -1,    -1,    -1,    -1,   187,   188,    -1,    -1,    -1,    88,
      89,    76,    77,    78,    -1,    -1,    -1,    -1,   187,   188,
      -1,    -1,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   187,   188,   241,    -1,    -1,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   187,   188,   241,    -1,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     187,   188,   241,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   187,   188,   241,    -1,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   187,   188,
     241,    -1,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   187,   188,   241,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,    -1,    -1,   241,    -1,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
      -1,    -1,   241,    -1,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,    -1,    -1,   241,    43,    44,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    43,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    43,    44,    45,    -1,    -1,
      76,    77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,    43,
      44,    45,    -1,    -1,    -1,    -1,    88,    89,    76,    77,
      78,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,
      -1,    -1,    76,    77,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,
      -1,    43,    44,    45,    -1,    -1,    -1,    -1,    88,    89,
      76,    77,    78,    -1,    -1,    43,    44,    45,    -1,    -1,
      -1,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    43,
      44,    45,    -1,    -1,    76,    77,    78,    -1,    -1,    -1,
      -1,   187,   188,    -1,    -1,    -1,    88,    89,    76,    77,
      78,    -1,    -1,    -1,    -1,   187,   188,    -1,    -1,    -1,
      88,    89,    76,    77,    78,    -1,    -1,    -1,    -1,   187,
     188,    -1,    -1,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   187,   188,   241,    -1,    -1,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   187,   188,   241,
      -1,    -1,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   187,   188,   241,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   187,   188,   241,    -1,    -1,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   187,
     188,   241,    -1,    -1,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   187,   188,   241,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,    -1,    -1,   241,
      -1,    -1,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,    -1,    -1,   241,    -1,    -1,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,    -1,    -1,   241,    43,    44,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,    -1,
      -1,    76,    77,    78,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,
      43,    44,    45,    -1,    -1,    -1,    -1,    88,    89,    76,
      77,    78,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    43,    44,
      45,    -1,    -1,    76,    77,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    88,    89,    76,    77,    78,
      -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,    88,
      89,    76,    77,    78,    -1,    -1,    43,    44,    45,    -1,
      -1,    -1,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      43,    44,    45,    -1,    -1,    76,    77,    78,    -1,    -1,
      -1,    -1,   187,   188,    -1,    -1,    -1,    88,    89,    76,
      77,    78,    -1,    -1,    -1,    -1,   187,   188,    -1,    -1,
      -1,    88,    89,    76,    77,    78,    -1,    -1,    -1,    -1,
     187,   188,    -1,    -1,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   187,   188,   241,    -1,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   187,   188,
     241,    -1,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   187,   188,   241,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   187,   188,   241,    -1,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     187,   188,   241,    -1,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   187,   188,   241,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,    -1,    -1,
     241,    -1,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,    -1,    -1,   241,    -1,    -1,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,    -1,    -1,   241,    43,
      44,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,
      -1,    -1,    76,    77,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,
      -1,    43,    44,    45,    -1,    -1,    -1,    -1,    88,    89,
      76,    77,    78,    -1,    -1,    43,    44,    45,    -1,    -1,
      -1,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    43,
      44,    45,    -1,    -1,    76,    77,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    88,    89,    76,    77,
      78,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,
      88,    89,    76,    77,    78,    -1,    -1,    43,    44,    45,
      -1,    -1,    -1,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,    43,    44,    45,    -1,    -1,    76,    77,    78,    -1,
      -1,    -1,    -1,   187,   188,    -1,    -1,    -1,    88,    89,
      76,    77,    78,    -1,    -1,    -1,    -1,   187,   188,    -1,
      -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,    -1,
      -1,   187,   188,    -1,    -1,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   187,   188,   241,    -1,    -1,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   187,
     188,   241,    -1,    -1,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   187,   188,   241,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   187,   188,   241,
      -1,    -1,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   187,   188,   241,    -1,    -1,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   187,   188,   241,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,    -1,
      -1,   241,    -1,    -1,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,    -1,    -1,   241,    -1,    -1,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,    -1,    -1,   241,
      43,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,    44,
      45,    -1,    -1,    76,    77,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    88,    89,    76,    77,    78,
      -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,    88,
      89,    76,    77,    78,    -1,    -1,    43,    44,    45,    -1,
      -1,    -1,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      43,    44,    45,    -1,    -1,    76,    77,    78,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,    89,    76,
      77,    78,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,
      -1,    88,    89,    76,    77,    78,    -1,    -1,    43,    44,
      45,    -1,    -1,    -1,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    43,    44,    45,    -1,    -1,    76,    77,    78,
      -1,    -1,    -1,    -1,   187,   188,    -1,    -1,    -1,    88,
      89,    76,    77,    78,    -1,    -1,    -1,    -1,   187,   188,
      -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,
      -1,    -1,   187,   188,    -1,    -1,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   187,   188,   241,    -1,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     187,   188,   241,    -1,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   187,   188,   241,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   187,   188,
     241,    -1,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   187,   188,   241,    -1,    -1,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   187,   188,   241,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
      -1,    -1,   241,    -1,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,    -1,    -1,   241,    -1,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,    -1,    -1,
     241,    43,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    43,    44,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,
      44,    45,    -1,    -1,    76,    77,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    88,    89,    76,    77,
      78,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,
      88,    89,    76,    77,    78,    -1,    -1,    43,    44,    45,
      -1,    -1,    -1,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,    43,    44,    45,    -1,    -1,    76,    77,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,    89,
      76,    77,    78,    -1,    -1,    43,    44,    45,    -1,    -1,
      -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,    43,
      44,    45,    -1,    -1,    -1,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,    43,    44,    45,    -1,    -1,    76,    77,
      78,    -1,    -1,    -1,    -1,   187,   188,    -1,    -1,    -1,
      88,    89,    76,    77,    78,    -1,    -1,    -1,    -1,   187,
     188,    -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,
      -1,    -1,    -1,   187,   188,    -1,    -1,    -1,    88,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   187,   188,   241,
      -1,    -1,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   187,   188,   241,    -1,    -1,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   187,   188,   241,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   187,
     188,   241,    -1,    -1,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   187,   188,   241,    -1,    -1,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   187,   188,   241,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,    -1,    -1,   241,    -1,    -1,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,    -1,    -1,   241,    -1,    -1,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,    -1,
      -1,   241,    43,    44,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      43,    44,    45,    -1,    -1,    76,    77,    78,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,    89,    76,
      77,    78,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,
      -1,    88,    89,    76,    77,    78,    -1,    -1,    43,    44,
      45,    -1,    -1,    -1,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    43,    44,    45,    -1,    -1,    76,    77,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      89,    76,    77,    78,    -1,    -1,    43,    44,    45,    -1,
      -1,    -1,    -1,    88,    89,    76,    77,    78,    -1,    -1,
      43,    44,    45,    -1,    -1,    -1,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    76,
      77,    78,    -1,    -1,    -1,    -1,   187,   188,    -1,    -1,
      -1,    88,    89,    76,    77,    -1,    -1,    -1,    -1,    -1,
     187,   188,    -1,    -1,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   187,   188,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   187,   188,
     241,    -1,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   187,   188,   241,    -1,    -1,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   187,   188,   241,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     187,   188,   241,    -1,    -1,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   187,   188,   241,    -1,    -1,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,    -1,    -1,
     241,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,    -1,    -1,    -1,    -1,    -1,   230,   231,   232,
     233,   234,   235,   236,    -1,   238
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     3,     4,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    21,    22,    23,    24,    25,
      26,    27,    30,    31,    32,    34,    35,    36,    37,    38,
      39,    41,    42,    46,    47,    80,    81,    86,    96,    97,
      99,   100,   101,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   120,   121,   122,   124,   131,   155,   158,   159,
     160,   161,   162,   163,   168,   169,   174,   175,   177,   178,
     181,   183,   186,   190,   200,   201,   202,   205,   206,   207,
     208,   209,   210,   211,   213,   225,   226,   229,   251,   252,
     253,   254,   255,   256,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,     5,     6,     7,
      33,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    79,    82,
      83,    84,    85,    87,    90,    91,    92,    93,    94,    95,
      98,   102,   103,   104,   114,   115,   116,   117,   118,   119,
     123,   125,   126,   127,   128,   129,   130,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     156,   157,   164,   165,   166,   167,   170,   171,   172,   173,
     176,   179,   180,   182,   184,   185,   189,   191,   192,   194,
     195,   197,   198,   199,   212,   214,   215,   220,   222,   223,
     224,   225,   226,   233,   240,   357,   358,   225,   226,   357,
     358,   240,   357,   358,   240,   357,   240,   357,   225,   240,
     247,   353,   240,   357,   240,   357,   240,   357,   357,   357,
     357,   225,   225,   240,   357,   358,   240,   357,   358,   240,
     357,   358,   240,   357,   240,   357,   225,   225,    19,    23,
     205,   208,   240,   357,   225,   226,   225,   226,   357,   225,
     240,   353,   357,   240,   357,   358,   240,   357,   240,   358,
     357,   358,   358,   357,   240,   357,   240,   357,   357,   240,
     357,   240,   357,   357,   357,   357,   240,   357,   358,   240,
     240,   240,   357,   240,   358,   357,   358,   240,   358,   358,
     240,   225,   240,   357,   240,   357,   358,   240,   357,   358,
     240,   357,   240,   358,   240,   358,   240,   357,   240,   358,
     357,   357,   357,   225,   226,   357,   225,   225,   220,   225,
     226,   258,   240,   357,   214,   215,   216,   217,   218,   219,
     232,   244,   216,   232,   244,     0,   239,   254,   243,    20,
     242,   240,   240,   240,   240,   240,   240,   240,   240,   240,
     240,   240,   240,   240,   240,   240,   240,   240,   240,   240,
     240,   240,   240,   240,   240,   240,   240,   240,   240,   240,
     240,   240,   357,   240,   240,   240,   240,   240,   240,   240,
     240,   240,   240,   240,   240,   240,   240,   240,   240,   240,
     240,   240,   240,   240,   240,   240,   240,   240,   240,   240,
     240,   240,   240,   240,   240,   240,   240,   240,   240,   240,
     240,   240,   240,   240,   240,   240,   240,   240,   240,   240,
     240,   240,   240,   240,   240,   240,   240,   240,   240,   240,
     240,   240,   240,   240,   240,   240,   240,   240,   240,   240,
     357,   240,   240,   240,   240,   240,   240,   240,   240,   225,
     225,   240,   214,   215,   240,   244,   240,   244,   357,   357,
     358,    43,    44,    45,    76,    77,    78,    88,    89,   187,
     188,   230,   231,   232,   233,   234,   235,   236,   238,   246,
      43,    44,    45,   230,   231,   232,   234,   246,   244,   244,
     357,   242,   357,   242,   357,   242,   225,   354,   357,   357,
     242,   357,   242,   357,   242,   232,   357,   242,   357,   242,
     357,   242,   241,   241,   357,   242,   240,   357,   240,   357,
     240,   357,   240,   357,   225,   357,   242,   357,   242,   357,
     242,   358,   242,   357,   242,   357,   242,   357,   242,   357,
     242,   242,   357,   242,   241,   241,   357,   242,   241,   241,
     241,   357,   242,   357,   358,   242,   242,   357,   242,   241,
     357,   358,   242,   357,   242,   358,   242,   240,   257,   257,
     257,   240,   240,   242,   357,   242,   357,   357,   357,   357,
     193,   196,   247,   352,   353,   357,   358,   357,   358,   193,
     196,   352,   353,   357,   358,   357,   251,    41,   274,   273,
     225,   226,   241,   357,   357,   241,   357,   357,   358,   357,
     358,   358,   358,   358,   358,   358,   358,   358,   357,   357,
     241,   357,   357,   357,   357,   357,   357,   357,   241,   357,
     357,   357,   357,   357,   357,   358,   357,   357,   358,   241,
     357,   241,   357,   241,   241,   241,   241,   241,   241,   358,
     241,   241,   357,   357,   357,   357,   357,   357,   357,   241,
     357,   358,   241,   241,   241,   241,   241,   241,   241,   241,
     241,   241,   241,   241,   241,   241,   241,   241,   241,   241,
     241,   241,   241,   241,   241,   241,   241,   241,   241,   241,
     241,   241,   358,   241,   357,   357,   357,   241,   241,   241,
     241,   241,   357,   241,   357,   241,   358,   358,   357,   358,
     358,   358,   358,   225,   226,   241,   241,   241,   357,   244,
     244,   225,   226,   241,   356,   357,   358,   242,   249,   357,
     241,   356,   242,   249,   357,   241,   241,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   358,   357,   357,   357,   358,   358,   358,   358,
     358,   358,   357,   358,   357,   357,   242,   357,   242,   357,
     242,   357,   241,   248,   242,   242,   357,   242,   357,   242,
     357,   357,   242,   358,   242,   358,   242,   358,   242,   357,
     357,   357,   357,   357,   241,   242,   357,   242,   358,   242,
     357,   242,   357,   242,   357,   242,   357,   242,   358,   242,
     357,   357,   242,   357,   242,   357,   242,   357,   242,   242,
     358,   357,   242,   358,   242,   242,   358,   242,   357,   242,
     358,   241,   258,   241,   356,   225,   226,   258,   242,   357,
     240,   240,   355,   358,   242,   245,   240,   240,   242,   245,
     244,   244,   242,   242,   241,   241,   241,   241,   241,   242,
     242,   242,   241,   241,   242,   242,   241,   241,   241,   241,
     241,   241,   241,   241,   241,   241,   241,   241,   241,   241,
     241,   241,   241,   241,   241,   241,   241,   241,   242,   242,
     241,   241,   241,   241,   241,   241,   241,   241,   241,   241,
     241,   241,   241,   241,   242,   241,   242,   242,   242,   242,
     241,   242,   241,   242,   241,   357,   357,   241,   241,   241,
     242,   249,   242,   245,   242,   245,   241,   249,   242,   245,
     242,   245,   242,   245,   242,   245,   357,   357,   242,   357,
     242,   354,   357,   242,   357,   242,   357,    28,   358,   358,
     358,   357,   242,   242,   242,   242,   242,   357,   358,   357,
     242,   357,   242,   357,   242,   357,   242,   357,   358,   357,
     242,   242,   357,   242,   357,   357,   358,   357,   242,   358,
     358,   358,   242,   357,   358,   241,   241,   241,   241,   357,
     358,   358,   248,   242,   357,   214,   215,   216,   217,   218,
     219,   232,   358,   358,   357,   216,   232,   357,   357,   357,
     357,   357,   357,   357,   358,   358,   357,   357,   358,   358,
     358,   358,   358,   358,   358,   242,   245,   242,   245,   356,
     245,   245,   357,   214,   215,   245,   245,   357,   357,   357,
     241,   242,   357,   242,   357,   242,   225,   353,   357,   242,
     357,   241,   357,   241,   241,   241,   242,   357,   357,   357,
     357,   357,   241,   241,   242,   357,   358,   242,   357,   242,
     358,   242,   357,   358,   242,   241,   242,   357,   357,   242,
     357,   241,   241,   242,   241,   357,   241,   241,   242,   358,
     241,   241,   241,   242,   242,   355,   245,   357,   357,   357,
     357,   357,   358,   242,   242,   245,   358,   357,   358,   245,
     245,   241,   242,   242,   241,   241,   241,   242,   241,   242,
     242,   241,   241,   242,   241,   242,   242,   241,   241,   241,
     357,   357,   245,   245,   245,   245,   357,   357,   242,   225,
     357,   242,   357,   242,    29,   357,   241,   241,   241,   241,
     357,   358,   357,   358,   242,   357,   358,   242,   357,   357,
     242,   357,   357,   358,   358,   358,   214,   215,   216,   217,
     218,   219,   232,   358,   358,   216,   232,   357,   357,   357,
     357,   357,   358,   357,   358,   245,   245,   214,   215,   241,
     242,   357,   241,   242,   225,   353,   357,   242,   357,   357,
     241,   241,   241,   241,   241,   242,   357,   242,   241,   357,
     358,   241,   242,   357,   241,   241,   241,   241,   242,   241,
     357,   357,   357,   357,   357,   358,   241,   242,   241,   358,
     357,   358,   241,   241,   241,   242,   241,   242,   241,   242,
     241,   241,   357,   225,   357,   242,   357,   357,   357,   358,
     242,   357,   242,   357,   357,   357,   357,   357,   241,   241,
     242,   225,   353,   241,   241,   242,   241,   358,   242,   357,
     241,   241,   241,   241,   241,   225,   358,   357,   241,   241,
     241
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:

/* Line 1806 of yacc.c  */
#line 372 "basicParse.y"
    {
	if (functionDefSymbol != -1 || subroutineDefSymbol !=-1) {
		errorcode = COMPERR_FUNCTIONGOTO;
		return -1;
	}
	labeltable[(yyvsp[(1) - (1)].number)] = byteOffset; 
	lastLineOffset = byteOffset;
	addIntOp(OP_CURRLINE, linenumber);
}
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 383 "basicParse.y"
    { lastLineOffset = byteOffset; addIntOp(OP_CURRLINE, linenumber); }
    break;

  case 8:

/* Line 1806 of yacc.c  */
#line 384 "basicParse.y"
    { lastLineOffset = byteOffset; addIntOp(OP_CURRLINE, linenumber); }
    break;

  case 9:

/* Line 1806 of yacc.c  */
#line 385 "basicParse.y"
    { lastLineOffset = byteOffset; addIntOp(OP_CURRLINE, linenumber); }
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 386 "basicParse.y"
    { lastLineOffset = byteOffset; addIntOp(OP_CURRLINE, linenumber); }
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 387 "basicParse.y"
    {
		// push to iftable the byte location of the end of the last stmt (top of loop)
		newIf(lastLineOffset, linenumber-1, IFTABLETYPEWHILE);
		lastLineOffset = byteOffset; 
		addIntOp(OP_CURRLINE, linenumber);
	}
    break;

  case 12:

/* Line 1806 of yacc.c  */
#line 393 "basicParse.y"
    { lastLineOffset = byteOffset; addIntOp(OP_CURRLINE, linenumber); }
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 394 "basicParse.y"
    {
		// push to iftable the byte location of the end of the last stmt (top of loop)
		newIf(lastLineOffset, linenumber, IFTABLETYPEDO);
		lastLineOffset = byteOffset;
		addIntOp(OP_CURRLINE, linenumber);
	}
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 400 "basicParse.y"
    { lastLineOffset = byteOffset; addIntOp(OP_CURRLINE, linenumber); }
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 401 "basicParse.y"
    { lastLineOffset = byteOffset; addIntOp(OP_CURRLINE, linenumber); }
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 402 "basicParse.y"
    { lastLineOffset = byteOffset; addIntOp(OP_CURRLINE, linenumber); }
    break;

  case 17:

/* Line 1806 of yacc.c  */
#line 403 "basicParse.y"
    { lastLineOffset = byteOffset; addIntOp(OP_CURRLINE, linenumber); }
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 404 "basicParse.y"
    { lastLineOffset = byteOffset; addIntOp(OP_CURRLINE, linenumber); }
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 405 "basicParse.y"
    { lastLineOffset = byteOffset; addIntOp(OP_CURRLINE, linenumber); }
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 407 "basicParse.y"
    { lastLineOffset = byteOffset; addIntOp(OP_CURRLINE, linenumber); }
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 410 "basicParse.y"
    {
		if (numifs>0) {
			errorcode = COMPERR_FUNCTIONNOTHERE;
			return -1;
		}
		// $2 is the symbol for the function - add the start to the label table
		functionDefSymbol = (yyvsp[(2) - (3)].number);
		addOp(OP_END); 
		labeltable[(yyvsp[(2) - (3)].number)] = byteOffset;
		lastLineOffset = byteOffset;
		newIf(0, linenumber, IFTABLETYPEFUNCTION);
		// initialize return variable
		addIntOp(OP_PUSHINT, 0);
		addIntOp(OP_NUMASSIGN, (yyvsp[(2) - (3)].number));
		// check to see if there are enough values on the stack
		addIntOp(OP_PUSHINT, numargs);
		addOp(OP_ARGUMENTCOUNTTEST);
		// add the assigns of the function arguments
		addOp(OP_INCREASERECURSE);
		{ 	int t;
			for(t=numargs-1;t>=0;t--) {
				if (argstype[t]==ARGSTYPEINT) addIntOp(OP_NUMASSIGN, args[t]);
				if (argstype[t]==ARGSTYPESTR) addIntOp(OP_STRINGASSIGN, args[t]);
				if (argstype[t]==ARGSTYPEVARREF) addIntOp(OP_VARREFASSIGN, args[t]);
				if (argstype[t]==ARGSTYPEVARREFSTR) addIntOp(OP_VARREFSTRASSIGN, args[t]);
			}
		}
		numargs=0;	// clear the list for next function
	}
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 440 "basicParse.y"
    {
		if (numifs>0) {
			errorcode = COMPERR_FUNCTIONNOTHERE;
			return -1;
		}
		// $2 is the symbol for the function - add the start to the label table
		functionDefSymbol = (yyvsp[(2) - (3)].number);
		addOp(OP_END); 
		labeltable[(yyvsp[(2) - (3)].number)] = byteOffset;
		lastLineOffset = byteOffset;
		newIf(0, linenumber, IFTABLETYPEFUNCTION);
		// initialize return variable
		addStringOp(OP_PUSHSTRING, "");
		addIntOp(OP_STRINGASSIGN, (yyvsp[(2) - (3)].number));
		// check to see if there are enough values on the stack
		addIntOp(OP_PUSHINT, numargs);
		addOp(OP_ARGUMENTCOUNTTEST);
		addOp(OP_INCREASERECURSE);
		{ 	int t;
			for(t=numargs-1;t>=0;t--) {
				if (argstype[t]==ARGSTYPEINT) addIntOp(OP_NUMASSIGN, args[t]);
				if (argstype[t]==ARGSTYPESTR) addIntOp(OP_STRINGASSIGN, args[t]);
				if (argstype[t]==ARGSTYPEVARREF) addIntOp(OP_VARREFASSIGN, args[t]);
				if (argstype[t]==ARGSTYPEVARREFSTR) addIntOp(OP_VARREFSTRASSIGN, args[t]);
			}
		}
		numargs=0;	// clear the list for next function
	}
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 470 "basicParse.y"
    {
		if (numifs>0) {
			errorcode = COMPERR_FUNCTIONNOTHERE;
			return -1;
		}
		// $2 is the symbol for the subroutine - add the start to the label table
		subroutineDefSymbol = (yyvsp[(2) - (3)].number);
		addOp(OP_END); 
		labeltable[(yyvsp[(2) - (3)].number)] = byteOffset;
		lastLineOffset = byteOffset;
		newIf(0, linenumber, IFTABLETYPEFUNCTION);
		// check to see if there are enough values on the stack
		addIntOp(OP_PUSHINT, numargs);
		addOp(OP_ARGUMENTCOUNTTEST);
		// add the assigns of the function arguments
		addOp(OP_INCREASERECURSE);
		{ 	int t;
			for(t=numargs-1;t>=0;t--) {
				if (argstype[t]==ARGSTYPEINT) addIntOp(OP_NUMASSIGN, args[t]);
				if (argstype[t]==ARGSTYPESTR) addIntOp(OP_STRINGASSIGN, args[t]);
				if (argstype[t]==ARGSTYPEVARREF) addIntOp(OP_VARREFASSIGN, args[t]);
				if (argstype[t]==ARGSTYPEVARREFSTR) addIntOp(OP_VARREFSTRASSIGN, args[t]);
			}
		}
		numargs=0;	// clear the list for next function
	}
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 502 "basicParse.y"
    {
		args[numargs] = (yyvsp[(1) - (1)].number); argstype[numargs] = ARGSTYPEINT; numargs++;
		//printf("functionvariable %i %i %i\n", args[numargs-1], argstype[numargs-1],numargs); 
	}
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 506 "basicParse.y"
    {
		args[numargs] = (yyvsp[(1) - (1)].number); argstype[numargs] = ARGSTYPESTR; numargs++;
		//printf("functionvariable %i %i %i\n", args[numargs-1], argstype[numargs-1],numargs); 
	}
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 510 "basicParse.y"
    {
		args[numargs] = (yyvsp[(3) - (4)].number); argstype[numargs] = ARGSTYPEVARREF; numargs++;
		//printf("functionvariable %i %i %i\n", args[numargs-1], argstype[numargs-1],numargs); 
	}
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 514 "basicParse.y"
    {
		args[numargs] = (yyvsp[(3) - (4)].number); argstype[numargs] = ARGSTYPEVARREFSTR; numargs++;
		//printf("functionvariable %i %i %i\n", args[numargs-1], argstype[numargs-1],numargs); 
	}
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 525 "basicParse.y"
    {
	if (numifs>0) {
		if (iftabletype[numifs-1]==IFTABLETYPEFUNCTION) {
			addIntOp(OP_PUSHVAR, functionDefSymbol);
			addOp(OP_DECREASERECURSE);
			functionDefSymbol = -1; 
			addOp(OP_RETURN);
			numifs--;
		} else {
			errorcode = testIfOnTableError();
			linenumber = testIfOnTable();
			return -1;
		}
	} else {
		errorcode = COMPERR_ENDFUNCTION;
		return -1;
	}
}
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 547 "basicParse.y"
    {
	if (numifs>0) {
		if (iftabletype[numifs-1]==IFTABLETYPEFUNCTION) {
			addOp(OP_DECREASERECURSE);
			subroutineDefSymbol = -1; 
			addOp(OP_RETURN);
			numifs--;
		} else {
			errorcode = testIfOnTableError();
			linenumber = testIfOnTable();
			return -1;
		}
	} else {
		errorcode = COMPERR_ENDFUNCTION;
		return -1;
	}
}
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 567 "basicParse.y"
    {
	// if there is an if branch or jump on the iftable stack get where it is
	// in the bytecode array and then put the current bytecode address there
	// - so we can jump over code
	if (numifs>0) {
		unsigned int *temp = NULL;
		numifs--;
		temp = (unsigned int *) (byteCode + iftable[numifs]);
		*temp = byteOffset;
	}
}
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 581 "basicParse.y"
    {
		// there is nothing to do with a multi line if (ifexp handles it)
	}
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 587 "basicParse.y"
    {
	unsigned int elsegototemp = 0;
	// on else create a jump point to the endif
	addIntOp(OP_PUSHINT, 0);	// false - always jump before else to endif
	addOp(OP_BRANCH);
	elsegototemp = addInt(0);
	// resolve the false jump on the if to the current location
	if (numifs>0) {
		if (iftabletype[numifs-1]==IFTABLETYPEIF) {
			unsigned int *temp = NULL;
			numifs--;
			temp = (unsigned int *) (byteCode + iftable[numifs]);
			*temp = byteOffset; 
			// now add the elsegoto jump to the iftable
			newIf(elsegototemp, linenumber, IFTABLETYPEELSE);
		} else {
			errorcode = testIfOnTableError();
			linenumber = testIfOnTable();
			return -1;
		}
	} else {
		errorcode = COMPERR_ELSE;
		return -1;
	}
}
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 618 "basicParse.y"
    {
	// if there is an if branch or jump on the iftable stack get where it is
	// in the bytecode array and then put the current bytecode address there
	// - so we can jump over code
	if (numifs>0) {
		if (iftabletype[numifs-1]==IFTABLETYPEIF||iftabletype[numifs-1]==IFTABLETYPEELSE) {
			unsigned int *temp = NULL;
			numifs--;
			temp = (unsigned int *) (byteCode + iftable[numifs]);
			*temp = byteOffset; 
		} else {
			errorcode = testIfOnTableError();
			linenumber = testIfOnTable();
			return -1;
		}
	} else {
		errorcode = COMPERR_ENDIF;
		return -1;
	}
}
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 641 "basicParse.y"
    {
	// create temp
	//if true, don't branch. If false, go to next line do the loop.
	addOp(OP_BRANCH);
	// after branch add a placeholder for the final end of the loop
	// it will be resolved in the endwhile statement, push the
	// location of this location on the iftable
	newIf(addInt(0), linenumber-1, IFTABLETYPEWHILE);
}
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 656 "basicParse.y"
    {
	// there should be two bytecode locations.  the TOP is the
	// location to jump to at the top of the loopthe , TOP-1 is the location
	// the exit jump needs to be written back to jump point on WHILE
	if (numifs>1) {
		if (iftabletype[numifs-1]==IFTABLETYPEWHILE) {
			unsigned int *temp = NULL;
			addIntOp(OP_PUSHINT, 0);	// false - always jump back to the beginning
			addIntOp(OP_BRANCH, iftable[numifs-1]);
			// resolve the false jump on the while to the current location
			temp = (unsigned int *) (byteCode + iftable[numifs-2]);
			*temp = byteOffset; 
			numifs-=2;
		} else {
			errorcode = testIfOnTableError();
			linenumber = testIfOnTable();
			return -1;
		}
	} else {
		errorcode = COMPERR_ENDWHILE;
		return -1;
	}
}
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 682 "basicParse.y"
    {
		// need nothing done at top of a do
	}
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 688 "basicParse.y"
    {
	// create temp
	//if If false, go to to the corresponding do.
	if (numifs>0) {
		if (iftabletype[numifs-1]==IFTABLETYPEDO) {
			addIntOp(OP_BRANCH, iftable[numifs-1]);
			numifs--;
		} else {
			errorcode = testIfOnTableError();
			linenumber = testIfOnTable();
			return -1;
		}
	} else {
		errorcode = COMPERR_UNTIL;
		return -1;
	}
}
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 786 "basicParse.y"
    {
		addIntOp(OP_PUSHINT, 1);
		addIntOp(OP_DIM, (yyvsp[(2) - (3)].number));
	}
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 790 "basicParse.y"
    {
		addIntOp(OP_PUSHINT, 1);
		addIntOp(OP_DIMSTR, (yyvsp[(2) - (3)].number));
	}
    break;

  case 128:

/* Line 1806 of yacc.c  */
#line 794 "basicParse.y"
    { addIntOp(OP_DIM, (yyvsp[(2) - (7)].number)); }
    break;

  case 129:

/* Line 1806 of yacc.c  */
#line 795 "basicParse.y"
    { addIntOp(OP_DIMSTR, (yyvsp[(2) - (7)].number)); }
    break;

  case 130:

/* Line 1806 of yacc.c  */
#line 798 "basicParse.y"
    {
		addIntOp(OP_PUSHINT, 1);
		addIntOp(OP_REDIM, (yyvsp[(2) - (3)].number));
	}
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 802 "basicParse.y"
    {
		addIntOp(OP_PUSHINT, 1);
		addIntOp(OP_REDIMSTR, (yyvsp[(2) - (3)].number));
	}
    break;

  case 132:

/* Line 1806 of yacc.c  */
#line 806 "basicParse.y"
    { addIntOp(OP_REDIM, (yyvsp[(2) - (7)].number)); }
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 807 "basicParse.y"
    { addIntOp(OP_REDIMSTR, (yyvsp[(2) - (7)].number)); }
    break;

  case 134:

/* Line 1806 of yacc.c  */
#line 810 "basicParse.y"
    { addOp(OP_PAUSE); }
    break;

  case 135:

/* Line 1806 of yacc.c  */
#line 813 "basicParse.y"
    { addOp(OP_THROWERROR); }
    break;

  case 136:

/* Line 1806 of yacc.c  */
#line 816 "basicParse.y"
    { addOp(OP_CLS); }
    break;

  case 137:

/* Line 1806 of yacc.c  */
#line 817 "basicParse.y"
    { addOp(OP_CLG); }
    break;

  case 138:

/* Line 1806 of yacc.c  */
#line 820 "basicParse.y"
    { addOp(OP_FASTGRAPHICS); }
    break;

  case 139:

/* Line 1806 of yacc.c  */
#line 823 "basicParse.y"
    { addOp(OP_GRAPHSIZE); }
    break;

  case 140:

/* Line 1806 of yacc.c  */
#line 824 "basicParse.y"
    { addOp(OP_GRAPHSIZE); }
    break;

  case 141:

/* Line 1806 of yacc.c  */
#line 827 "basicParse.y"
    { addOp(OP_REFRESH); }
    break;

  case 142:

/* Line 1806 of yacc.c  */
#line 830 "basicParse.y"
    { addOp(OP_END); }
    break;

  case 143:

/* Line 1806 of yacc.c  */
#line 834 "basicParse.y"
    {
	//if true, don't branch. If false, go to next line.
	addOp(OP_BRANCH);
	// after branch add a placeholder for the final end of the if
	// it will be resolved in the if/else/endif statement, push the
	// location of this location on the iftable
	checkByteMem(sizeof(int));
	newIf(byteOffset, linenumber, IFTABLETYPEIF);
	byteOffset += sizeof(int);
	}
    break;

  case 144:

/* Line 1806 of yacc.c  */
#line 846 "basicParse.y"
    { addIntOp(OP_STRARRAYASSIGN, (yyvsp[(1) - (6)].number)); }
    break;

  case 145:

/* Line 1806 of yacc.c  */
#line 847 "basicParse.y"
    {
		// a$[n] += s$
		addOp(OP_STACKSWAP);
		addOp(OP_STACKDUP);
		addIntOp(OP_DEREF,(yyvsp[(1) - (6)].number));
		addOp(OP_STACKTOPTO2);
		addOp(OP_STACKTOPTO2);
		addOp(OP_CONCAT);
		addIntOp(OP_STRARRAYASSIGN, (yyvsp[(1) - (6)].number));
	}
    break;

  case 146:

/* Line 1806 of yacc.c  */
#line 857 "basicParse.y"
    { addIntOp(OP_STRARRAYASSIGN2D, (yyvsp[(1) - (8)].number)); }
    break;

  case 147:

/* Line 1806 of yacc.c  */
#line 858 "basicParse.y"
    {
		// a$[b,c] += s$
		addOp(OP_STACKTOPTO2);
		addOp(OP_STACKDUP2);
		addIntOp(OP_DEREF2D,(yyvsp[(1) - (8)].number));
		addOp(OP_STACKTOPTO2);
		addOp(OP_STACKSWAP2);
		addOp(OP_STACKSWAP);
		addOp(OP_CONCAT);
		addIntOp(OP_STRARRAYASSIGN2D, (yyvsp[(1) - (8)].number));
	}
    break;

  case 148:

/* Line 1806 of yacc.c  */
#line 870 "basicParse.y"
    {
		addInt2Op(OP_STRARRAYLISTASSIGN, (yyvsp[(1) - (3)].number), listlen);
		listlen = 0;
	}
    break;

  case 149:

/* Line 1806 of yacc.c  */
#line 874 "basicParse.y"
    { addIntOp(OP_EXPLODESTR, (yyvsp[(1) - (8)].number));}
    break;

  case 150:

/* Line 1806 of yacc.c  */
#line 875 "basicParse.y"
    { addIntOp(OP_EXPLODESTR_C, (yyvsp[(1) - (10)].number)); }
    break;

  case 151:

/* Line 1806 of yacc.c  */
#line 876 "basicParse.y"
    { addIntOp(OP_EXPLODEXSTR, (yyvsp[(1) - (8)].number));}
    break;

  case 152:

/* Line 1806 of yacc.c  */
#line 877 "basicParse.y"
    {
		errorcode = COMPERR_ASSIGNN2S;
		if (yytext[0] == '\n') { linenumber--; };
		return -1;
	}
    break;

  case 153:

/* Line 1806 of yacc.c  */
#line 882 "basicParse.y"
    {
		errorcode = COMPERR_ASSIGNN2S;
		if (yytext[0] == '\n') { linenumber--; };
		return -1;
	}
    break;

  case 154:

/* Line 1806 of yacc.c  */
#line 887 "basicParse.y"
    {
		errorcode = COMPERR_ASSIGNN2S;
		if (yytext[0] == '\n') { linenumber--; };
		return -1;
	}
    break;

  case 155:

/* Line 1806 of yacc.c  */
#line 894 "basicParse.y"
    {
		addIntOp(OP_ARRAYASSIGN, (yyvsp[(1) - (6)].number));
	}
    break;

  case 156:

/* Line 1806 of yacc.c  */
#line 897 "basicParse.y"
    {
		// a[n]++ (Statement)
		addOp(OP_STACKDUP);
		addIntOp(OP_DEREF,(yyvsp[(1) - (5)].number));
		addIntOp(OP_PUSHINT,1);
		addOp(OP_ADD);
		addIntOp(OP_ARRAYASSIGN, (yyvsp[(1) - (5)].number));
	}
    break;

  case 157:

/* Line 1806 of yacc.c  */
#line 905 "basicParse.y"
    {
		// a[n]-- (Statement)
		addOp(OP_STACKDUP);
		addIntOp(OP_DEREF,(yyvsp[(1) - (5)].number));
		addIntOp(OP_PUSHINT,1);
		addOp(OP_SUB);
		addIntOp(OP_ARRAYASSIGN, (yyvsp[(1) - (5)].number));
	}
    break;

  case 158:

/* Line 1806 of yacc.c  */
#line 913 "basicParse.y"
    {
		// a[n] += n
		addOp(OP_STACKSWAP);
		addOp(OP_STACKDUP);
		addIntOp(OP_DEREF,(yyvsp[(1) - (6)].number));
		addOp(OP_STACKTOPTO2);
		addOp(OP_STACKTOPTO2);
		addOp(OP_ADD);
		addIntOp(OP_ARRAYASSIGN, (yyvsp[(1) - (6)].number));
	}
    break;

  case 159:

/* Line 1806 of yacc.c  */
#line 923 "basicParse.y"
    {
		// a[n] -= n
		addOp(OP_STACKSWAP);
		addOp(OP_STACKDUP);
		addIntOp(OP_DEREF,(yyvsp[(1) - (6)].number));
		addOp(OP_STACKTOPTO2);
		addOp(OP_STACKTOPTO2);
		addOp(OP_SUB);
		addIntOp(OP_ARRAYASSIGN, (yyvsp[(1) - (6)].number));
	}
    break;

  case 160:

/* Line 1806 of yacc.c  */
#line 933 "basicParse.y"
    {
		// a[n] *= n
		addOp(OP_STACKSWAP);
		addOp(OP_STACKDUP);
		addIntOp(OP_DEREF,(yyvsp[(1) - (6)].number));
		addOp(OP_STACKTOPTO2);
		addOp(OP_STACKTOPTO2);
		addOp(OP_MUL);
		addIntOp(OP_ARRAYASSIGN, (yyvsp[(1) - (6)].number));
	}
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 943 "basicParse.y"
    {
		// a[n] /= n
		addOp(OP_STACKSWAP);
		addOp(OP_STACKDUP);
		addIntOp(OP_DEREF,(yyvsp[(1) - (6)].number));
		addOp(OP_STACKTOPTO2);
		addOp(OP_STACKTOPTO2);
		addOp(OP_DIV);
		addIntOp(OP_ARRAYASSIGN, (yyvsp[(1) - (6)].number));
	}
    break;

  case 162:

/* Line 1806 of yacc.c  */
#line 953 "basicParse.y"
    {
		addIntOp(OP_ARRAYASSIGN2D, (yyvsp[(1) - (8)].number));
	}
    break;

  case 163:

/* Line 1806 of yacc.c  */
#line 956 "basicParse.y"
    {
		addOp(OP_STACKDUP2);
		addIntOp(OP_DEREF2D,(yyvsp[(1) - (7)].number));
		addIntOp(OP_PUSHINT,1);
		addOp(OP_ADD);
		addIntOp(OP_ARRAYASSIGN2D, (yyvsp[(1) - (7)].number));
	}
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 963 "basicParse.y"
    {
		addOp(OP_STACKDUP2);
		addIntOp(OP_DEREF2D,(yyvsp[(1) - (7)].number));
		addIntOp(OP_PUSHINT,1);
		addOp(OP_SUB);
		addIntOp(OP_ARRAYASSIGN2D, (yyvsp[(1) - (7)].number));
	}
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 970 "basicParse.y"
    {
		// a[b,c] += n
		addOp(OP_STACKTOPTO2);
		addOp(OP_STACKDUP2);
		addIntOp(OP_DEREF2D,(yyvsp[(1) - (8)].number));
		addOp(OP_STACKTOPTO2);
		addOp(OP_STACKSWAP2);
		addOp(OP_ADD);
		addIntOp(OP_ARRAYASSIGN2D, (yyvsp[(1) - (8)].number));
	}
    break;

  case 166:

/* Line 1806 of yacc.c  */
#line 980 "basicParse.y"
    {
		// a[b,c] -= n
		addOp(OP_STACKTOPTO2);
		addOp(OP_STACKDUP2);
		addIntOp(OP_DEREF2D,(yyvsp[(1) - (8)].number));
		addOp(OP_STACKTOPTO2);
		addOp(OP_STACKSWAP2);
		addOp(OP_STACKSWAP);
		addOp(OP_SUB);
		addIntOp(OP_ARRAYASSIGN2D, (yyvsp[(1) - (8)].number));
	}
    break;

  case 167:

/* Line 1806 of yacc.c  */
#line 991 "basicParse.y"
    {
		// a[b,c] *= n
		addOp(OP_STACKTOPTO2);
		addOp(OP_STACKDUP2);
		addIntOp(OP_DEREF2D,(yyvsp[(1) - (8)].number));
		addOp(OP_STACKTOPTO2);
		addOp(OP_STACKSWAP2);
		addOp(OP_MUL);
		addIntOp(OP_ARRAYASSIGN2D, (yyvsp[(1) - (8)].number));
	}
    break;

  case 168:

/* Line 1806 of yacc.c  */
#line 1001 "basicParse.y"
    {
		// a[b,c] /= n
		addOp(OP_STACKTOPTO2);
		addOp(OP_STACKDUP2);
		addIntOp(OP_DEREF2D,(yyvsp[(1) - (8)].number));
		addOp(OP_STACKTOPTO2);
		addOp(OP_STACKSWAP2);
		addOp(OP_STACKSWAP);
		addOp(OP_DIV);
		addIntOp(OP_ARRAYASSIGN2D, (yyvsp[(1) - (8)].number));
	}
    break;

  case 169:

/* Line 1806 of yacc.c  */
#line 1012 "basicParse.y"
    {
		addInt2Op(OP_ARRAYLISTASSIGN, (yyvsp[(1) - (3)].number), listlen);
		listlen = 0;
	}
    break;

  case 170:

/* Line 1806 of yacc.c  */
#line 1016 "basicParse.y"
    {
		addIntOp(OP_EXPLODE, (yyvsp[(1) - (8)].number));
	}
    break;

  case 171:

/* Line 1806 of yacc.c  */
#line 1019 "basicParse.y"
    {
		addIntOp(OP_EXPLODE_C, (yyvsp[(1) - (10)].number));
	}
    break;

  case 172:

/* Line 1806 of yacc.c  */
#line 1022 "basicParse.y"
    {
		addIntOp(OP_EXPLODEX, (yyvsp[(1) - (8)].number));
	}
    break;

  case 173:

/* Line 1806 of yacc.c  */
#line 1025 "basicParse.y"
    {
		errorcode = COMPERR_ASSIGNS2N;
		if (yytext[0] == '\n') { linenumber--; };
		return -1;
	}
    break;

  case 174:

/* Line 1806 of yacc.c  */
#line 1030 "basicParse.y"
    {
		errorcode = COMPERR_ASSIGNS2N;
		if (yytext[0] == '\n') { linenumber--; };
		return -1;
	}
    break;

  case 175:

/* Line 1806 of yacc.c  */
#line 1035 "basicParse.y"
    {
		errorcode = COMPERR_ASSIGNS2N;
		if (yytext[0] == '\n') { linenumber--; };
		return -1;
	}
    break;

  case 176:

/* Line 1806 of yacc.c  */
#line 1044 "basicParse.y"
    { addIntOp(OP_NUMASSIGN, (yyvsp[(1) - (3)].number)); }
    break;

  case 177:

/* Line 1806 of yacc.c  */
#line 1045 "basicParse.y"
    {
		errorcode = COMPERR_ASSIGNS2N;
		if (yytext[0] == '\n') { linenumber--; };
		return -1;
	}
    break;

  case 178:

/* Line 1806 of yacc.c  */
#line 1050 "basicParse.y"
    {
		addIntOp(OP_PUSHVAR,(yyvsp[(1) - (2)].number));
		addIntOp(OP_PUSHINT,1);
		addOp(OP_ADD);
		addIntOp(OP_NUMASSIGN, (yyvsp[(1) - (2)].number));
	}
    break;

  case 179:

/* Line 1806 of yacc.c  */
#line 1056 "basicParse.y"
    {
		addIntOp(OP_PUSHVAR,(yyvsp[(1) - (2)].number));
		addIntOp(OP_PUSHINT,1);
		addOp(OP_SUB);
		addIntOp(OP_NUMASSIGN, (yyvsp[(1) - (2)].number));
	}
    break;

  case 180:

/* Line 1806 of yacc.c  */
#line 1062 "basicParse.y"
    {
		addIntOp(OP_PUSHVAR,(yyvsp[(1) - (3)].number));
		addOp(OP_ADD);
		addIntOp(OP_NUMASSIGN, (yyvsp[(1) - (3)].number));
	}
    break;

  case 181:

/* Line 1806 of yacc.c  */
#line 1067 "basicParse.y"
    {
		addIntOp(OP_PUSHVAR,(yyvsp[(1) - (3)].number));
		addOp(OP_STACKSWAP);
		addOp(OP_SUB);
		addIntOp(OP_NUMASSIGN, (yyvsp[(1) - (3)].number));
	}
    break;

  case 182:

/* Line 1806 of yacc.c  */
#line 1073 "basicParse.y"
    {
		addIntOp(OP_PUSHVAR,(yyvsp[(1) - (3)].number));
		addOp(OP_MUL);
		addIntOp(OP_NUMASSIGN, (yyvsp[(1) - (3)].number));
	}
    break;

  case 183:

/* Line 1806 of yacc.c  */
#line 1078 "basicParse.y"
    {
		addIntOp(OP_PUSHVAR,(yyvsp[(1) - (3)].number));
		addOp(OP_STACKSWAP);
		addOp(OP_DIV);
		addIntOp(OP_NUMASSIGN, (yyvsp[(1) - (3)].number));
	}
    break;

  case 184:

/* Line 1806 of yacc.c  */
#line 1087 "basicParse.y"
    { addIntOp(OP_STRINGASSIGN, (yyvsp[(1) - (3)].number)); }
    break;

  case 185:

/* Line 1806 of yacc.c  */
#line 1088 "basicParse.y"
    {
		errorcode = COMPERR_ASSIGNN2S;
		if (yytext[0] == '\n') { linenumber--; };
		return -1;
	}
    break;

  case 186:

/* Line 1806 of yacc.c  */
#line 1093 "basicParse.y"
    {
		addIntOp(OP_PUSHVAR,(yyvsp[(1) - (3)].number));
		addOp(OP_STACKSWAP);
		addOp(OP_CONCAT);
		addIntOp(OP_STRINGASSIGN, (yyvsp[(1) - (3)].number));
	}
    break;

  case 187:

/* Line 1806 of yacc.c  */
#line 1102 "basicParse.y"
    {
		addIntOp(OP_PUSHINT, 1); //step
		addIntOp(OP_FOR, (yyvsp[(2) - (6)].number));
		// add to iftable to make sure it is not broken with an if
		// do, while, else, and to report if it is
		// next ed before end of program
		newIf(0, linenumber-1, IFTABLETYPEFOR);
	}
    break;

  case 188:

/* Line 1806 of yacc.c  */
#line 1111 "basicParse.y"
    {
		addIntOp(OP_FOR, (yyvsp[(2) - (8)].number));
		// add to iftable to make sure it is not broken with an if
		// do, while, else, and to report if it is
		// next ed before end of program
		newIf(0, linenumber-1, IFTABLETYPEFOR);
	}
    break;

  case 189:

/* Line 1806 of yacc.c  */
#line 1121 "basicParse.y"
    {
		if (numifs>0) {
			if (iftabletype[numifs-1]==IFTABLETYPEFOR) {
				addIntOp(OP_NEXT, (yyvsp[(2) - (2)].number));
				numifs--;
			} else {
				errorcode = testIfOnTableError();
				linenumber = testIfOnTable();
				return -1;
			}
		} else {
			errorcode = COMPERR_NEXT;
			return -1;
		}
	}
    break;

  case 190:

/* Line 1806 of yacc.c  */
#line 1138 "basicParse.y"
    {
	if (functionDefSymbol != -1 || subroutineDefSymbol !=-1) {
		errorcode = COMPERR_FUNCTIONGOTO;
		return -1;
	}
	addIntOp(OP_GOTO, (yyvsp[(2) - (2)].number));
}
    break;

  case 191:

/* Line 1806 of yacc.c  */
#line 1147 "basicParse.y"
    {
	if (functionDefSymbol != -1 || subroutineDefSymbol !=-1) {
		errorcode = COMPERR_FUNCTIONGOTO;
		return -1;
	}
	addIntOp(OP_GOSUB, (yyvsp[(2) - (2)].number));
}
    break;

  case 192:

/* Line 1806 of yacc.c  */
#line 1156 "basicParse.y"
    { addIntOp(OP_GOSUB, (yyvsp[(2) - (2)].number)); }
    break;

  case 193:

/* Line 1806 of yacc.c  */
#line 1157 "basicParse.y"
    { addIntOp(OP_GOSUB, (yyvsp[(2) - (4)].number)); }
    break;

  case 194:

/* Line 1806 of yacc.c  */
#line 1158 "basicParse.y"
    { addIntOp(OP_GOSUB, (yyvsp[(2) - (5)].number)); }
    break;

  case 195:

/* Line 1806 of yacc.c  */
#line 1161 "basicParse.y"
    { addExtendedOp(OP_OFFERROR); }
    break;

  case 196:

/* Line 1806 of yacc.c  */
#line 1164 "basicParse.y"
    { addIntOp(OP_ONERROR, (yyvsp[(2) - (2)].number)); }
    break;

  case 197:

/* Line 1806 of yacc.c  */
#line 1167 "basicParse.y"
    { 
	if (functionDefSymbol!=-1) {
		// if we are defining a function return pushes a variable value
		addIntOp(OP_PUSHVAR, functionDefSymbol);
		addOp(OP_DECREASERECURSE);
	}
	if (subroutineDefSymbol!=-1) {
		// if we are defining a rubroutine
		addOp(OP_DECREASERECURSE);
	}
	addOp(OP_RETURN);
 }
    break;

  case 198:

/* Line 1806 of yacc.c  */
#line 1181 "basicParse.y"
    { addOp(OP_SETCOLORRGB); }
    break;

  case 199:

/* Line 1806 of yacc.c  */
#line 1182 "basicParse.y"
    { addOp(OP_SETCOLORRGB); }
    break;

  case 200:

/* Line 1806 of yacc.c  */
#line 1183 "basicParse.y"
    { addOp(OP_SETCOLORINT); }
    break;

  case 201:

/* Line 1806 of yacc.c  */
#line 1186 "basicParse.y"
    { addIntOp(OP_SOUND_ARRAY, (yyvsp[(3) - (4)].number)); }
    break;

  case 202:

/* Line 1806 of yacc.c  */
#line 1187 "basicParse.y"
    { addIntOp(OP_SOUND_ARRAY, (yyvsp[(2) - (2)].number)); }
    break;

  case 203:

/* Line 1806 of yacc.c  */
#line 1188 "basicParse.y"
    { addIntOp(OP_SOUND_LIST, listlen); listlen=0; }
    break;

  case 204:

/* Line 1806 of yacc.c  */
#line 1189 "basicParse.y"
    { addOp(OP_SOUND); }
    break;

  case 205:

/* Line 1806 of yacc.c  */
#line 1190 "basicParse.y"
    { addOp(OP_SOUND); }
    break;

  case 206:

/* Line 1806 of yacc.c  */
#line 1193 "basicParse.y"
    { addOp(OP_PLOT); }
    break;

  case 207:

/* Line 1806 of yacc.c  */
#line 1194 "basicParse.y"
    { addOp(OP_PLOT); }
    break;

  case 208:

/* Line 1806 of yacc.c  */
#line 1197 "basicParse.y"
    { addOp(OP_LINE); }
    break;

  case 209:

/* Line 1806 of yacc.c  */
#line 1198 "basicParse.y"
    { addOp(OP_LINE); }
    break;

  case 210:

/* Line 1806 of yacc.c  */
#line 1202 "basicParse.y"
    { addOp(OP_CIRCLE); }
    break;

  case 211:

/* Line 1806 of yacc.c  */
#line 1203 "basicParse.y"
    { addOp(OP_CIRCLE); }
    break;

  case 212:

/* Line 1806 of yacc.c  */
#line 1206 "basicParse.y"
    { addOp(OP_RECT); }
    break;

  case 213:

/* Line 1806 of yacc.c  */
#line 1207 "basicParse.y"
    { addOp(OP_RECT); }
    break;

  case 214:

/* Line 1806 of yacc.c  */
#line 1210 "basicParse.y"
    { addOp(OP_TEXT); }
    break;

  case 215:

/* Line 1806 of yacc.c  */
#line 1211 "basicParse.y"
    { addOp(OP_TEXT); }
    break;

  case 216:

/* Line 1806 of yacc.c  */
#line 1212 "basicParse.y"
    { addOp(OP_TEXT); }
    break;

  case 217:

/* Line 1806 of yacc.c  */
#line 1213 "basicParse.y"
    { addOp(OP_TEXT); }
    break;

  case 218:

/* Line 1806 of yacc.c  */
#line 1216 "basicParse.y"
    { addOp(OP_FONT); }
    break;

  case 219:

/* Line 1806 of yacc.c  */
#line 1217 "basicParse.y"
    { addOp(OP_FONT); }
    break;

  case 220:

/* Line 1806 of yacc.c  */
#line 1220 "basicParse.y"
    { addOp(OP_SAY); }
    break;

  case 221:

/* Line 1806 of yacc.c  */
#line 1221 "basicParse.y"
    { addOp(OP_SAY); }
    break;

  case 222:

/* Line 1806 of yacc.c  */
#line 1224 "basicParse.y"
    { addOp(OP_SYSTEM); }
    break;

  case 223:

/* Line 1806 of yacc.c  */
#line 1227 "basicParse.y"
    { addOp(OP_VOLUME); }
    break;

  case 224:

/* Line 1806 of yacc.c  */
#line 1230 "basicParse.y"
    { addIntOp(OP_POLY, (yyvsp[(2) - (2)].number)); }
    break;

  case 225:

/* Line 1806 of yacc.c  */
#line 1231 "basicParse.y"
    { addIntOp(OP_POLY, (yyvsp[(3) - (4)].number)); }
    break;

  case 226:

/* Line 1806 of yacc.c  */
#line 1232 "basicParse.y"
    { addIntOp(OP_POLY_LIST, listlen); listlen=0; }
    break;

  case 227:

/* Line 1806 of yacc.c  */
#line 1235 "basicParse.y"
    { addFloatOp(OP_PUSHFLOAT, 0); addIntOp(OP_STAMP, (yyvsp[(8) - (8)].number)); }
    break;

  case 228:

/* Line 1806 of yacc.c  */
#line 1236 "basicParse.y"
    { addFloatOp(OP_PUSHFLOAT, 0); addIntOp(OP_STAMP, (yyvsp[(9) - (10)].number)); }
    break;

  case 229:

/* Line 1806 of yacc.c  */
#line 1237 "basicParse.y"
    { addIntOp(OP_STAMP_S_LIST, listlen); listlen=0; }
    break;

  case 230:

/* Line 1806 of yacc.c  */
#line 1238 "basicParse.y"
    { addFloatOp(OP_PUSHFLOAT, 1); addFloatOp(OP_PUSHFLOAT, 0); addIntOp(OP_STAMP, (yyvsp[(6) - (6)].number)); }
    break;

  case 231:

/* Line 1806 of yacc.c  */
#line 1239 "basicParse.y"
    { addFloatOp(OP_PUSHFLOAT, 1); addFloatOp(OP_PUSHFLOAT, 0); addIntOp(OP_STAMP, (yyvsp[(7) - (8)].number)); }
    break;

  case 232:

/* Line 1806 of yacc.c  */
#line 1240 "basicParse.y"
    { addIntOp(OP_STAMP_LIST, listlen); listlen=0; }
    break;

  case 233:

/* Line 1806 of yacc.c  */
#line 1241 "basicParse.y"
    { addIntOp(OP_STAMP, (yyvsp[(10) - (10)].number)); }
    break;

  case 234:

/* Line 1806 of yacc.c  */
#line 1242 "basicParse.y"
    { addIntOp(OP_STAMP, (yyvsp[(11) - (12)].number)); }
    break;

  case 235:

/* Line 1806 of yacc.c  */
#line 1243 "basicParse.y"
    { addIntOp(OP_STAMP_SR_LIST, listlen); listlen=0; }
    break;

  case 236:

/* Line 1806 of yacc.c  */
#line 1246 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_STACKSWAP); addIntOp(OP_PUSHINT, 0); addOp(OP_OPEN); }
    break;

  case 237:

/* Line 1806 of yacc.c  */
#line 1247 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_OPEN); }
    break;

  case 238:

/* Line 1806 of yacc.c  */
#line 1248 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_OPEN); }
    break;

  case 239:

/* Line 1806 of yacc.c  */
#line 1249 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_STACKSWAP); addIntOp(OP_PUSHINT, 1); addOp(OP_OPEN); }
    break;

  case 240:

/* Line 1806 of yacc.c  */
#line 1250 "basicParse.y"
    { addIntOp(OP_PUSHINT, 1); addOp(OP_OPEN); }
    break;

  case 241:

/* Line 1806 of yacc.c  */
#line 1251 "basicParse.y"
    { addIntOp(OP_PUSHINT, 1); addOp(OP_OPEN); }
    break;

  case 242:

/* Line 1806 of yacc.c  */
#line 1254 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_STACKSWAP); addOp(OP_WRITE); }
    break;

  case 243:

/* Line 1806 of yacc.c  */
#line 1255 "basicParse.y"
    { addOp(OP_WRITE); }
    break;

  case 244:

/* Line 1806 of yacc.c  */
#line 1256 "basicParse.y"
    { addOp(OP_WRITE); }
    break;

  case 245:

/* Line 1806 of yacc.c  */
#line 1259 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_STACKSWAP); addOp(OP_WRITELINE); }
    break;

  case 246:

/* Line 1806 of yacc.c  */
#line 1260 "basicParse.y"
    { addOp(OP_WRITELINE); }
    break;

  case 247:

/* Line 1806 of yacc.c  */
#line 1261 "basicParse.y"
    { addOp(OP_WRITELINE); }
    break;

  case 248:

/* Line 1806 of yacc.c  */
#line 1264 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_STACKSWAP); addOp(OP_WRITEBYTE); }
    break;

  case 249:

/* Line 1806 of yacc.c  */
#line 1265 "basicParse.y"
    { addOp(OP_WRITEBYTE); }
    break;

  case 250:

/* Line 1806 of yacc.c  */
#line 1266 "basicParse.y"
    { addOp(OP_WRITEBYTE); }
    break;

  case 251:

/* Line 1806 of yacc.c  */
#line 1269 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_CLOSE); }
    break;

  case 252:

/* Line 1806 of yacc.c  */
#line 1270 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_CLOSE); }
    break;

  case 253:

/* Line 1806 of yacc.c  */
#line 1271 "basicParse.y"
    { addOp(OP_CLOSE); }
    break;

  case 254:

/* Line 1806 of yacc.c  */
#line 1274 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_RESET); }
    break;

  case 255:

/* Line 1806 of yacc.c  */
#line 1275 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_RESET); }
    break;

  case 256:

/* Line 1806 of yacc.c  */
#line 1276 "basicParse.y"
    { addOp(OP_RESET); }
    break;

  case 257:

/* Line 1806 of yacc.c  */
#line 1279 "basicParse.y"
    {addIntOp(OP_PUSHINT, 0); addOp(OP_STACKSWAP);addOp(OP_SEEK); }
    break;

  case 258:

/* Line 1806 of yacc.c  */
#line 1280 "basicParse.y"
    { addOp(OP_SEEK); }
    break;

  case 259:

/* Line 1806 of yacc.c  */
#line 1281 "basicParse.y"
    { addOp(OP_SEEK); }
    break;

  case 260:

/* Line 1806 of yacc.c  */
#line 1284 "basicParse.y"
    { addIntOp(OP_STRINGASSIGN, (yyvsp[(3) - (3)].number)); }
    break;

  case 261:

/* Line 1806 of yacc.c  */
#line 1285 "basicParse.y"
    { addOp(OP_STACKSWAP); addIntOp(OP_STRARRAYASSIGN, (yyvsp[(3) - (6)].number)); }
    break;

  case 262:

/* Line 1806 of yacc.c  */
#line 1286 "basicParse.y"
    { addIntOp(OP_NUMASSIGN, (yyvsp[(3) - (3)].number)); }
    break;

  case 263:

/* Line 1806 of yacc.c  */
#line 1287 "basicParse.y"
    { addOp(OP_STACKSWAP); addIntOp(OP_ARRAYASSIGN, (yyvsp[(3) - (6)].number)); }
    break;

  case 264:

/* Line 1806 of yacc.c  */
#line 1288 "basicParse.y"
    { addOp(OP_INPUT); addIntOp(OP_STRINGASSIGN, (yyvsp[(2) - (2)].number)); }
    break;

  case 265:

/* Line 1806 of yacc.c  */
#line 1289 "basicParse.y"
    { addOp(OP_INPUT); addIntOp(OP_STRARRAYASSIGN, (yyvsp[(2) - (5)].number)); }
    break;

  case 266:

/* Line 1806 of yacc.c  */
#line 1290 "basicParse.y"
    { addOp(OP_INPUT); addIntOp(OP_STRARRAYASSIGN2D, (yyvsp[(2) - (7)].number)); }
    break;

  case 267:

/* Line 1806 of yacc.c  */
#line 1291 "basicParse.y"
    { addOp(OP_INPUT); addIntOp(OP_NUMASSIGN, (yyvsp[(2) - (2)].number)); }
    break;

  case 268:

/* Line 1806 of yacc.c  */
#line 1292 "basicParse.y"
    { addOp(OP_INPUT); addIntOp(OP_ARRAYASSIGN, (yyvsp[(2) - (5)].number)); }
    break;

  case 269:

/* Line 1806 of yacc.c  */
#line 1293 "basicParse.y"
    { addOp(OP_INPUT); addIntOp(OP_ARRAYASSIGN2D, (yyvsp[(2) - (7)].number)); }
    break;

  case 270:

/* Line 1806 of yacc.c  */
#line 1296 "basicParse.y"
    { addOp(OP_PRINT);  addOp(OP_INPUT); }
    break;

  case 271:

/* Line 1806 of yacc.c  */
#line 1299 "basicParse.y"
    { addStringOp(OP_PUSHSTRING, ""); addOp(OP_PRINTN); }
    break;

  case 272:

/* Line 1806 of yacc.c  */
#line 1300 "basicParse.y"
    { addOp(OP_PRINTN); }
    break;

  case 273:

/* Line 1806 of yacc.c  */
#line 1301 "basicParse.y"
    { addOp(OP_PRINTN); }
    break;

  case 274:

/* Line 1806 of yacc.c  */
#line 1302 "basicParse.y"
    { addOp(OP_PRINT); }
    break;

  case 275:

/* Line 1806 of yacc.c  */
#line 1303 "basicParse.y"
    { addOp(OP_PRINT); }
    break;

  case 276:

/* Line 1806 of yacc.c  */
#line 1306 "basicParse.y"
    {addOp(OP_WAVPLAY);  }
    break;

  case 277:

/* Line 1806 of yacc.c  */
#line 1309 "basicParse.y"
    { addOp(OP_WAVSTOP); }
    break;

  case 278:

/* Line 1806 of yacc.c  */
#line 1310 "basicParse.y"
    { addOp(OP_WAVSTOP); }
    break;

  case 279:

/* Line 1806 of yacc.c  */
#line 1313 "basicParse.y"
    { addExtendedOp(OP_WAVWAIT); }
    break;

  case 280:

/* Line 1806 of yacc.c  */
#line 1314 "basicParse.y"
    { addExtendedOp(OP_WAVWAIT); }
    break;

  case 281:

/* Line 1806 of yacc.c  */
#line 1317 "basicParse.y"
    {addOp(OP_PUTSLICE);  }
    break;

  case 282:

/* Line 1806 of yacc.c  */
#line 1318 "basicParse.y"
    { addOp(OP_PUTSLICE); }
    break;

  case 283:

/* Line 1806 of yacc.c  */
#line 1319 "basicParse.y"
    {addOp(OP_PUTSLICEMASK);  }
    break;

  case 284:

/* Line 1806 of yacc.c  */
#line 1320 "basicParse.y"
    { addOp(OP_PUTSLICEMASK); }
    break;

  case 285:

/* Line 1806 of yacc.c  */
#line 1322 "basicParse.y"
    {addOp(OP_IMGLOAD);  }
    break;

  case 286:

/* Line 1806 of yacc.c  */
#line 1323 "basicParse.y"
    { addOp(OP_IMGLOAD); }
    break;

  case 287:

/* Line 1806 of yacc.c  */
#line 1324 "basicParse.y"
    { addOp(OP_IMGLOAD_S); }
    break;

  case 288:

/* Line 1806 of yacc.c  */
#line 1325 "basicParse.y"
    { addOp(OP_IMGLOAD_S); }
    break;

  case 289:

/* Line 1806 of yacc.c  */
#line 1326 "basicParse.y"
    { addOp(OP_IMGLOAD_SR); }
    break;

  case 290:

/* Line 1806 of yacc.c  */
#line 1327 "basicParse.y"
    { addOp(OP_IMGLOAD_SR); }
    break;

  case 291:

/* Line 1806 of yacc.c  */
#line 1330 "basicParse.y"
    { addExtendedOp(OP_SPRITEDIM); }
    break;

  case 292:

/* Line 1806 of yacc.c  */
#line 1333 "basicParse.y"
    {addExtendedOp(OP_SPRITELOAD);  }
    break;

  case 293:

/* Line 1806 of yacc.c  */
#line 1334 "basicParse.y"
    { addExtendedOp(OP_SPRITELOAD); }
    break;

  case 294:

/* Line 1806 of yacc.c  */
#line 1337 "basicParse.y"
    {addExtendedOp(OP_SPRITESLICE);  }
    break;

  case 295:

/* Line 1806 of yacc.c  */
#line 1338 "basicParse.y"
    { addExtendedOp(OP_SPRITESLICE); }
    break;

  case 296:

/* Line 1806 of yacc.c  */
#line 1341 "basicParse.y"
    {addExtendedOp(OP_SPRITEPLACE);  }
    break;

  case 297:

/* Line 1806 of yacc.c  */
#line 1342 "basicParse.y"
    { addExtendedOp(OP_SPRITEPLACE); }
    break;

  case 298:

/* Line 1806 of yacc.c  */
#line 1345 "basicParse.y"
    {addExtendedOp(OP_SPRITEMOVE);  }
    break;

  case 299:

/* Line 1806 of yacc.c  */
#line 1346 "basicParse.y"
    { addExtendedOp(OP_SPRITEMOVE); }
    break;

  case 300:

/* Line 1806 of yacc.c  */
#line 1349 "basicParse.y"
    { addExtendedOp(OP_SPRITEHIDE); }
    break;

  case 301:

/* Line 1806 of yacc.c  */
#line 1352 "basicParse.y"
    { addExtendedOp(OP_SPRITESHOW); }
    break;

  case 302:

/* Line 1806 of yacc.c  */
#line 1355 "basicParse.y"
    {addOp(OP_CLICKCLEAR);  }
    break;

  case 303:

/* Line 1806 of yacc.c  */
#line 1356 "basicParse.y"
    { addOp(OP_CLICKCLEAR); }
    break;

  case 304:

/* Line 1806 of yacc.c  */
#line 1359 "basicParse.y"
    { addExtendedOp(OP_CHANGEDIR); }
    break;

  case 305:

/* Line 1806 of yacc.c  */
#line 1362 "basicParse.y"
    { addExtendedOp(OP_DECIMAL); }
    break;

  case 306:

/* Line 1806 of yacc.c  */
#line 1365 "basicParse.y"
    { addExtendedOp(OP_DBOPEN); }
    break;

  case 307:

/* Line 1806 of yacc.c  */
#line 1368 "basicParse.y"
    { addExtendedOp(OP_DBCLOSE); }
    break;

  case 308:

/* Line 1806 of yacc.c  */
#line 1369 "basicParse.y"
    { addExtendedOp(OP_DBCLOSE); }
    break;

  case 309:

/* Line 1806 of yacc.c  */
#line 1372 "basicParse.y"
    { addExtendedOp(OP_DBEXECUTE); }
    break;

  case 310:

/* Line 1806 of yacc.c  */
#line 1375 "basicParse.y"
    { addExtendedOp(OP_DBOPENSET); }
    break;

  case 311:

/* Line 1806 of yacc.c  */
#line 1378 "basicParse.y"
    { addExtendedOp(OP_DBCLOSESET); }
    break;

  case 312:

/* Line 1806 of yacc.c  */
#line 1379 "basicParse.y"
    { addExtendedOp(OP_DBCLOSESET); }
    break;

  case 313:

/* Line 1806 of yacc.c  */
#line 1382 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_STACKSWAP); addExtendedOp(OP_NETLISTEN); }
    break;

  case 314:

/* Line 1806 of yacc.c  */
#line 1383 "basicParse.y"
    { addExtendedOp(OP_NETLISTEN); }
    break;

  case 315:

/* Line 1806 of yacc.c  */
#line 1384 "basicParse.y"
    { addExtendedOp(OP_NETLISTEN); }
    break;

  case 316:

/* Line 1806 of yacc.c  */
#line 1387 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_STACKTOPTO2); addExtendedOp(OP_NETCONNECT); }
    break;

  case 317:

/* Line 1806 of yacc.c  */
#line 1388 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_STACKTOPTO2); addExtendedOp(OP_NETCONNECT); }
    break;

  case 318:

/* Line 1806 of yacc.c  */
#line 1389 "basicParse.y"
    { addExtendedOp(OP_NETCONNECT); }
    break;

  case 319:

/* Line 1806 of yacc.c  */
#line 1390 "basicParse.y"
    { addExtendedOp(OP_NETCONNECT); }
    break;

  case 320:

/* Line 1806 of yacc.c  */
#line 1393 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_STACKSWAP); addExtendedOp(OP_NETWRITE); }
    break;

  case 321:

/* Line 1806 of yacc.c  */
#line 1394 "basicParse.y"
    { addExtendedOp(OP_NETWRITE); }
    break;

  case 322:

/* Line 1806 of yacc.c  */
#line 1395 "basicParse.y"
    { addExtendedOp(OP_NETWRITE); }
    break;

  case 323:

/* Line 1806 of yacc.c  */
#line 1398 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addExtendedOp(OP_NETCLOSE); }
    break;

  case 324:

/* Line 1806 of yacc.c  */
#line 1399 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addExtendedOp(OP_NETCLOSE); }
    break;

  case 325:

/* Line 1806 of yacc.c  */
#line 1400 "basicParse.y"
    { addExtendedOp(OP_NETCLOSE); }
    break;

  case 326:

/* Line 1806 of yacc.c  */
#line 1403 "basicParse.y"
    { addExtendedOp(OP_KILL); }
    break;

  case 327:

/* Line 1806 of yacc.c  */
#line 1404 "basicParse.y"
    { addExtendedOp(OP_KILL); }
    break;

  case 328:

/* Line 1806 of yacc.c  */
#line 1407 "basicParse.y"
    { addExtendedOp(OP_SETSETTING); }
    break;

  case 329:

/* Line 1806 of yacc.c  */
#line 1408 "basicParse.y"
    { addExtendedOp(OP_SETSETTING); }
    break;

  case 330:

/* Line 1806 of yacc.c  */
#line 1411 "basicParse.y"
    { addExtendedOp(OP_PORTOUT); }
    break;

  case 331:

/* Line 1806 of yacc.c  */
#line 1412 "basicParse.y"
    { addExtendedOp(OP_PORTOUT); }
    break;

  case 332:

/* Line 1806 of yacc.c  */
#line 1415 "basicParse.y"
    {addStringOp(OP_PUSHSTRING, "PNG"); addExtendedOp(OP_IMGSAVE); }
    break;

  case 333:

/* Line 1806 of yacc.c  */
#line 1416 "basicParse.y"
    { addExtendedOp(OP_IMGSAVE); }
    break;

  case 334:

/* Line 1806 of yacc.c  */
#line 1417 "basicParse.y"
    { addExtendedOp(OP_IMGSAVE); }
    break;

  case 335:

/* Line 1806 of yacc.c  */
#line 1420 "basicParse.y"
    { addExtendedOp(OP_EDITVISIBLE); }
    break;

  case 336:

/* Line 1806 of yacc.c  */
#line 1423 "basicParse.y"
    { addExtendedOp(OP_GRAPHVISIBLE); }
    break;

  case 337:

/* Line 1806 of yacc.c  */
#line 1426 "basicParse.y"
    { addExtendedOp(OP_OUTPUTVISIBLE); }
    break;

  case 338:

/* Line 1806 of yacc.c  */
#line 1429 "basicParse.y"
    {
	// create ops to make all of the variables listed globals
	if (numifs>0) {
		errorcode = COMPERR_GLOBALNOTHERE;
		return -1;
	}
 	int t;
	for(t=numargs-1;t>=0;t--) {
		addIntOp(OP_GLOBAL, args[t]);
	}
	numargs=0;	// clear the list for next function
}
    break;

  case 341:

/* Line 1806 of yacc.c  */
#line 1451 "basicParse.y"
    { listlen = 1; }
    break;

  case 342:

/* Line 1806 of yacc.c  */
#line 1452 "basicParse.y"
    { listlen++; }
    break;

  case 343:

/* Line 1806 of yacc.c  */
#line 1455 "basicParse.y"
    { listlen = 1; }
    break;

  case 344:

/* Line 1806 of yacc.c  */
#line 1456 "basicParse.y"
    { listlen++; }
    break;

  case 345:

/* Line 1806 of yacc.c  */
#line 1459 "basicParse.y"
    { listlen = 1; }
    break;

  case 346:

/* Line 1806 of yacc.c  */
#line 1460 "basicParse.y"
    { listlen = 1; }
    break;

  case 347:

/* Line 1806 of yacc.c  */
#line 1461 "basicParse.y"
    {listlen++;}
    break;

  case 348:

/* Line 1806 of yacc.c  */
#line 1465 "basicParse.y"
    { (yyval.floatnum) = (yyvsp[(2) - (3)].floatnum); }
    break;

  case 349:

/* Line 1806 of yacc.c  */
#line 1466 "basicParse.y"
    { addOp(OP_ADD); }
    break;

  case 350:

/* Line 1806 of yacc.c  */
#line 1467 "basicParse.y"
    { addOp(OP_SUB); }
    break;

  case 351:

/* Line 1806 of yacc.c  */
#line 1468 "basicParse.y"
    { addOp(OP_MUL); }
    break;

  case 352:

/* Line 1806 of yacc.c  */
#line 1469 "basicParse.y"
    { addOp(OP_MOD); }
    break;

  case 353:

/* Line 1806 of yacc.c  */
#line 1470 "basicParse.y"
    { addOp(OP_INTDIV); }
    break;

  case 354:

/* Line 1806 of yacc.c  */
#line 1471 "basicParse.y"
    { addOp(OP_DIV); }
    break;

  case 355:

/* Line 1806 of yacc.c  */
#line 1472 "basicParse.y"
    { addOp(OP_EX); }
    break;

  case 356:

/* Line 1806 of yacc.c  */
#line 1473 "basicParse.y"
    { addExtendedOp(OP_BINARYOR); }
    break;

  case 357:

/* Line 1806 of yacc.c  */
#line 1474 "basicParse.y"
    { addExtendedOp(OP_BINARYAND); }
    break;

  case 358:

/* Line 1806 of yacc.c  */
#line 1475 "basicParse.y"
    { addExtendedOp(OP_BINARYNOT); }
    break;

  case 359:

/* Line 1806 of yacc.c  */
#line 1476 "basicParse.y"
    { addOp(OP_NEGATE); }
    break;

  case 360:

/* Line 1806 of yacc.c  */
#line 1477 "basicParse.y"
    {addOp(OP_AND); }
    break;

  case 361:

/* Line 1806 of yacc.c  */
#line 1478 "basicParse.y"
    { addOp(OP_OR); }
    break;

  case 362:

/* Line 1806 of yacc.c  */
#line 1479 "basicParse.y"
    { addOp(OP_XOR); }
    break;

  case 363:

/* Line 1806 of yacc.c  */
#line 1480 "basicParse.y"
    { addOp(OP_NOT); }
    break;

  case 364:

/* Line 1806 of yacc.c  */
#line 1481 "basicParse.y"
    { addOp(OP_EQUAL); }
    break;

  case 365:

/* Line 1806 of yacc.c  */
#line 1482 "basicParse.y"
    { addOp(OP_NEQUAL); }
    break;

  case 366:

/* Line 1806 of yacc.c  */
#line 1483 "basicParse.y"
    { addOp(OP_LT); }
    break;

  case 367:

/* Line 1806 of yacc.c  */
#line 1484 "basicParse.y"
    { addOp(OP_GT); }
    break;

  case 368:

/* Line 1806 of yacc.c  */
#line 1485 "basicParse.y"
    { addOp(OP_GTE); }
    break;

  case 369:

/* Line 1806 of yacc.c  */
#line 1486 "basicParse.y"
    { addOp(OP_LTE); }
    break;

  case 370:

/* Line 1806 of yacc.c  */
#line 1487 "basicParse.y"
    { addOp(OP_EQUAL); }
    break;

  case 371:

/* Line 1806 of yacc.c  */
#line 1488 "basicParse.y"
    { addOp(OP_NEQUAL); }
    break;

  case 372:

/* Line 1806 of yacc.c  */
#line 1489 "basicParse.y"
    { addOp(OP_LT); }
    break;

  case 373:

/* Line 1806 of yacc.c  */
#line 1490 "basicParse.y"
    { addOp(OP_GT); }
    break;

  case 374:

/* Line 1806 of yacc.c  */
#line 1491 "basicParse.y"
    { addOp(OP_GTE); }
    break;

  case 375:

/* Line 1806 of yacc.c  */
#line 1492 "basicParse.y"
    { addOp(OP_LTE); }
    break;

  case 376:

/* Line 1806 of yacc.c  */
#line 1493 "basicParse.y"
    { addFloatOp(OP_PUSHFLOAT, (yyvsp[(1) - (1)].floatnum)); }
    break;

  case 377:

/* Line 1806 of yacc.c  */
#line 1494 "basicParse.y"
    { addIntOp(OP_PUSHINT, (yyvsp[(1) - (1)].number)); }
    break;

  case 378:

/* Line 1806 of yacc.c  */
#line 1495 "basicParse.y"
    { addIntOp(OP_ALEN, (yyvsp[(1) - (4)].number)); }
    break;

  case 379:

/* Line 1806 of yacc.c  */
#line 1496 "basicParse.y"
    { addIntOp(OP_ALEN, (yyvsp[(1) - (4)].number)); }
    break;

  case 380:

/* Line 1806 of yacc.c  */
#line 1497 "basicParse.y"
    { addIntOp(OP_ALENX, (yyvsp[(1) - (5)].number)); }
    break;

  case 381:

/* Line 1806 of yacc.c  */
#line 1498 "basicParse.y"
    { addIntOp(OP_ALENX, (yyvsp[(1) - (5)].number)); }
    break;

  case 382:

/* Line 1806 of yacc.c  */
#line 1499 "basicParse.y"
    { addIntOp(OP_ALENY, (yyvsp[(1) - (5)].number)); }
    break;

  case 383:

/* Line 1806 of yacc.c  */
#line 1500 "basicParse.y"
    { addIntOp(OP_ALENY, (yyvsp[(1) - (5)].number)); }
    break;

  case 384:

/* Line 1806 of yacc.c  */
#line 1501 "basicParse.y"
    { addIntOp(OP_DEREF, (yyvsp[(1) - (4)].number)); }
    break;

  case 385:

/* Line 1806 of yacc.c  */
#line 1502 "basicParse.y"
    {
		// a[n]++
		addOp(OP_STACKDUP);
		addIntOp(OP_DEREF, (yyvsp[(1) - (5)].number));
		addOp(OP_STACKSWAP);
		addOp(OP_STACKDUP);
		addIntOp(OP_DEREF, (yyvsp[(1) - (5)].number));
		addIntOp(OP_PUSHINT,1);
		addOp(OP_ADD);
		addIntOp(OP_ARRAYASSIGN, (yyvsp[(1) - (5)].number));
	}
    break;

  case 386:

/* Line 1806 of yacc.c  */
#line 1513 "basicParse.y"
    {
		// a[n]--
		addOp(OP_STACKDUP);
		addIntOp(OP_DEREF, (yyvsp[(1) - (5)].number));
		addOp(OP_STACKSWAP);
		addOp(OP_STACKDUP);
		addIntOp(OP_DEREF, (yyvsp[(1) - (5)].number));
		addIntOp(OP_PUSHINT,1);
		addOp(OP_SUB);
		addIntOp(OP_ARRAYASSIGN, (yyvsp[(1) - (5)].number));
	}
    break;

  case 387:

/* Line 1806 of yacc.c  */
#line 1524 "basicParse.y"
    {
		// ++a[n]
		addOp(OP_STACKDUP);
		addOp(OP_STACKDUP);
		addIntOp(OP_DEREF, (yyvsp[(2) - (5)].number));
		addIntOp(OP_PUSHINT,1);
		addOp(OP_ADD);
		addIntOp(OP_ARRAYASSIGN, (yyvsp[(2) - (5)].number));
		addIntOp(OP_DEREF, (yyvsp[(2) - (5)].number));
	}
    break;

  case 388:

/* Line 1806 of yacc.c  */
#line 1534 "basicParse.y"
    {
		// --a[n]
		addOp(OP_STACKDUP);
		addOp(OP_STACKDUP);
		addIntOp(OP_DEREF, (yyvsp[(2) - (5)].number));
		addIntOp(OP_PUSHINT,1);
		addOp(OP_SUB);
		addIntOp(OP_ARRAYASSIGN, (yyvsp[(2) - (5)].number));
		addIntOp(OP_DEREF, (yyvsp[(2) - (5)].number));
	}
    break;

  case 389:

/* Line 1806 of yacc.c  */
#line 1544 "basicParse.y"
    { addIntOp(OP_DEREF2D, (yyvsp[(1) - (6)].number)); }
    break;

  case 390:

/* Line 1806 of yacc.c  */
#line 1545 "basicParse.y"
    {
		// a[b,c]++
		addOp(OP_STACKDUP2);
		addIntOp(OP_DEREF2D, (yyvsp[(1) - (7)].number));
		addOp(OP_STACKTOPTO2);
		addOp(OP_STACKDUP2);
		addIntOp(OP_DEREF2D, (yyvsp[(1) - (7)].number));
		addIntOp(OP_PUSHINT,1);
		addOp(OP_ADD);
		addIntOp(OP_ARRAYASSIGN2D, (yyvsp[(1) - (7)].number));
	}
    break;

  case 391:

/* Line 1806 of yacc.c  */
#line 1556 "basicParse.y"
    {
		// a[b,c]--
		addOp(OP_STACKDUP2);
		addIntOp(OP_DEREF2D, (yyvsp[(1) - (7)].number));
		addOp(OP_STACKTOPTO2);
		addOp(OP_STACKDUP2);
		addIntOp(OP_DEREF2D, (yyvsp[(1) - (7)].number));
		addIntOp(OP_PUSHINT,1);
		addOp(OP_SUB);
		addIntOp(OP_ARRAYASSIGN2D, (yyvsp[(1) - (7)].number));
	}
    break;

  case 392:

/* Line 1806 of yacc.c  */
#line 1567 "basicParse.y"
    {
		// ++a[b,c]
		addOp(OP_STACKDUP2);
		addOp(OP_STACKDUP2);
		addIntOp(OP_DEREF2D, (yyvsp[(2) - (7)].number));
		addIntOp(OP_PUSHINT,1);
		addOp(OP_ADD);
		addIntOp(OP_ARRAYASSIGN2D, (yyvsp[(2) - (7)].number));
		addIntOp(OP_DEREF2D, (yyvsp[(2) - (7)].number));
	}
    break;

  case 393:

/* Line 1806 of yacc.c  */
#line 1577 "basicParse.y"
    {
		// --a[b,c]
		addOp(OP_STACKDUP2);
		addOp(OP_STACKDUP2);
		addIntOp(OP_DEREF2D, (yyvsp[(2) - (7)].number));
		addIntOp(OP_PUSHINT,1);
		addOp(OP_SUB);
		addIntOp(OP_ARRAYASSIGN2D, (yyvsp[(2) - (7)].number));
		addIntOp(OP_DEREF2D, (yyvsp[(2) - (7)].number));
	}
    break;

  case 394:

/* Line 1806 of yacc.c  */
#line 1587 "basicParse.y"
    {
		// function call with arguments
		addIntOp(OP_GOSUB, (yyvsp[(1) - (4)].number));
	}
    break;

  case 395:

/* Line 1806 of yacc.c  */
#line 1591 "basicParse.y"
    {
		// function call without arguments
		addIntOp(OP_GOSUB, (yyvsp[(1) - (3)].number));
	}
    break;

  case 396:

/* Line 1806 of yacc.c  */
#line 1595 "basicParse.y"
    {
		if ((yyvsp[(1) - (1)].number) < 0) {
			return -1;
		} else {
			addIntOp(OP_PUSHVAR, (yyvsp[(1) - (1)].number));
		}
	}
    break;

  case 397:

/* Line 1806 of yacc.c  */
#line 1602 "basicParse.y"
    {
		addIntOp(OP_PUSHVAR,(yyvsp[(1) - (2)].number));
		addIntOp(OP_PUSHVAR,(yyvsp[(1) - (2)].number));
		addIntOp(OP_PUSHINT,1);
		addOp(OP_ADD);
		addIntOp(OP_NUMASSIGN, (yyvsp[(1) - (2)].number));
	}
    break;

  case 398:

/* Line 1806 of yacc.c  */
#line 1609 "basicParse.y"
    {
		addIntOp(OP_PUSHVAR,(yyvsp[(1) - (2)].number));
		addIntOp(OP_PUSHVAR,(yyvsp[(1) - (2)].number));
		addIntOp(OP_PUSHINT,1);
		addOp(OP_SUB);
		addIntOp(OP_NUMASSIGN, (yyvsp[(1) - (2)].number));
	}
    break;

  case 399:

/* Line 1806 of yacc.c  */
#line 1616 "basicParse.y"
    {
		addIntOp(OP_PUSHVAR,(yyvsp[(2) - (2)].number));
		addIntOp(OP_PUSHINT,1);
		addOp(OP_ADD);
		addIntOp(OP_NUMASSIGN, (yyvsp[(2) - (2)].number));
		addIntOp(OP_PUSHVAR,(yyvsp[(2) - (2)].number));
	}
    break;

  case 400:

/* Line 1806 of yacc.c  */
#line 1623 "basicParse.y"
    {
		addIntOp(OP_PUSHVAR,(yyvsp[(2) - (2)].number));
		addIntOp(OP_PUSHINT,1);
		addOp(OP_SUB);
		addIntOp(OP_NUMASSIGN, (yyvsp[(2) - (2)].number));
		addIntOp(OP_PUSHVAR,(yyvsp[(2) - (2)].number));
	}
    break;

  case 401:

/* Line 1806 of yacc.c  */
#line 1630 "basicParse.y"
    { addOp(OP_INT); }
    break;

  case 402:

/* Line 1806 of yacc.c  */
#line 1631 "basicParse.y"
    { addOp(OP_INT); }
    break;

  case 403:

/* Line 1806 of yacc.c  */
#line 1632 "basicParse.y"
    { addOp(OP_FLOAT); }
    break;

  case 404:

/* Line 1806 of yacc.c  */
#line 1633 "basicParse.y"
    { addOp(OP_FLOAT); }
    break;

  case 405:

/* Line 1806 of yacc.c  */
#line 1634 "basicParse.y"
    { addOp(OP_LENGTH); }
    break;

  case 406:

/* Line 1806 of yacc.c  */
#line 1635 "basicParse.y"
    { addOp(OP_ASC); }
    break;

  case 407:

/* Line 1806 of yacc.c  */
#line 1636 "basicParse.y"
    { addOp(OP_INSTR); }
    break;

  case 408:

/* Line 1806 of yacc.c  */
#line 1637 "basicParse.y"
    { addOp(OP_INSTR_S); }
    break;

  case 409:

/* Line 1806 of yacc.c  */
#line 1638 "basicParse.y"
    { addOp(OP_INSTR_SC); }
    break;

  case 410:

/* Line 1806 of yacc.c  */
#line 1639 "basicParse.y"
    { addOp(OP_INSTRX); }
    break;

  case 411:

/* Line 1806 of yacc.c  */
#line 1640 "basicParse.y"
    { addOp(OP_INSTRX_S); }
    break;

  case 412:

/* Line 1806 of yacc.c  */
#line 1641 "basicParse.y"
    { addOp(OP_CEIL); }
    break;

  case 413:

/* Line 1806 of yacc.c  */
#line 1642 "basicParse.y"
    { addOp(OP_FLOOR); }
    break;

  case 414:

/* Line 1806 of yacc.c  */
#line 1643 "basicParse.y"
    { addOp(OP_SIN); }
    break;

  case 415:

/* Line 1806 of yacc.c  */
#line 1644 "basicParse.y"
    { addOp(OP_COS); }
    break;

  case 416:

/* Line 1806 of yacc.c  */
#line 1645 "basicParse.y"
    { addOp(OP_TAN); }
    break;

  case 417:

/* Line 1806 of yacc.c  */
#line 1646 "basicParse.y"
    { addOp(OP_ASIN); }
    break;

  case 418:

/* Line 1806 of yacc.c  */
#line 1647 "basicParse.y"
    { addOp(OP_ACOS); }
    break;

  case 419:

/* Line 1806 of yacc.c  */
#line 1648 "basicParse.y"
    { addOp(OP_ATAN); }
    break;

  case 420:

/* Line 1806 of yacc.c  */
#line 1649 "basicParse.y"
    { addOp(OP_DEGREES); }
    break;

  case 421:

/* Line 1806 of yacc.c  */
#line 1650 "basicParse.y"
    { addOp(OP_RADIANS); }
    break;

  case 422:

/* Line 1806 of yacc.c  */
#line 1651 "basicParse.y"
    { addOp(OP_LOG); }
    break;

  case 423:

/* Line 1806 of yacc.c  */
#line 1652 "basicParse.y"
    { addOp(OP_LOGTEN); }
    break;

  case 424:

/* Line 1806 of yacc.c  */
#line 1653 "basicParse.y"
    { addOp(OP_SQR); }
    break;

  case 425:

/* Line 1806 of yacc.c  */
#line 1654 "basicParse.y"
    { addOp(OP_EXP); }
    break;

  case 426:

/* Line 1806 of yacc.c  */
#line 1655 "basicParse.y"
    { addOp(OP_ABS); }
    break;

  case 427:

/* Line 1806 of yacc.c  */
#line 1656 "basicParse.y"
    { addOp(OP_RAND); }
    break;

  case 428:

/* Line 1806 of yacc.c  */
#line 1657 "basicParse.y"
    { addOp(OP_RAND); }
    break;

  case 429:

/* Line 1806 of yacc.c  */
#line 1658 "basicParse.y"
    { addFloatOp(OP_PUSHFLOAT, 3.14159265); }
    break;

  case 430:

/* Line 1806 of yacc.c  */
#line 1659 "basicParse.y"
    { addFloatOp(OP_PUSHFLOAT, 3.14159265); }
    break;

  case 431:

/* Line 1806 of yacc.c  */
#line 1660 "basicParse.y"
    { addIntOp(OP_PUSHINT, 1); }
    break;

  case 432:

/* Line 1806 of yacc.c  */
#line 1661 "basicParse.y"
    { addIntOp(OP_PUSHINT, 1); }
    break;

  case 433:

/* Line 1806 of yacc.c  */
#line 1662 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); }
    break;

  case 434:

/* Line 1806 of yacc.c  */
#line 1663 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); }
    break;

  case 435:

/* Line 1806 of yacc.c  */
#line 1664 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_EOF); }
    break;

  case 436:

/* Line 1806 of yacc.c  */
#line 1665 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_EOF); }
    break;

  case 437:

/* Line 1806 of yacc.c  */
#line 1666 "basicParse.y"
    { addOp(OP_EOF); }
    break;

  case 438:

/* Line 1806 of yacc.c  */
#line 1667 "basicParse.y"
    { addOp(OP_EXISTS); }
    break;

  case 439:

/* Line 1806 of yacc.c  */
#line 1668 "basicParse.y"
    { addOp(OP_YEAR); }
    break;

  case 440:

/* Line 1806 of yacc.c  */
#line 1669 "basicParse.y"
    { addOp(OP_YEAR); }
    break;

  case 441:

/* Line 1806 of yacc.c  */
#line 1670 "basicParse.y"
    { addOp(OP_MONTH); }
    break;

  case 442:

/* Line 1806 of yacc.c  */
#line 1671 "basicParse.y"
    { addOp(OP_MONTH); }
    break;

  case 443:

/* Line 1806 of yacc.c  */
#line 1672 "basicParse.y"
    { addOp(OP_DAY); }
    break;

  case 444:

/* Line 1806 of yacc.c  */
#line 1673 "basicParse.y"
    { addOp(OP_DAY); }
    break;

  case 445:

/* Line 1806 of yacc.c  */
#line 1674 "basicParse.y"
    { addOp(OP_HOUR); }
    break;

  case 446:

/* Line 1806 of yacc.c  */
#line 1675 "basicParse.y"
    { addOp(OP_HOUR); }
    break;

  case 447:

/* Line 1806 of yacc.c  */
#line 1676 "basicParse.y"
    { addOp(OP_MINUTE); }
    break;

  case 448:

/* Line 1806 of yacc.c  */
#line 1677 "basicParse.y"
    { addOp(OP_MINUTE); }
    break;

  case 449:

/* Line 1806 of yacc.c  */
#line 1678 "basicParse.y"
    { addOp(OP_SECOND); }
    break;

  case 450:

/* Line 1806 of yacc.c  */
#line 1679 "basicParse.y"
    { addOp(OP_SECOND); }
    break;

  case 451:

/* Line 1806 of yacc.c  */
#line 1680 "basicParse.y"
    { addOp(OP_GRAPHWIDTH); }
    break;

  case 452:

/* Line 1806 of yacc.c  */
#line 1681 "basicParse.y"
    { addOp(OP_GRAPHWIDTH); }
    break;

  case 453:

/* Line 1806 of yacc.c  */
#line 1682 "basicParse.y"
    { addOp(OP_GRAPHHEIGHT); }
    break;

  case 454:

/* Line 1806 of yacc.c  */
#line 1683 "basicParse.y"
    { addOp(OP_GRAPHHEIGHT); }
    break;

  case 455:

/* Line 1806 of yacc.c  */
#line 1684 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_SIZE); }
    break;

  case 456:

/* Line 1806 of yacc.c  */
#line 1685 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_SIZE); }
    break;

  case 457:

/* Line 1806 of yacc.c  */
#line 1686 "basicParse.y"
    { addOp(OP_SIZE); }
    break;

  case 458:

/* Line 1806 of yacc.c  */
#line 1687 "basicParse.y"
    { addOp(OP_KEY); }
    break;

  case 459:

/* Line 1806 of yacc.c  */
#line 1688 "basicParse.y"
    { addOp(OP_KEY); }
    break;

  case 460:

/* Line 1806 of yacc.c  */
#line 1689 "basicParse.y"
    { addOp(OP_MOUSEX); }
    break;

  case 461:

/* Line 1806 of yacc.c  */
#line 1690 "basicParse.y"
    { addOp(OP_MOUSEX); }
    break;

  case 462:

/* Line 1806 of yacc.c  */
#line 1691 "basicParse.y"
    { addOp(OP_MOUSEY); }
    break;

  case 463:

/* Line 1806 of yacc.c  */
#line 1692 "basicParse.y"
    { addOp(OP_MOUSEY); }
    break;

  case 464:

/* Line 1806 of yacc.c  */
#line 1693 "basicParse.y"
    { addOp(OP_MOUSEB); }
    break;

  case 465:

/* Line 1806 of yacc.c  */
#line 1694 "basicParse.y"
    { addOp(OP_MOUSEB); }
    break;

  case 466:

/* Line 1806 of yacc.c  */
#line 1695 "basicParse.y"
    { addOp(OP_CLICKX); }
    break;

  case 467:

/* Line 1806 of yacc.c  */
#line 1696 "basicParse.y"
    { addOp(OP_CLICKX); }
    break;

  case 468:

/* Line 1806 of yacc.c  */
#line 1697 "basicParse.y"
    { addOp(OP_CLICKY); }
    break;

  case 469:

/* Line 1806 of yacc.c  */
#line 1698 "basicParse.y"
    { addOp(OP_CLICKY); }
    break;

  case 470:

/* Line 1806 of yacc.c  */
#line 1699 "basicParse.y"
    { addOp(OP_CLICKB); }
    break;

  case 471:

/* Line 1806 of yacc.c  */
#line 1700 "basicParse.y"
    { addOp(OP_CLICKB); }
    break;

  case 472:

/* Line 1806 of yacc.c  */
#line 1701 "basicParse.y"
    { addIntOp(OP_PUSHINT, -1); }
    break;

  case 473:

/* Line 1806 of yacc.c  */
#line 1702 "basicParse.y"
    { addIntOp(OP_PUSHINT, -1); }
    break;

  case 474:

/* Line 1806 of yacc.c  */
#line 1703 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x000000); }
    break;

  case 475:

/* Line 1806 of yacc.c  */
#line 1704 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x000000); }
    break;

  case 476:

/* Line 1806 of yacc.c  */
#line 1705 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0xf8f8f8); }
    break;

  case 477:

/* Line 1806 of yacc.c  */
#line 1706 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0xf8f8f8); }
    break;

  case 478:

/* Line 1806 of yacc.c  */
#line 1707 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0xff0000); }
    break;

  case 479:

/* Line 1806 of yacc.c  */
#line 1708 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0xff0000); }
    break;

  case 480:

/* Line 1806 of yacc.c  */
#line 1709 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x800000); }
    break;

  case 481:

/* Line 1806 of yacc.c  */
#line 1710 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x800000); }
    break;

  case 482:

/* Line 1806 of yacc.c  */
#line 1711 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x00ff00); }
    break;

  case 483:

/* Line 1806 of yacc.c  */
#line 1712 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x00ff00); }
    break;

  case 484:

/* Line 1806 of yacc.c  */
#line 1713 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x008000); }
    break;

  case 485:

/* Line 1806 of yacc.c  */
#line 1714 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x008000); }
    break;

  case 486:

/* Line 1806 of yacc.c  */
#line 1715 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x0000ff); }
    break;

  case 487:

/* Line 1806 of yacc.c  */
#line 1716 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x0000ff); }
    break;

  case 488:

/* Line 1806 of yacc.c  */
#line 1717 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x000080); }
    break;

  case 489:

/* Line 1806 of yacc.c  */
#line 1718 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x000080); }
    break;

  case 490:

/* Line 1806 of yacc.c  */
#line 1719 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x00ffff); }
    break;

  case 491:

/* Line 1806 of yacc.c  */
#line 1720 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x00ffff); }
    break;

  case 492:

/* Line 1806 of yacc.c  */
#line 1721 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x008080); }
    break;

  case 493:

/* Line 1806 of yacc.c  */
#line 1722 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x008080); }
    break;

  case 494:

/* Line 1806 of yacc.c  */
#line 1723 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0xff00ff); }
    break;

  case 495:

/* Line 1806 of yacc.c  */
#line 1724 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0xff00ff); }
    break;

  case 496:

/* Line 1806 of yacc.c  */
#line 1725 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x800080); }
    break;

  case 497:

/* Line 1806 of yacc.c  */
#line 1726 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x800080); }
    break;

  case 498:

/* Line 1806 of yacc.c  */
#line 1727 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0xffff00); }
    break;

  case 499:

/* Line 1806 of yacc.c  */
#line 1728 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0xffff00); }
    break;

  case 500:

/* Line 1806 of yacc.c  */
#line 1729 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x808000); }
    break;

  case 501:

/* Line 1806 of yacc.c  */
#line 1730 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x808000); }
    break;

  case 502:

/* Line 1806 of yacc.c  */
#line 1731 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0xff6600); }
    break;

  case 503:

/* Line 1806 of yacc.c  */
#line 1732 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0xff6600); }
    break;

  case 504:

/* Line 1806 of yacc.c  */
#line 1733 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0xaa3300); }
    break;

  case 505:

/* Line 1806 of yacc.c  */
#line 1734 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0xaa3300); }
    break;

  case 506:

/* Line 1806 of yacc.c  */
#line 1735 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0xa4a4a4); }
    break;

  case 507:

/* Line 1806 of yacc.c  */
#line 1736 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0xa4a4a4); }
    break;

  case 508:

/* Line 1806 of yacc.c  */
#line 1737 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x808080); }
    break;

  case 509:

/* Line 1806 of yacc.c  */
#line 1738 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0x808080); }
    break;

  case 510:

/* Line 1806 of yacc.c  */
#line 1739 "basicParse.y"
    { addOp(OP_PIXEL); }
    break;

  case 511:

/* Line 1806 of yacc.c  */
#line 1740 "basicParse.y"
    { addOp(OP_RGB); }
    break;

  case 512:

/* Line 1806 of yacc.c  */
#line 1741 "basicParse.y"
    { addOp(OP_GETCOLOR); }
    break;

  case 513:

/* Line 1806 of yacc.c  */
#line 1742 "basicParse.y"
    { addOp(OP_GETCOLOR); }
    break;

  case 514:

/* Line 1806 of yacc.c  */
#line 1743 "basicParse.y"
    { addExtendedOp(OP_SPRITECOLLIDE); }
    break;

  case 515:

/* Line 1806 of yacc.c  */
#line 1744 "basicParse.y"
    { addExtendedOp(OP_SPRITEX); }
    break;

  case 516:

/* Line 1806 of yacc.c  */
#line 1745 "basicParse.y"
    { addExtendedOp(OP_SPRITEY); }
    break;

  case 517:

/* Line 1806 of yacc.c  */
#line 1746 "basicParse.y"
    { addExtendedOp(OP_SPRITEH); }
    break;

  case 518:

/* Line 1806 of yacc.c  */
#line 1747 "basicParse.y"
    { addExtendedOp(OP_SPRITEW); }
    break;

  case 519:

/* Line 1806 of yacc.c  */
#line 1748 "basicParse.y"
    { addExtendedOp(OP_SPRITEV); }
    break;

  case 520:

/* Line 1806 of yacc.c  */
#line 1749 "basicParse.y"
    { addExtendedOp(OP_DBROW); }
    break;

  case 521:

/* Line 1806 of yacc.c  */
#line 1750 "basicParse.y"
    { addExtendedOp(OP_DBINT); }
    break;

  case 522:

/* Line 1806 of yacc.c  */
#line 1751 "basicParse.y"
    { addExtendedOp(OP_DBFLOAT); }
    break;

  case 523:

/* Line 1806 of yacc.c  */
#line 1752 "basicParse.y"
    { addExtendedOp(OP_LASTERROR); }
    break;

  case 524:

/* Line 1806 of yacc.c  */
#line 1753 "basicParse.y"
    { addExtendedOp(OP_LASTERROR); }
    break;

  case 525:

/* Line 1806 of yacc.c  */
#line 1754 "basicParse.y"
    { addExtendedOp(OP_LASTERRORLINE); }
    break;

  case 526:

/* Line 1806 of yacc.c  */
#line 1755 "basicParse.y"
    { addExtendedOp(OP_LASTERRORLINE); }
    break;

  case 527:

/* Line 1806 of yacc.c  */
#line 1756 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addExtendedOp(OP_NETDATA); }
    break;

  case 528:

/* Line 1806 of yacc.c  */
#line 1757 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addExtendedOp(OP_NETDATA); }
    break;

  case 529:

/* Line 1806 of yacc.c  */
#line 1758 "basicParse.y"
    { addExtendedOp(OP_NETDATA); }
    break;

  case 530:

/* Line 1806 of yacc.c  */
#line 1759 "basicParse.y"
    { addExtendedOp(OP_PORTIN); }
    break;

  case 531:

/* Line 1806 of yacc.c  */
#line 1760 "basicParse.y"
    { addExtendedOp(OP_COUNT); }
    break;

  case 532:

/* Line 1806 of yacc.c  */
#line 1761 "basicParse.y"
    { addExtendedOp(OP_COUNT_C); }
    break;

  case 533:

/* Line 1806 of yacc.c  */
#line 1762 "basicParse.y"
    { addExtendedOp(OP_COUNTX); }
    break;

  case 534:

/* Line 1806 of yacc.c  */
#line 1763 "basicParse.y"
    { addExtendedOp(OP_OSTYPE); }
    break;

  case 535:

/* Line 1806 of yacc.c  */
#line 1764 "basicParse.y"
    { addExtendedOp(OP_OSTYPE); }
    break;

  case 536:

/* Line 1806 of yacc.c  */
#line 1765 "basicParse.y"
    { addExtendedOp(OP_MSEC); }
    break;

  case 537:

/* Line 1806 of yacc.c  */
#line 1766 "basicParse.y"
    { addExtendedOp(OP_MSEC); }
    break;

  case 538:

/* Line 1806 of yacc.c  */
#line 1767 "basicParse.y"
    { addExtendedOp(OP_TEXTWIDTH); }
    break;

  case 539:

/* Line 1806 of yacc.c  */
#line 1768 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_READBYTE); }
    break;

  case 540:

/* Line 1806 of yacc.c  */
#line 1769 "basicParse.y"
    { addOp(OP_READBYTE); }
    break;

  case 541:

/* Line 1806 of yacc.c  */
#line 1770 "basicParse.y"
    { addIntOp(OP_PUSHVARREF, (yyvsp[(3) - (4)].number)); }
    break;

  case 542:

/* Line 1806 of yacc.c  */
#line 1771 "basicParse.y"
    { addIntOp(OP_PUSHVARREFSTR, (yyvsp[(3) - (4)].number)); }
    break;

  case 543:

/* Line 1806 of yacc.c  */
#line 1777 "basicParse.y"
    { (yyval.string) = (yyvsp[(2) - (3)].string); }
    break;

  case 544:

/* Line 1806 of yacc.c  */
#line 1778 "basicParse.y"
    { addOp(OP_CONCAT); }
    break;

  case 545:

/* Line 1806 of yacc.c  */
#line 1779 "basicParse.y"
    { addOp(OP_CONCAT); }
    break;

  case 546:

/* Line 1806 of yacc.c  */
#line 1780 "basicParse.y"
    { addOp(OP_CONCAT); }
    break;

  case 547:

/* Line 1806 of yacc.c  */
#line 1781 "basicParse.y"
    { addStringOp(OP_PUSHSTRING, (yyvsp[(1) - (1)].string)); }
    break;

  case 548:

/* Line 1806 of yacc.c  */
#line 1782 "basicParse.y"
    { addIntOp(OP_DEREF, (yyvsp[(1) - (4)].number)); }
    break;

  case 549:

/* Line 1806 of yacc.c  */
#line 1783 "basicParse.y"
    { addIntOp(OP_DEREF2D, (yyvsp[(1) - (6)].number)); }
    break;

  case 550:

/* Line 1806 of yacc.c  */
#line 1784 "basicParse.y"
    { addIntOp(OP_GOSUB, (yyvsp[(1) - (4)].number)); }
    break;

  case 551:

/* Line 1806 of yacc.c  */
#line 1785 "basicParse.y"
    { addIntOp(OP_GOSUB, (yyvsp[(1) - (3)].number)); }
    break;

  case 552:

/* Line 1806 of yacc.c  */
#line 1787 "basicParse.y"
    {
		if ((yyvsp[(1) - (1)].number) < 0) {
			return -1;
		} else {
			addIntOp(OP_PUSHVAR, (yyvsp[(1) - (1)].number));
		}
	}
    break;

  case 553:

/* Line 1806 of yacc.c  */
#line 1794 "basicParse.y"
    { addOp(OP_CHR); }
    break;

  case 554:

/* Line 1806 of yacc.c  */
#line 1795 "basicParse.y"
    { addOp(OP_STRING); }
    break;

  case 555:

/* Line 1806 of yacc.c  */
#line 1796 "basicParse.y"
    { addOp(OP_UPPER); }
    break;

  case 556:

/* Line 1806 of yacc.c  */
#line 1797 "basicParse.y"
    { addOp(OP_LOWER); }
    break;

  case 557:

/* Line 1806 of yacc.c  */
#line 1798 "basicParse.y"
    { addOp(OP_MID); }
    break;

  case 558:

/* Line 1806 of yacc.c  */
#line 1799 "basicParse.y"
    { addOp(OP_LEFT); }
    break;

  case 559:

/* Line 1806 of yacc.c  */
#line 1800 "basicParse.y"
    { addOp(OP_RIGHT); }
    break;

  case 560:

/* Line 1806 of yacc.c  */
#line 1801 "basicParse.y"
    { addOp(OP_GETSLICE); }
    break;

  case 561:

/* Line 1806 of yacc.c  */
#line 1802 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_READ); }
    break;

  case 562:

/* Line 1806 of yacc.c  */
#line 1803 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_READ); }
    break;

  case 563:

/* Line 1806 of yacc.c  */
#line 1804 "basicParse.y"
    { addOp(OP_READ); }
    break;

  case 564:

/* Line 1806 of yacc.c  */
#line 1805 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_READLINE); }
    break;

  case 565:

/* Line 1806 of yacc.c  */
#line 1806 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addOp(OP_READLINE); }
    break;

  case 566:

/* Line 1806 of yacc.c  */
#line 1807 "basicParse.y"
    { addOp(OP_READLINE); }
    break;

  case 567:

/* Line 1806 of yacc.c  */
#line 1808 "basicParse.y"
    { addExtendedOp(OP_CURRENTDIR); }
    break;

  case 568:

/* Line 1806 of yacc.c  */
#line 1809 "basicParse.y"
    { addExtendedOp(OP_CURRENTDIR); }
    break;

  case 569:

/* Line 1806 of yacc.c  */
#line 1810 "basicParse.y"
    { addExtendedOp(OP_DBSTRING); }
    break;

  case 570:

/* Line 1806 of yacc.c  */
#line 1811 "basicParse.y"
    { addExtendedOp(OP_LASTERRORMESSAGE); }
    break;

  case 571:

/* Line 1806 of yacc.c  */
#line 1812 "basicParse.y"
    { addExtendedOp(OP_LASTERRORMESSAGE); }
    break;

  case 572:

/* Line 1806 of yacc.c  */
#line 1813 "basicParse.y"
    { addExtendedOp(OP_LASTERROREXTRA); }
    break;

  case 573:

/* Line 1806 of yacc.c  */
#line 1814 "basicParse.y"
    { addExtendedOp(OP_LASTERROREXTRA); }
    break;

  case 574:

/* Line 1806 of yacc.c  */
#line 1815 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addExtendedOp(OP_NETREAD); }
    break;

  case 575:

/* Line 1806 of yacc.c  */
#line 1816 "basicParse.y"
    { addIntOp(OP_PUSHINT, 0); addExtendedOp(OP_NETREAD); }
    break;

  case 576:

/* Line 1806 of yacc.c  */
#line 1817 "basicParse.y"
    { addExtendedOp(OP_NETREAD); }
    break;

  case 577:

/* Line 1806 of yacc.c  */
#line 1818 "basicParse.y"
    { addExtendedOp(OP_NETADDRESS); }
    break;

  case 578:

/* Line 1806 of yacc.c  */
#line 1819 "basicParse.y"
    { addExtendedOp(OP_NETADDRESS); }
    break;

  case 579:

/* Line 1806 of yacc.c  */
#line 1820 "basicParse.y"
    { addExtendedOp(OP_MD5); }
    break;

  case 580:

/* Line 1806 of yacc.c  */
#line 1821 "basicParse.y"
    { addExtendedOp(OP_GETSETTING); }
    break;

  case 581:

/* Line 1806 of yacc.c  */
#line 1822 "basicParse.y"
    { addExtendedOp(OP_DIR); }
    break;

  case 582:

/* Line 1806 of yacc.c  */
#line 1823 "basicParse.y"
    { addStringOp(OP_PUSHSTRING, ""); addExtendedOp(OP_DIR); }
    break;

  case 583:

/* Line 1806 of yacc.c  */
#line 1824 "basicParse.y"
    { addExtendedOp(OP_REPLACE); }
    break;

  case 584:

/* Line 1806 of yacc.c  */
#line 1825 "basicParse.y"
    { addExtendedOp(OP_REPLACE_C); }
    break;

  case 585:

/* Line 1806 of yacc.c  */
#line 1826 "basicParse.y"
    { addExtendedOp(OP_REPLACEX); }
    break;

  case 586:

/* Line 1806 of yacc.c  */
#line 1827 "basicParse.y"
    {  addStringOp(OP_PUSHSTRING, ""); addIntOp(OP_IMPLODE, (yyvsp[(3) - (4)].number)); }
    break;

  case 587:

/* Line 1806 of yacc.c  */
#line 1828 "basicParse.y"
    {  addIntOp(OP_IMPLODE, (yyvsp[(3) - (6)].number)); }
    break;

  case 588:

/* Line 1806 of yacc.c  */
#line 1829 "basicParse.y"
    {  addStringOp(OP_PUSHSTRING, ""); addIntOp(OP_IMPLODE, (yyvsp[(3) - (4)].number)); }
    break;

  case 589:

/* Line 1806 of yacc.c  */
#line 1830 "basicParse.y"
    {  addIntOp(OP_IMPLODE, (yyvsp[(3) - (6)].number)); }
    break;



/* Line 1806 of yacc.c  */
#line 11252 "basicParse.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 1834 "basicParse.y"


int
yyerror(const char *msg) {
	errorcode = COMPERR_SYNTAX;
	if (yytext[0] == '\n') { linenumber--; } // error happened on previous line
	return -1;
}

